'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:29 pm'!
Object subclass: #Model
	instanceVariableNames: 'dependents '
	classVariableNames: 'WindowActiveOnFirstClick UseColorfulWindows '
	poolDictionaries: ''
	category: 'Kernel-Models'!
Model subclass: #ListChooser
	instanceVariableNames: 'window fullList selectedItems searchText searchMorph title listMorph index realIndex buttonBar builder addAllowed result selectedIndex items dialogMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!
PBColorPreferenceView subclass: #PBWindowColorPreferenceView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '51Deprecated-PreferenceBrowser'!
Model subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classIndex classesSelected failedList failedSelected errorList errorSelected lastUpdate result previousRun categoryPattern classPattern '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnitGUI'!
Object subclass: #WindowColorRegistry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: '51Deprecated-System-Support'!
Object subclass: #WindowColorSpec
	instanceVariableNames: 'classSymbol wording brightColor pastelColor normalColor helpMessage'
	classVariableNames: ''
	poolDictionaries: ''
	category: '51Deprecated-System-Support'!

!Object methodsFor: '*51Deprecated' stamp: 'mt 7/2/2016 11:40'!
defaultBackgroundColor
	
	self deprecated: 'Implement #uniformWindowColor and #customWindowColor in your model.'.
	^ Color veryVeryLightGray! !


!Model methodsFor: 'morphic ui' stamp: 'mt 7/2/2016 12:00'!
applyUserInterfaceTheme

	self dependents do: [:ea |
		ea isSystemWindow ifTrue: [
			ea refreshWindowColor]].! !

!Model methodsFor: 'morphic ui' stamp: 'mt 7/2/2016 11:58'!
canApplyUserInterfaceTheme
	^ self dependents notEmpty! !

!Model methodsFor: 'morphic ui' stamp: 'mt 7/10/2016 12:11'!
defaultBackgroundColor

	self flag: #remove. "Use #windowColorToUse"
	^ self windowColorToUse! !

!Model methodsFor: 'morphic ui' stamp: 'mt 7/9/2016 08:51'!
defaultWindowColor

	^ self uniformWindowColor! !

!Model methodsFor: 'morphic ui' stamp: 'mt 7/2/2016 11:21'!
uniformWindowColor

	^ self userInterfaceTheme uniformWindowColor ifNil: [Color veryVeryLightGray]! !

!Model methodsFor: 'morphic ui' stamp: 'mt 7/10/2016 12:14'!
windowColorToUse

	^ Color colorFrom: (self class useColorfulWindows
		ifTrue: [self userInterfaceTheme customWindowColor ifNil: [self defaultWindowColor]]
		ifFalse: [self uniformWindowColor])! !


!DualChangeSorter methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.719 g: 0.9 b: 0.9)! !


!MCTool methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.65 g: 0.691 b: 0.876)! !


!Morph methodsFor: 'e-toy support' stamp: 'mt 7/2/2016 11:48'!
embeddedInMorphicWindowLabeled: labelString
	| window |
	window := (SystemWindow labelled: labelString) model: nil.
	window setStripeColorsFrom: Color white.
	window addMorph: self frame: (0@0 extent: 1@1).
	^ window! !


!CornerGripMorph class methodsFor: 'handle settings' stamp: 'mt 7/2/2016 13:28'!
activeColor
	<preference: 'Corner Grip highlight color'
		category: 'colors'
		description: 'The highlight-color of window corners'
		type: #Color>
	^(self activeForm colorAt: 24@24) alpha:  1! !

!CornerGripMorph class methodsFor: 'handle settings' stamp: 'mt 7/2/2016 13:28'!
passiveColor
	<preference: 'Corner Grip color'
		category: 'colors'
		description: 'The default color of window corners'
		type: #Color>
	^(self passiveForm colorAt: 24@24) alpha:  1! !


!Model class methodsFor: 'preferences' stamp: 'mt 7/2/2016 11:56'!
themeProperties

	^ {
		{ #uniformWindowColor. 'Colors'. 'The color to be used when all windows should have the same color' }.
		{ #customWindowColor. 'Colors'. 'The color to be used when all windows can have their own color' }.
	}! !

!Model class methodsFor: 'preferences' stamp: 'mt 7/10/2016 11:54'!
useColorfulWindows
	<preference: 'Use colorful windows'
		categoryList: #(Morphic windows)
		description: 'When true, windows have colors specific to their kind.'
		type: #Boolean>
	^UseColorfulWindows ifNil:[true]! !

!Model class methodsFor: 'preferences' stamp: 'mt 7/10/2016 12:16'!
useColorfulWindows: aBoolean

	UseColorfulWindows = aBoolean ifTrue: [^ self].
	UseColorfulWindows := aBoolean.

	(Smalltalk classNamed: #SystemWindow) ifNotNil: [:c | c refreshAllWindows].
	(Smalltalk classNamed: #TheWorldMainDockingBar) ifNotNil: [:c | c updateInstances].! !


!PreferenceBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.671 g: 0.9 b: 0.9)! !


!PreferenceBrowser class methodsFor: 'class initialization' stamp: 'mt 7/3/2016 10:08'!
initialize
	self
		registerInOpenMenu;
		registerInFlaps! !


!PreferenceView methodsFor: 'user interface' stamp: 'mt 7/2/2016 11:53'!
tearOffButton
	"Hand the user a button the can control this"

	| aButton |
	aButton := self representativeButtonWithColor: Color white inPanel: nil.
	aButton borderWidth: 1; borderColor:  Color black; useRoundedCorners.
	aButton openInHand! !


!PBWindowColorPreferenceView methodsFor: 'initialization' stamp: 'mt 7/2/2016 12:58'!
initialize
	super initialize.
	self addActionTitled: 'Bright' target: Preferences selector: #yourself arguments: {} balloonText: 'Use standard bright colors for all windows' translated.
	self addActionTitled: 'Pastel' target: Preferences selector: #yourself arguments: {} balloonText: 'Use standard pastel colors for all windows' translated.	
	self addActionTitled: 'Gray' target: Preferences selector: #yourself arguments: {} balloonText: 'Use gray backgrounds for all standard windows' translated.! !


!Preferences class methodsFor: '*51Deprecated-window colors' stamp: 'mt 7/3/2016 10:17'!
setWindowColorFor: modelSymbol to: incomingColor
	
	| aColor |
	self deprecated: 'Configure UI themes directly.'.
	aColor := incomingColor asNontranslucentColor.
	(aColor = ColorPickerMorph perniciousBorderColor or: [aColor = Color black]) 
		ifTrue: [^ self].
	UserInterfaceTheme set: #customWindowColor for: modelSymbol to: aColor.	! !

!Preferences class methodsFor: '*51Deprecated-window colors' stamp: 'mt 7/3/2016 10:21'!
uniformWindowColor

	self deprecated: 'Use Model >> #uniformWindowColor.'.
	^Color veryVeryLightGray! !

!Preferences class methodsFor: '*51Deprecated-window colors' stamp: 'mt 7/3/2016 10:15'!
windowColorFor: aModelClassName
	
	| classToCheck |
	self deprecated: 'Use Model >> #customWindowColor'.	
	classToCheck := Smalltalk at: aModelClassName.
	^ (UserInterfaceTheme current get: #customWindowColor for: classToCheck)
		ifNil: [(UserInterfaceTheme current get: #uniformWindowColor for: classToCheck)
			ifNil: [Color veryVeryLightGray]]! !

!Preferences class methodsFor: '*51Deprecated-window colors' stamp: 'mt 7/3/2016 10:19'!
windowColorTable
	"Answer a list of WindowColorSpec objects, one for each tool to be represented in the window-color panel"
	
	self deprecated: 'Consult current UI theme.'.
	^ {}! !


!SMLoaderPlus methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.801 g: 0.801 b: 0.614)! !


!SMLoaderPlus class methodsFor: 'class initialization' stamp: 'mt 7/2/2016 12:37'!
initialize
	"Hook us up in the world menu."
	"self initialize"
	Smalltalk
		at: #ToolBuilder
		ifPresent:
			[ : tb | self registerInFlapsRegistry.
			(TheWorldMenu respondsTo: #registerOpenCommand:) ifTrue:
				[ | oldCmds |
				oldCmds := TheWorldMenu registry select:
					[ : cmd | cmd first includesSubstring: 'Package Loader' ].
				oldCmds do:
					[ : cmd | TheWorldMenu unregisterOpenCommand: cmd first ].
				TheWorldMenu registerOpenCommand: {self openMenuString. 
					{self. 
					#open}} ] ].
	DefaultFilters := OrderedCollection new.
	DefaultCategoriesToFilterIds := OrderedCollection new! !


!ScriptingDomain methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.91 g: 0.91 b: 0.91)! !


!SmallLandColorTheme methodsFor: 'applying' stamp: 'mt 7/2/2016 13:00'!
apply

	""
	super apply.
	""
	self updateTopProject.
	self updateFlaps.
	self updateWorldMainDockingBar! !


!StandardToolSet class methodsFor: 'class initialization' stamp: 'mt 7/2/2016 12:41'!
initialize
	ToolSet register: self.! !


!StringHolder methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.9 g: 0.9 b: 0.719)! !


!Browser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.764 g: 0.9 b: 0.63)! !


!ChangeList methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.719 g: 0.9 b: 0.9)! !


!ChangeSorter methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.719 g: 0.9 b: 0.9)! !


!ChatNotes methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 1 g: 0.7 b: 0.8)! !


!Debugger methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.9 g: 0.719 b: 0.719)! !


!FileContentsBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.7 g: 0.7 b: 0.508)! !


!FileList methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.65 g: 0.65 b: 0.65)! !


!MessageSet methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.719 g: 0.9 b: 0.9)! !


!Lexicon methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.79 g: 0.9 b: 0.79)! !


!InstanceBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.726 g: 0.9 b: 0.9)! !


!MessageNames methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.639 g: 0.9 b: 0.497)! !


!PackagePaneBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.9 g: 0.9 b: 0.63)! !


!PluggableFileList methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ Color lightYellow! !


!SMReleaseBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.801 g: 0.801 b: 0.614)! !


!SelectorBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.45 g: 0.9 b: 0.9)! !


!SystemWindow methodsFor: 'initialization' stamp: 'mt 7/25/2016 15:50'!
initializeLabelArea
	"Initialize the label area (titlebar) for the window."
	
	labelString ifNil: [labelString := 'Untitled Window'].
	label := StringMorph new contents: labelString.
			"Add collapse box so #labelHeight will work"
			collapseBox := self createCollapseBox.
			stripes := Array
						with: (RectangleMorph newBounds: bounds)
						with: (RectangleMorph newBounds: bounds).
			"see extent:"
			self addLabelArea.
			self setLabelWidgetAllowance.
			self addCloseBox.
			self class moveMenuButtonRight 
				ifTrue: [self addLabel. self addMenuControl]
				ifFalse: [self addMenuControl. self addLabel].
			self addExpandBox.
			labelArea addMorphBack: collapseBox.
			self setFramesForLabelArea.
			Preferences noviceMode
				ifTrue: [closeBox
						ifNotNil: [closeBox setBalloonText: 'close window'].
					menuBox
						ifNotNil: [menuBox setBalloonText: 'window menu'].
					collapseBox
						ifNotNil: [collapseBox setBalloonText: 'collapse/expand window']].
! !

!SystemWindow methodsFor: 'initialization' stamp: 'mt 7/25/2016 15:50'!
setDefaultParameters

	Preferences menuAppearance3d ifTrue: [
		self addDropShadow.
		self hasDropShadow: self isKeyWindow. "maybe turn off again"].
	
	self borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]).
	label font: (self userInterfaceTheme titleFont ifNil: [TextStyle defaultFont]).! !

!SystemWindow methodsFor: 'user interface' stamp: 'mt 7/10/2016 11:56'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self
		setDefaultParameters;
		refreshWindowColor.

	self isLookingFocused
		ifTrue: [self lookUnfocused; lookFocused]
		ifFalse: [self lookFocused; lookUnfocused].! !

!SystemWindow methodsFor: 'focus' stamp: 'mt 7/9/2016 11:42'!
lookFocused

	"Optimize performance."
	self isLookingFocused ifTrue: [^ self].
	self isLookingFocused: true.

	label ifNotNil: [ label color: (self userInterfaceTheme focusedLabelColor ifNil: [Color black]) ].
	
	(self isKeyWindow or: [self class windowTitleActiveOnFirstClick])
		ifTrue: [self undimWindowButtons].
		
	self paneColorToUse in: [ : col |
		self
			 setStripeColorsFrom: col ;
			 adoptPaneColor: col].! !

!SystemWindow methodsFor: 'focus' stamp: 'mt 7/9/2016 11:43'!
lookUnfocused

	"Optimize performance."
	self isLookingFocused ifFalse: [^ self].
	self isLookingFocused: false.

	label ifNotNil: [ label color: (self userInterfaceTheme unfocusedLabelColor ifNil: [Color darkGray]) ].
	self dimWindowButtons.
	self paneColorToUseWhenNotActive in: [ : col |
		self
			 setStripeColorsFrom: col ;
			 adoptPaneColor: col ]! !

!SystemWindow methodsFor: 'colors' stamp: 'mt 7/26/2016 08:04'!
gradientWithColor: aColor

	| gradient cc |
	cc := aColor adjustSaturation: -0.08 brightness: 0.4.
	gradient := GradientFillStyle ramp: {
		0.0 -> (self isKeyWindow ifTrue: [cc muchLighter] ifFalse: [cc]). 
		0.25 -> (aColor mixed: 0.5 with: cc). 
		1.0 -> aColor.
	}.
	gradient origin: self topLeft.
	gradient direction: 0 @ self labelHeight.
	^gradient! !

!SystemWindow methodsFor: 'colors' stamp: 'mt 7/10/2016 12:20'!
paneColor
	| cc |
	(cc := self valueOfProperty: #paneColor) ifNotNil: [^cc].
	model notNil ifTrue: [cc := model windowColorToUse].
	cc ifNil: [cc := paneMorphs isEmptyOrNil ifFalse: [paneMorphs first color]].
	cc ifNil: [cc := self defaultColor].
	self paneColor: cc.
	^cc! !

!SystemWindow methodsFor: 'colors' stamp: 'mt 7/9/2016 11:41'!
paneColorToUseWhenNotActive

	^ (self userInterfaceTheme unfocusedWindowColorModifier ifNil: [ [:color | color darker] ])
		value: self paneColorToUse! !

!SystemWindow methodsFor: 'colors' stamp: 'mt 7/25/2016 15:45'!
setStripeColorsFrom: paneColor 
	"Set the stripe color based on the given paneColor"

	labelArea ifNotNil: [labelArea color: Color transparent].
	self updateBoxesColor: paneColor.
	stripes ifNil: [^self].

	self borderColor: ((self userInterfaceTheme borderColorModifier ifNil: [ [:c | c adjustBrightness: -0.3] ])
							value: paneColor).

	self class gradientWindow
		ifTrue: [self fillStyle: (self gradientWithColor: paneColor)]
		ifFalse: [self color: paneColor].! !


!ArchiveViewer methodsFor: 'accessing' stamp: 'mt 7/2/2016 11:36'!
defaultBackgroundColor

	^ Color veryVeryLightGray! !

!ArchiveViewer methodsFor: 'accessing' stamp: 'mt 7/2/2016 11:51'!
defaultColor

	^ Color veryVeryLightGray! !


!SMLoader methodsFor: 'user interface' stamp: 'mt 7/10/2016 12:13'!
defaultColor

	^ self defaultWindowColor! !

!SMLoader methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.801 g: 0.801 b: 0.614)! !


!SystemWindow class methodsFor: 'preferences' stamp: 'mt 7/25/2016 15:48'!
themeProperties

	^ super themeProperties, {	
		{ #borderColorModifier. 'Colors'. 'How to derive the borderColor from the window color.' }.
		{ #borderWidth. 'Borders'. 'Width of the menu''s border.' }.
		{ #titleFont. 'Fonts'. 'Font of the window title.' }.
		
		{ #unfocusedWindowColorModifier. 'Colors'. 'A block with one argument that modifies a color to look unfocused.' }.
		{ #unfocusedLabelColor. 'Colors'. 'Window title color when window has no focus.'}.
		{ #focusedLabelColor. 'Colors'. 'Window title color when window has focus.'}.
	}! !


!SMLoader class methodsFor: 'class initialization' stamp: 'mt 7/2/2016 12:37'!
initialize
	"Hook us up in the world menu."
	"self initialize"
	Smalltalk
		at: #ToolBuilder
		ifAbsent: [self registerInFlapsRegistry.
			(TheWorldMenu respondsTo: #registerOpenCommand:)
				ifTrue: [| oldCmds |
					oldCmds := TheWorldMenu registry select: [:cmd | cmd first includesSubstring: 'Package Loader'].
					oldCmds do: [:cmd | TheWorldMenu unregisterOpenCommand: cmd first].
					TheWorldMenu registerOpenCommand: {self openMenuString. {self. #open}}]].
	DefaultFilters := OrderedCollection new.
	DefaultCategoriesToFilterIds := OrderedCollection new! !


!TestRunner methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.9 g: 0.576 b: 0.09)! !


!TheWorldMainDockingBar methodsFor: 'private' stamp: 'mt 7/2/2016 12:43'!
colorIcon: aColor

	"Guess if 'uniform window colors' are used and avoid all icons to be just gray"
	(aColor = (UserInterfaceTheme current get: #uniformWindowColor for: Model) or: [Preferences tinyDisplay]) ifTrue: [ ^nil ].
	^(aColor iconOrThumbnailOfSize: 14)
		borderWidth: 3 color: MenuMorph menuColor muchDarker;
		borderWidth: 2 color: Color transparent! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
browserMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Browser' translated;
			help: 'Open a browser' translated;
			icon: (self colorIcon: Browser basicNew windowColorToUse);
			target: StandardToolSet;
			selector: #openClassBrowser ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
dualChangeSorterMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Dual Change Sorter' translated;
			help: 'Open a Dual Change Sorter' translated;
			icon: (self colorIcon: ChangeSorter basicNew windowColorToUse);
			target: DualChangeSorter;
			selector: #open ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
fileListMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'File List' translated;
			help: 'Open a file list' translated;
			icon: (self colorIcon: FileList basicNew windowColorToUse);
			target: StandardToolSet;
			selector: #openFileList ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
methodFinderMenuItemOn: menu 

	menu addItem: [:item | 
		item 
			contents: 'Method Finder' translated;
			help: 'Open the Method Finder' translated;
			icon: (self colorIcon: SelectorBrowser basicNew windowColorToUse);
			target: StandardToolSet;
			selector: #openSelectorBrowser]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
monticelloBrowserMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Monticello Browser' translated;
			help: 'Open a Monticello Browser' translated;
			icon: (self colorIcon: MCTool basicNew windowColorToUse);
			target: MCWorkingCopyBrowser;
			selector: #open ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
monticelloConfigurationsMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Monticello Configurations' translated;
			help: 'Open a Monticello Configurations Editor' translated;
			icon: (self colorIcon: MCConfigurationBrowser basicNew windowColorToUse);
			target: MCConfigurationBrowser;
			selector: #open ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:08'!
preferenceBrowserMenuItemOn: menu
	Smalltalk at: #PreferenceBrowser ifPresent:[:pb|
		menu addItem: [ :item |
			item
				contents: 'Preferences' translated;
				help: 'Open a Preferences Browser' translated;
				icon: (self colorIcon: pb basicNew windowColorToUse);
				target: pb;
				selector: #open ]
	].! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:09'!
processBrowserMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Process Browser' translated;
			help: 'Open a Process Browser' translated;
			icon: (self colorIcon: ProcessBrowser basicNew windowColorToUse);
			target: ProcessBrowser;
			selector: #open ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:09'!
simpleChangeSorterMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Simple Change Sorter' translated;
			help: 'Open a Change Sorter' translated;
			icon: (self colorIcon: ChangeSorter basicNew windowColorToUse);
			target: ChangeSorter;
			selector: #open ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:09'!
testRunnerMenuItemOn: menu
	Smalltalk at: #TestRunner ifPresent:[:aClass|
		menu addItem: [ :item |
			item
				contents: 'Test Runner' translated;
				help: 'Open the Test Runner' translated;
				icon: (self colorIcon: aClass basicNew windowColorToUse);
				target: aClass;
				selector: #open ]
	].! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:11'!
transcriptMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Transcript' translated;
			help: 'Open the Transcript' translated;
			icon: (self colorIcon: Transcript windowColorToUse);
			target: Transcript;
			selector: #open ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - tools' stamp: 'mt 7/10/2016 12:11'!
workspaceMenuItemOn: menu

	menu addItem: [ :item |
		item
			contents: 'Workspace' translated;
			help: 'Open a Workspace' translated;
			icon: (self colorIcon: Workspace basicNew windowColorToUse);
			target: StandardToolSet;
			selector: #openWorkspace ]! !


!TranscriptStream methodsFor: 'model protocol' stamp: 'mt 7/9/2016 11:02'!
applyUserInterfaceTheme

	self dependents do: [:ea |
		ea isSystemWindow ifTrue: [
			ea refreshWindowColor]].! !

!TranscriptStream methodsFor: 'model protocol' stamp: 'mt 7/10/2016 12:20'!
windowColorToUse

	^ Color colorFrom: (Model useColorfulWindows
		ifTrue: [self userInterfaceTheme customWindowColor ifNil: [Color r: 0.9 g: 0.75 b: 0.45]]
		ifFalse: [self userInterfaceTheme uniformWindowColor ifNil: [Color veryVeryLightGray]])! !


!TranscriptStream class methodsFor: 'preferences' stamp: 'mt 7/9/2016 11:04'!
themeProperties
	
	^ Model themeProperties! !


!VersionsBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.782 g: 0.677 b: 0.9)! !


!ClassCommentVersionsBrowser methodsFor: 'user interface' stamp: 'mt 7/9/2016 08:52'!
defaultWindowColor
	^ (Color r: 0.753 g: 0.677 b: 0.9)! !

ClassCommentVersionsBrowser class removeSelector: #windowColorSpecification!
VersionsBrowser class removeSelector: #windowColorSpecification!

!ClassCommentVersionsBrowser reorganize!
('basic function' diffedVersionContents reformulateList scanVersionsOf: updateListsAndCodeIn:)
('menu' compareToCurrentVersion listSelectionVersionsMenu: offerVersionsHelp)
('user interface' defaultWindowColor)
('misc' classCommentIndicated contentsSymbolQuints priorSourceOrNil selectedClass wantsPrettyDiffOption)
('contents' aboutToStyle:)
!

TranscriptStream class removeSelector: #windowColorSpecification!
TestRunner class removeSelector: #windowColorSpecification!
TestRunner removeSelector: #defaultBackgroundColor!
Model subclass: #TestRunner
	instanceVariableNames: 'categories categoriesSelected classes classIndex classesSelected failedList failedSelected errorList errorSelected lastUpdate result previousRun categoryPattern classPattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnitGUI'!
SMLoader initialize!
SMLoader class removeSelector: #windowColorSpecification!
SystemWindow removeSelector: #adoptPaneColor:!
SystemWindow removeSelector: #defaultBorderColor!
SystemWindow removeSelector: #defaultBorderWidth!
SystemWindow removeSelector: #defaultColor!

!SystemWindow reorganize!
('drawing' areasRemainingToFill: colorForInsets makeMeVisible wantsRoundedCorners)
('events' doFastFrameDrag: filterEvent:for: handleListenEvent: handleMouseDown: handleMouseUp: handlesMouseDown: handlesMouseOver: handlesMouseOverDragging: mouseDown: mouseEnter: mouseEnterDragging: mouseLeave: mouseLeaveDragging: paneTransition: secondaryPaneTransition:divider: startDragFromLabel: wantsHalo wantsToBeDroppedInto:)
('geometry' extent: justDroppedInto:event: labelRect paneMorphs panelRect position: removeMenuBox setPaneRectsFromBounds)
('initialization' addCloseBox addCornerGrips addExpandBox addKeyboardShortcuts addLabelArea addMenuControl addPaneSplitters applyModelExtent boxExtent createBox: createCloseBox createCollapseBox createExpandBox createMenuBox defaultBounds initialize initializeKeyboardShortcuts initializeLabelArea initializeWithLabel: maximumExtent maximumExtent: model: removeKeyboardShortcuts replaceBoxes setDefaultParameters setFramesForLabelArea)
('label' addLabel getRawLabel knownName label labelArea labelHeight labelWidgetAllowance relabel relabelEvent: setLabel: setLabelWidgetAllowance tryToRenameTo: update: widthOfFullLabelText)
('layout' assureLabelAreaVisible convertAlignment layoutBounds putLabelItemsInLabelArea)
('menu' addCustomMenuItems:hand: buildWindowMenu changeColor deleteCloseBox fullScreen fullScreenMaximumExtent makeClosable makeSecondTopmost makeUnclosable offerWindowMenu sendToBack setWindowColor takeOutOfWindow wantsYellowButtonMenu)
('object fileIn' convertToCurrentVersion:refStream:)
('open/close' anyOpenWindowLikeMe closeBoxHit delete initialExtent mustNotClose openAsIs openAsIsIn: openInWorld: openInWorld:extent: openInWorldExtent: postAcceptBrowseFor:)
('panes' addMorph:frame: addMorph:fullFrame: holdsTranscript paneMorphSatisfying: replacePane:with: setUpdatablePanesFrom: titleAndPaneText updatablePanes updateBox:color: updateBoxesColor:)
('resize/collapse' allowReframeHandles allowReframeHandles: collapse collapseOrExpand collapsedFrame contractToOriginalSize expand expandBoxHit expandToFullScreen fastFramingOn fullFrame getBoundsWithFlex getCollapsedFrame isCollapsed mouseLeaveEvent:fromPane: paneWithLongestSide:near: reframePanesAdjoining:along:to: setBoundsWithFlex: unexpandedFrame unexpandedFrame: wantsExpandBox)
('stepping' amendSteppingStatus stepAt: stepTime wantsSteps wantsStepsWhenCollapsed)
('user interface' applyUserInterfaceTheme)
('testing' isSystemWindow isWindowForModel: shouldDropOnMouseUp wantsToBeCachedByHand)
('top window' beKeyWindow beKeyWindowIfNeeded: comeToFront comeToFrontModally dimWindowButtons extantSketchEditor isKeyWindow undimWindowButtons updatePanesFromSubmorphs)
('*services-base' requestor topWindow)
('thumbnail' icon)
('polymorph' modalChild modalLockTo: modalOwner modalUnlockFrom: rememberedKeyboardFocus)
('*Etoys-support' isCandidateForAutomaticViewing)
('colors handling')
('*51Deprecated' activateAndForceLabelToShow activateWindow activeOnlyOnTop activeOnlyOnTop: adjustBorderUponActivationWhenLabeless adjustBorderUponDeactivationWhenLabeless bringBehind: setLabelFont:)
('focus' activate isActive isActive: isLookingFocused isLookingFocused: lockWindowDecorations lockWindowTitle lookFocused lookUnfocused passivate passivateIfNeeded unlockWindowDecorations unlockWindowTitle updateFocusLookAtHand updateFocusLookForKeyboardFocus windowDecorations)
('colors' existingPaneColor gradientWithColor: paneColor paneColor: paneColorToUse paneColorToUseWhenNotActive raisedColor refreshWindowColor restoreDefaultPaneColor setStripeColorsFrom: setWindowColor: updatePaneColors)
!

SelectorBrowser class removeSelector: #windowColorSpecification!
SMReleaseBrowser class removeSelector: #windowColorSpecification!
PackagePaneBrowser class removeSelector: #windowColorSpecification!
MessageNames class removeSelector: #windowColorSpecification!
InstanceBrowser class removeSelector: #windowColorSpecification!
Lexicon class removeSelector: #windowColorSpecification!
MessageSet class removeSelector: #windowColorSpecification!
FileList class removeSelector: #windowColorSpecification!
FileContentsBrowser class removeSelector: #windowColorSpecification!
Debugger class removeSelector: #windowColorSpecification!
ChangeSorter class removeSelector: #windowColorSpecification!
ChangeList class removeSelector: #windowColorSpecification!
Browser class removeSelector: #windowColorSpecification!
StringHolder class removeSelector: #windowColorSpecification!
PluggableFileList removeSelector: #defaultBackgroundColor!
ChatNotes removeSelector: #defaultBackgroundColor!
StandardToolSet initialize!
ScriptingDomain removeSelector: #defaultBackgroundColor!
SMLoaderPlus initialize!
SMLoaderPlus class removeSelector: #windowColorSpecification!
Preferences class removeSelector: #browserWindowColor!
Preferences class removeSelector: #changeListWindowColor!
Preferences class removeSelector: #changeSorterWindowColor!
Preferences class removeSelector: #checkForWindowColors!
Preferences class removeSelector: #classCommentVersionsBrowserWindowColor!
Preferences class removeSelector: #darkenStandardWindowPreferences!
Preferences class removeSelector: #debuggerWindowColor!
Preferences class removeSelector: #defaultWindowColor!
Preferences class removeSelector: #dualChangeSorterWindowColor!
Preferences class removeSelector: #fileContentsBrowserWindowColor!
Preferences class removeSelector: #fileListWindowColor!
Preferences class removeSelector: #installBrightWindowColors!
Preferences class removeSelector: #installNormalWindowColors!
Preferences class removeSelector: #installPastelWindowColors!
Preferences class removeSelector: #installUniformWindowColors!
Preferences class removeSelector: #installWindowColorsVia:!
Preferences class removeSelector: #instanceBrowserWindowColor!
Preferences class removeSelector: #lexiconWindowColor!
Preferences class removeSelector: #lightenStandardWindowPreferences!
Preferences class removeSelector: #messageListWindowColor!
Preferences class removeSelector: #messageNamesWindowColor!
Preferences class removeSelector: #methodFinderWindowColor!
Preferences class removeSelector: #monticelloToolWindowColor!
Preferences class removeSelector: #packageBrowserWindowColor!
Preferences class removeSelector: #packageLoaderWindowColor!
Preferences class removeSelector: #packageReleaseBrowserWindowColor!
Preferences class removeSelector: #preferenceBrowserWindowColor!
Preferences class removeSelector: #preferencesPanelWindowColor!
Preferences class removeSelector: #roundedWindowCorners!
Preferences class removeSelector: #testRunnerWindowColor!
Preferences class removeSelector: #transcriptWindowColor!
Preferences class removeSelector: #versionsBrowserWindowColor!
Preferences class removeSelector: #windowColorHelp!
Preferences class removeSelector: #windowColorPreferenceForClassNamed:!
Preferences class removeSelector: #workspaceWindowColor!
PreferenceBrowser initialize!
PreferenceBrowser class removeSelector: #registerWindowColor!
PreferenceBrowser class removeSelector: #windowColorSpecification!

!PreferenceBrowser class reorganize!
('class initialization' initialize registerInFlaps registerInOpenMenu unload unregisterFromFlaps unregisterFromOpenMenu)
('instance creation' open prototypicalToolWindow)
('*services-base' openForServices)
!

MCTool class removeSelector: #windowColorSpecification!
DualChangeSorter class removeSelector: #windowColorSpecification!
Object class removeSelector: #windowColorSpecification!
MCTool removeSelector: #defaultBackgroundColor!
Model subclass: #ListChooser
	instanceVariableNames: 'selectedIndex items searchText addAllowed result title listMorph dialogMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!
Object subclass: #Model
	instanceVariableNames: 'dependents'
	classVariableNames: 'UseColorfulWindows WindowActiveOnFirstClick'
	poolDictionaries: ''
	category: 'Kernel-Models'!
"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

Preferences allPreferences
	select: [:ea | ea name endsWith: #WindowColor]
	thenDo: [:ea | Preferences removePreference: ea name].
PBWindowColorPreferenceView unload.
WindowColorRegistry refresh.
TheWorldMainDockingBar updateInstances.!

