'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:26 pm'!
SHTextStyler subclass: #SHTextStylerST80
	instanceVariableNames: 'classOrMetaClass workspace font parser formatAssignments environment sourceMap processedSourceMap pixelHeight attributesByPixelHeight parseAMethod '
	classVariableNames: 'SubduedSyntaxHighlights SyntaxHighlightingAsYouType SyntaxHighlightingAsYouTypeAnsiAssignment SyntaxHighlightingAsYouTypeLeftArrowAssignment TextAttributesByPixelHeight '
	poolDictionaries: ''
	category: 'ShoutCore-Styling'!
SHTextStylerST80 class
	instanceVariableNames: 'styleTable textAttributesByPixelHeight '!

!PluggableTextMorphPlus methodsFor: 'updating' stamp: 'mt 7/24/2016 13:21'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.

	self styler ifNotNil: [:s | 
		s reset.
		self updateStyle].! !

!PluggableTextMorphPlus methodsFor: 'initialize' stamp: 'mt 7/3/2016 14:27'!
useDefaultStyler
	"This should be changed to a proper registry but as long as there is only shout this will do"
	
	(self userInterfaceTheme stylerClass ifNil: [Smalltalk at: #SHTextStylerST80])
		ifNotNil: [:stylerClass | self styler: (stylerClass new view: self)].! !


!PluggableTextMorphPlus class methodsFor: 'preferences' stamp: 'mt 7/25/2016 11:07'!
themeProperties

	^  super themeProperties, {
		{ #stylerClass. 'Editing'. 'The styler class you want to use for syntax highlighting' }.
		{ #balloonTextColor. 'Colors'. 'Color to use when drawing the balloon text on an empty text field.' }.
		{ #balloonTextFont. 'Fonts'. 'Font to use when drawing the balloon text on an empty text field.' }.
	}! !


!SHTextStylerST80 methodsFor: 'updating' stamp: 'mt 7/3/2016 14:31'!
applyUserInterfaceTheme
	"My dependents should take care of invalidating my caches and then ask me to style again. It is of no use to invalidate my caches right now because I have no idea when my dependents will ask me to style again."! !

!SHTextStylerST80 methodsFor: 'style table' stamp: 'mt 7/3/2016 12:28'!
attributesByPixelHeight

	^ attributesByPixelHeight ifNil: [
		attributesByPixelHeight := self attributesByPixelHeight: self pixelHeight]! !

!SHTextStylerST80 methodsFor: 'style table' stamp: 'mt 7/3/2016 14:01'!
attributesByPixelHeight: aNumber

	^ self class textAttributesByPixelHeight
		at: aNumber 
		ifAbsent: [
			self class
				textAttributesByPixelHeightAt: aNumber
				put: (self createTextAttributesForPixelHeight: aNumber)]! !

!SHTextStylerST80 methodsFor: 'style table' stamp: 'mt 7/3/2016 14:07'!
attributesFor: aSymbol

	^ self attributesByPixelHeight at: aSymbol ifAbsent: nil! !

!SHTextStylerST80 methodsFor: 'style table' stamp: 'mt 7/3/2016 14:07'!
createAttributeArrayForColor: aColorOrNil emphasis: anEmphasisOrArrayorNil font: aFontOrNil
	"Answer a new Array containing any non nil TextAttributes specified"

	| answer emphArray |
	answer := Array new.
	aColorOrNil ifNotNil: [answer := answer, {TextColor color: aColorOrNil}].
	anEmphasisOrArrayorNil ifNotNil: [
		emphArray := anEmphasisOrArrayorNil isArray 
			ifFalse: [{anEmphasisOrArrayorNil}] 
			ifTrue: [anEmphasisOrArrayorNil].
		answer := answer, emphArray].
	aFontOrNil ifNotNil: [
		answer := answer, {TextFontReference toFont: aFontOrNil}].
	^answer! !

!SHTextStylerST80 methodsFor: 'style table' stamp: 'mt 7/3/2016 14:59'!
createTextAttributesForPixelHeight: aNumber

	| result |	 
	result := IdentityDictionary new.
	result at: #default put: {}. "Required as fall-back for non-existing attributes."
	
	self class themeProperties do: [:each |
		| spec element emphasis font color |
		element := each first.
		spec := self userInterfaceTheme perform: element.
		spec isArray ifFalse: [spec := {spec}]. "Support color-only hints."
		
		color := spec first ifNotNil: [:colorSpec | Color colorFrom: colorSpec].
		emphasis := spec at: 2 ifAbsent:[nil].
		font := spec at: 3 ifAbsent: [nil].
		
		"Support for named text styles."
		font isString ifTrue: [
			| textStyle |
			textStyle := TextStyle named: font.
			font := textStyle ifNotNil: [textStyle fontOfSize: aNumber]].

		(self createAttributeArrayForColor: color emphasis: emphasis font: font)
			ifNotEmpty: [:attrArray | result at: element put: attrArray]].
	^ result
	! !

!SHTextStylerST80 methodsFor: 'initialize-release' stamp: 'mt 7/3/2016 15:16'!
reset

	attributesByPixelHeight := nil.! !


!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'mt 7/3/2016 15:19'!
applyUserInterfaceTheme

	self resetTextAttributesByPixelHeight.! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'mt 7/3/2016 14:36'!
canApplyThemeToInstances

	^ false! !

!SHTextStylerST80 class methodsFor: 'preferences' stamp: 'mt 7/3/2016 11:59'!
themeProperties

	^ {
		{ #default. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #invalid. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #excessCode. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #comment. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #unfinishedComment. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #'$'. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #character. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #integer. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #number. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #-. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #symbol. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #stringSymbol. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #literalArray. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #string. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #unfinishedString. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #assignment. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #ansiAssignment. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #literal. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #keyword. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #binary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #unary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #incompleteKeyword. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #incompleteBinary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #incompleteUnary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #undefinedKeyword. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #undefinedBinary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #undefinedUnary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #patternKeyword. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #patternBinary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #patternUnary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #self. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #super. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #true. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #false. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #nil. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #thisContext. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #return. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #patternArg. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #methodArg. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockPatternArg. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockArg. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #argument. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockArgColon. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis2. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis2. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis3. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis3. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis4. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis4. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis5. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis5. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis6. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis6. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftParenthesis7. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightParenthesis7. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart2. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd2. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart3. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd3. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart4. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd4. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart5. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd5. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart6. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd6. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockStart7. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockEnd7. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #arrayStart. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #arrayEnd. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #arrayStart1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #arrayEnd1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #byteArrayStart. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #byteArrayEnd. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #byteArrayStart1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #byteArrayEnd1. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #leftBrace. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #rightBrace. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #cascadeSeparator. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #statementSeparator. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #externalCallType. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #externalCallTypePointerIndicator. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #primitiveOrExternalCallStart. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #primitiveOrExternalCallEnd. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #methodTempBar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockTempBar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockArgsBar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #primitive. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #pragmaKeyword. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #pragmaUnary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #pragmaBinary. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #externalFunctionCallingConvention. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #module. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockTempVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #blockPatternTempVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #instVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #workspaceVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #undefinedIdentifier. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #incompleteIdentifier. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #tempVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #patternTempVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #poolConstant. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #classVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.
		{ #globalVar. 'Styling'. 'Specify color, emphasis, and font in a triple.' }.	
	}! !

!SHTextStylerST80 class methodsFor: '*51Deprecated' stamp: 'mt 7/3/2016 14:14'!
attributesByPixelHeight: aNumber

	self deprecated: 'Use UI themes.'.
	^self textAttributesByPixelHeight
		at: aNumber 
		ifAbsent: [Dictionary new]! !

!SHTextStylerST80 class methodsFor: '*51Deprecated' stamp: 'mt 7/3/2016 14:11'!
attributesFor: aSymbol pixelHeight: aNumber

	self deprecated: 'Use UI themes.'.
	^(self textAttributesByPixelHeight 
		at: aNumber 
		ifAbsent:[Dictionary new]) 
			at: aSymbol ifAbsent:[nil]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'mt 7/3/2016 14:18'!
resetTextAttributesByPixelHeight

	TextAttributesByPixelHeight := nil.! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'mt 7/3/2016 12:21'!
textAttributesByPixelHeight
	"A cache for text attributes used by all instances of text styler."
	^ TextAttributesByPixelHeight ifNil: [ TextAttributesByPixelHeight := Dictionary new ]! !

!SHTextStylerST80 class methodsFor: 'style table' stamp: 'mt 7/3/2016 12:23'!
textAttributesByPixelHeightAt: aNumber put: someTextAttributes
	"Thread-safety first."
	
	TextAttributesByPixelHeight := self textAttributesByPixelHeight copy
		at: aNumber put: someTextAttributes;
		yourself.
	^ someTextAttributes! !


!TextDiffBuilder methodsFor: 'creating patches' stamp: 'mt 7/9/2016 10:44'!
buildDisplayPatch

	| stream |
	stream := AttributedTextStream new.
	
	"Lazy initialize the text attributes cache."
	NormalTextAttributes ifNil: [NormalTextAttributes := self userInterfaceTheme normalTextAttributes
		ifNil: [{TextEmphasis normal}]].
	InsertTextAttributes ifNil: [InsertTextAttributes := self userInterfaceTheme insertTextAttributes
		ifNil: [{TextColor red}]].
	RemoveTextAttributes ifNil: [RemoveTextAttributes := self userInterfaceTheme removeTextAttributes
		ifNil: [{TextEmphasis struckOut. TextColor blue}]].
	
	self 
		patchSequenceDoIfMatch: [ :string |
			self print: string withAttributes: NormalTextAttributes on: stream ]
		ifInsert: [ :string |
			self print: string withAttributes: InsertTextAttributes on: stream ]
		ifRemove: [ :string |
			self print: string withAttributes: RemoveTextAttributes on: stream ].
	^stream contents! !

!TextDiffBuilder methodsFor: 'updating' stamp: 'mt 7/9/2016 10:46'!
applyUserInterfaceTheme
	"My class-side cache is invalidated there. My dependents have to invoke my services again."! !


!TextDiffBuilder class methodsFor: 'preferences' stamp: 'mt 7/9/2016 10:39'!
applyUserInterfaceTheme

	NormalTextAttributes := nil.
	InsertTextAttributes := nil.
	RemoveTextAttributes := nil.! !

!TextDiffBuilder class methodsFor: 'preferences' stamp: 'mt 7/9/2016 10:44'!
canApplyThemeToInstances
	^ false! !

!TextDiffBuilder class methodsFor: 'preferences' stamp: 'mt 7/9/2016 10:38'!
themeProperties

	^ {
		{ #insertTextAttributes. 'Styling'. 'Text attributes to use when a patch was inserted.' }.
		{ #normalTextAttributes. 'Styling'. 'Text attributes to use when text did not change.' }.
		{ #removeTextAttributes. 'Styling'. 'Text attributes to use when a patch was removed.' }.
	}! !

TextDiffBuilder class removeSelector: #initialize!
TextDiffBuilder class removeSelector: #initializeTextAttributes!
SHTextStylerST80 class removeSelector: #attributeArrayForColor:emphasis:font:!
SHTextStylerST80 class removeSelector: #chooseDefaultStyleTable!
SHTextStylerST80 class removeSelector: #defaultStyleTable!
SHTextStylerST80 class removeSelector: #initialTextAttributesForPixelHeight:!
SHTextStylerST80 class removeSelector: #initialize!
SHTextStylerST80 class removeSelector: #styleTable!
SHTextStylerST80 class removeSelector: #styleTable:!
SHTextStylerST80 class removeSelector: #subduedStyleTable!
SHTextStylerST80 class removeSelector: #subduedSyntaxHighlights!
SHTextStylerST80 class removeSelector: #subduedSyntaxHighlights:!
SHTextStylerST80 class
	instanceVariableNames: ''!

!SHTextStylerST80 class reorganize!
('preferences' ansiAssignmentPreferenceChanged applyUserInterfaceTheme canApplyThemeToInstances leftArrowAssignmentPreferenceChanged syntaxHighlightingAsYouType syntaxHighlightingAsYouType: syntaxHighlightingAsYouTypeAnsiAssignment syntaxHighlightingAsYouTypeAnsiAssignment: syntaxHighlightingAsYouTypeLeftArrowAssignment syntaxHighlightingAsYouTypeLeftArrowAssignment: themeProperties)
('*51Deprecated' attributesByPixelHeight: attributesFor:pixelHeight:)
('style table' resetTextAttributesByPixelHeight textAttributesByPixelHeight textAttributesByPixelHeightAt:put:)
!

SHTextStyler subclass: #SHTextStylerST80
	instanceVariableNames: 'classOrMetaClass workspace font parser formatAssignments environment sourceMap processedSourceMap pixelHeight attributesByPixelHeight parseAMethod'
	classVariableNames: 'SyntaxHighlightingAsYouType SyntaxHighlightingAsYouTypeAnsiAssignment SyntaxHighlightingAsYouTypeLeftArrowAssignment TextAttributesByPixelHeight'
	poolDictionaries: ''
	category: 'ShoutCore-Styling'!

!SHTextStylerST80 reorganize!
('updating' applyUserInterfaceTheme)
('style table' attributesByPixelHeight attributesByPixelHeight: attributesFor: createAttributeArrayForColor:emphasis:font: createTextAttributesForPixelHeight:)
('private' convertAssignmentsToAnsi: convertAssignmentsToLeftArrow: parseableSourceCodeTemplate pixelHeight privateFormat: privateStyle: rangesIn:setWorkspace: replaceStringForRangesWithType:with:in: setAttributesIn:fromRanges:)
('accessing' classOrMetaClass: environment: font: formatAssignments: parseAMethod: sourceMap: workspace:)
('initialize-release' initialize reset)
('converting' unstyledTextFrom:)
('copying' veryDeepInner:)
!

