'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:24 pm'!
Morph subclass: #DialogWindow
	instanceVariableNames: 'titleMorph messageMorph paneMorph buttonRow result selectedButton cancelButton timeout preferredPosition keyMap exclusive'
	classVariableNames: 'GradientDialog RoundedDialogCorners UseWiggleAnimation'
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!DialogWindow commentStamp: '<historical>' prior: 0!
A DialogBoxMorph is Morph used in simple yes/no/confirm dialogs. Strongly modal.!

DialogWindow subclass: #FillInTheBlankMorph
	instanceVariableNames: 'response done textPane responseUponCancel '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!
Model subclass: #ListChooser
	instanceVariableNames: 'selectedIndex items searchText addAllowed result title listMorph dialogMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!
Morph subclass: #NewBalloonMorph
	instanceVariableNames: 'balloonOwner textMorph maximumWidth orientation hasTail '
	classVariableNames: 'DefaultBalloonTextColor UseNewBalloonMorph '
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
PluggableCompositeSpec subclass: #PluggableDialogSpec
	instanceVariableNames: 'title message extent buttons closeAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Kernel'!
DialogWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'statusValue getChildrenSelector getButtonsSelector model closeDialogSelector getMessageSelector getTitleSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!
PluggableCompositeSpec subclass: #PluggableWindowSpec
	instanceVariableNames: 'label extent closeAction isDialog multiWindowStyle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Kernel'!
Morph subclass: #SystemProgressBarMorph
	instanceVariableNames: 'barSize barColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
Morph subclass: #SystemProgressMorph
	instanceVariableNames: 'activeSlots bars labels font lock requestedPosition textColor '
	classVariableNames: 'BarHeight BarWidth Inset UniqueInstance '
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
DialogWindow subclass: #UserDialogBoxMorph
	instanceVariableNames: 'labelMorph value savedLabel '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/13/2016 19:41'!
addPaneMorph: aMorph

	self paneMorph addMorphBack: aMorph.! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/22/2016 15:52'!
createAcceptButton

	^ self
		createButton: 'Accept' translated
		value: true
		color: (self userInterfaceTheme okColor ifNil: [Color r: 0.49 g: 0.749 b: 0.49])! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/13/2016 17:59'!
createButton: buttonLabel

	^ self
		createButton: buttonLabel
		value: self buttonRow submorphs size + 1
		color: self defaultButtonColor! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/13/2016 17:54'!
createButton: buttonLabel value: buttonValue

	^ self
		createButton: buttonLabel
		value: buttonValue
		color: self defaultButtonColor! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/21/2016 09:16'!
createButton: buttonLabel value: buttonValue color: buttonColor

	| button |
	button := PluggableButtonMorphPlus new
		label: buttonLabel ;
		action: [ self closeDialog: buttonValue ] ;
		setProperty: #normalColor toValue: buttonColor ;
		setProperty: #normalLabel toValue: buttonLabel ;
		hResizing: #rigid;
		vResizing: #rigid;
		yourself.
	
	self deselectButton: button.
	buttonRow addMorphBack: button.
	self updateButtonExtent.
	
	^ button! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/22/2016 15:53'!
createCancelButton

	^ cancelButton := self
		createButton: 'Cancel' translated
		value: false
		color: (self userInterfaceTheme cancelColor ifNil: [Color r: 1 g: 0.6 b: 0.588])! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/13/2016 20:14'!
createCancelButton: label value: result

	^ cancelButton := self
		createButton: label
		value: result! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/13/2016 18:13'!
registerKeyboardShortcutFor: button 
	"Take the first alpha-numeric character that is not already used as a shortcut, and use it as a shortcut."
	
	(button valueOfProperty: #normalLabel) asString in: [:normalLabel | normalLabel do: [:char |
		char isAlphaNumeric ifTrue: [ keyMap
				at: char asLowercase
				ifPresent: []
				ifAbsent: [ 
					button label: ('{1} ({2})' format: {normalLabel. char}).
					^ keyMap at: char asLowercase put: button ] ] ] ]! !

!DialogWindow methodsFor: 'constructing' stamp: 'mt 7/13/2016 18:47'!
registerKeyboardShortcuts
	
	self buttons do: [:ea | self registerKeyboardShortcutFor: ea].! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/13/2016 17:40'!
cancelDialog

	self cancelButton
		ifNil: [self closeDialog: nil]
		ifNotNil: [:btn | btn performAction].	! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/13/2016 18:01'!
closeDialog

	self selectedButton
		ifNil: [self closeDialog: nil]
		ifNotNil: [:btn | btn performAction].	! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/13/2016 17:37'!
closeDialog: returnValue
	result := returnValue.
	self delete.! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/25/2016 09:59'!
exploreInvocation

	| result context |
	self exclusive: false. "We want to explore."

	result := OrderedCollection new.
	context := thisContext.
	
	[context method selector = #getUserResponse]
		whileFalse: [context := context sender].
	
	[context sender] whileNotNil: [
		result add: context method.
		context := context sender].
	result add: context method.

	result explore.! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/19/2016 13:50'!
flash
	"Flash me"
	Beeper beepPrimitive.

	self class useWiggleAnimation ifTrue: [
		#(-2 4 -6 8 -4) do: [:i |
			self left: self left + i.
			self refreshWorld.
		] separatedBy: [(Delay forMilliseconds: 50) wait]
	] ifFalse: [
		1 to: 2 do:[:i|
			self color: Color black.
			self world doOneCycleNow.
			(Delay forMilliseconds: 50) wait.
			self color: Color white.
			self world doOneCycleNow.
			(Delay forMilliseconds: 50) wait] ]! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/19/2016 14:05'!
getUserResponse

	| hand world |
	(ProvideAnswerNotification signal: self title asString) ifNotNil: [:answer| ^ answer].

	self message ifEmpty: [messageMorph delete]. "Do not waste space."
	self paneMorph submorphs ifEmpty: [self paneMorph delete]. "Do not waste space."

	hand := self currentHand.
	world := self currentWorld.
	
	self fullBounds.
	self center: preferredPosition.
	self bounds: (self bounds translatedToBeWithin: world bounds).
	self openInWorld: world.
	
	hand keyboardFocus in: [:priorKeyboardFocus |
		hand mouseFocus in: [:priorMouseFocus |
			self exclusive ifTrue: [hand newMouseFocus: self].
			hand newKeyboardFocus: self.

			[self isInWorld] whileTrue:[world doOneSubCycle].

			hand newKeyboardFocus: priorKeyboardFocus.
			self exclusive ifTrue: [
				hand newMouseFocus: priorMouseFocus]]].

	^ result! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/21/2016 09:16'!
getUserResponseAfter: seconds

	timeout := seconds + 1.
	
	self ensureSelectedButton.	
	self step.
	self updateButtonExtent.
	
	^ self getUserResponse! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/13/2016 20:02'!
getUserResponseAtHand

	^ self getUserResponseAtHand: ActiveHand! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/13/2016 21:00'!
getUserResponseAtHand: aHand

	self message ifEmpty: [messageMorph delete]. "Do not waste space."
	self paneMorph submorphs ifEmpty: [self paneMorph delete]. "Do not waste space."

	self moveSelectedButtonToHand: aHand.
	^ self getUserResponse! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/25/2016 09:55'!
offerDialogMenu

	| menu |
	menu := MenuMorph new defaultTarget: self.
	menu
		add: (exclusive == true ifTrue: ['<yes>'] ifFalse: ['<no>']), 'be modally exclusive' translated
		action: #toggleExclusive;
		addLine;
		add: 'explore dialog invocation' translated
		action: #exploreInvocation.
		
	menu popUpEvent: self currentEvent in: self world.
	
	[menu isInWorld] whileTrue: [self world doOneSubCycle].
	self exclusive ifTrue: [self activeHand newMouseFocus: self].! !

!DialogWindow methodsFor: 'running' stamp: 'mt 7/25/2016 09:43'!
toggleExclusive

	self exclusive: self exclusive not.! !

!DialogWindow methodsFor: 'selection' stamp: 'mt 7/22/2016 15:44'!
deselectButton: aButton

	aButton ifNil: [^ self].
	aButton offColor: (aButton valueOfProperty: #normalColor).
	aButton == selectedButton ifTrue: [selectedButton := nil].! !

!DialogWindow methodsFor: 'selection' stamp: 'mt 7/13/2016 19:51'!
ensureSelectedButton

	self selectedButton ifNil: [self selectButton: self buttons first].! !

!DialogWindow methodsFor: 'selection' stamp: 'mt 7/22/2016 15:44'!
selectButton: aButton

	| buttonColor |
	buttonColor :=  ((self userInterfaceTheme selectionModifier ifNil: [ [:c | c muchLighter] ]) value: (aButton valueOfProperty: #normalColor)).
	self deselectButton: selectedButton.
	aButton offColor: buttonColor.
	selectedButton := aButton.! !

!DialogWindow methodsFor: 'selection' stamp: 'mt 7/13/2016 18:34'!
selectNextButton

	self selectedButton ifNil: [^ self].
	self selectedButtonIndex: self selectedButtonIndex \\ self buttons size + 1.! !

!DialogWindow methodsFor: 'selection' stamp: 'mt 7/13/2016 18:43'!
selectPreviousButton

	self selectedButton ifNil: [^ self].
	self selectedButtonIndex: self selectedButtonIndex - 2 \\ self buttons size + 1.! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/21/2016 09:57'!
handleMouseUp: event

	super handleMouseUp: event.
	self exclusive ifTrue: [event hand newMouseFocus: self].! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/13/2016 12:21'!
handlesKeyboard: evt

	^true! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/13/2016 17:27'!
handlesMouseDown: evt 

	^ true! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/21/2016 10:05'!
keyStroke: evt
	| char |
	self stopAutoTrigger.
	char := evt keyCharacter.

	char = Character escape ifTrue: [ ^ self cancelDialog ].
	(char = Character cr or: [char = Character enter]) ifTrue: [ ^ self closeDialog ].

	((char = Character arrowLeft or: [char = Character arrowUp])
		or: [ evt shiftPressed and: [ char = Character tab ] ])
			ifTrue: [ ^ self selectPreviousButton ].
	((char = Character arrowRight or: [char = Character arrowDown])
		or: [ char = Character tab ])
			ifTrue: [ ^ self selectNextButton ].
			
	keyMap
		at: char asLowercase
		ifPresent: [ : foundButton | foundButton performAction ]
		ifAbsent: [ "do nothing" ].! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/13/2016 18:04'!
mouseDown: event

	self stopAutoTrigger.

	"Always bring me to the front since I am modal"
	self comeToFront.
	
	(self containsPoint: event position)
		ifFalse:[^ self flash].
	
	event hand 
		waitForClicksOrDrag: self 
		event: event 
		selectors: { nil. nil. nil. #startDrag: }
		threshold: HandMorph dragThreshold.! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/19/2016 13:02'!
mouseUp: event
	self stopAutoTrigger.
! !

!DialogWindow methodsFor: 'events' stamp: 'mt 7/13/2016 12:21'!
processFocusEvent: evt using: dispatcher

	^ dispatcher dispatchFocusEventFully: evt with: self! !

!DialogWindow methodsFor: 'position' stamp: 'mt 7/13/2016 20:03'!
moveSelectedButtonToHand: aHand
	"Just let the user confirm the selected button without having to reposition the mouse."
	
	self ensureSelectedButton.
	self moveTo: self fullBounds center + (aHand position - self selectedButton center).! !

!DialogWindow methodsFor: 'position' stamp: 'mt 7/13/2016 19:46'!
moveTo: position

	preferredPosition := position.! !

!DialogWindow methodsFor: 'position' stamp: 'mt 7/13/2016 17:06'!
moveToHand

	self moveToHand: self activeHand.! !

!DialogWindow methodsFor: 'position' stamp: 'mt 7/13/2016 20:01'!
moveToHand: aHand

	self moveTo: aHand position.! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/13/2016 20:54'!
createBody

	| body |
	body := Morph new
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		cellPositioning: #leftCenter;
		layoutInset: (10@5 corner: 10@10);
		cellInset: 5;
		color: Color transparent;
		yourself.
	body addAllMorphs: {self createMessage: ''. self createPane. self createButtonRow}.
	self addMorphBack: body.! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/21/2016 10:00'!
createButtonRow

	^ buttonRow := Morph new
		color: Color transparent;
		changeTableLayout;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #center;
		cellInset: 5;
		yourself! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/22/2016 10:53'!
createMessage: aString 
	
	messageMorph := aString asText asMorph lock.
	self setMessageParameters.	
	^ messageMorph! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/14/2016 08:38'!
createPane

	^ paneMorph := BorderedMorph new
		changeProportionalLayout;
		hResizing: #rigid;
		vResizing: #rigid;
		layoutInset: 0;
		color: Color transparent;
		borderWidth: 0;
		yourself.! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/25/2016 10:04'!
createTitle: aString 
	"Mimick behavior of MenuMorph title creation."
	
	| box closeButton menuButton |
	box := Morph new
		name: #title;
		changeTableLayout;
		listDirection: #leftToRight;
		listCentering: #justified;
		yourself.
	
	titleMorph := aString asText asMorph lock.

	closeButton := SystemWindowButton new
		color: Color transparent;
		target: self;
		extent: 12@12;
		actionSelector: #cancelDialog;
		balloonText: 'Cancel this dialog' translated;
		borderWidth: 0;
		labelGraphic: SystemWindow closeBoxImage;
		extent: SystemWindow closeBoxImage extent;
		yourself.

	menuButton := SystemWindowButton new
		color: Color transparent;
		target: self;
		actionSelector: #offerDialogMenu;
		balloonText: 'Dialog menu' translated;
		borderWidth: 0;
		labelGraphic: SystemWindow menuBoxImage;
		extent: SystemWindow menuBoxImage extent;
		yourself.
	
	box addAllMorphs: {closeButton. titleMorph. menuButton}.
	
	self addMorphBack: box.
	self setTitleParameters.
! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/14/2016 08:41'!
initialExtent

	^ 200@150! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/22/2016 15:58'!
initialize

	super initialize.
	
	self
		changeTableLayout;
		listDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		setProperty: #indicateKeyboardFocus toValue: #never.
	
	self createTitle: 'Dialog'.
	self createBody.
	
	self setDefaultParameters.
	
	keyMap := Dictionary new.
	exclusive := true.
	preferredPosition := ActiveWorld center.! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/25/2016 14:36'!
setDefaultParameters
	"change the receiver's appareance parameters"

	self
		color: (self userInterfaceTheme color ifNil: [Color white]);
		borderStyle: (self userInterfaceTheme borderStyle ifNil: [BorderStyle default]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color gray]);
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]);
		layoutInset: ((self class roundedDialogCorners and: [self class gradientDialog])
			"This check compensates a bug in balloon."
			ifTrue: [0] ifFalse: [self borderWidth negated asPoint]).

	Preferences menuAppearance3d ifTrue: [self addDropShadow].! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/22/2016 10:52'!
setMessageParameters
	
	messageMorph ifNotNil: [
		| fontToUse colorToUse |
		fontToUse := self userInterfaceTheme font ifNil: [TextStyle defaultFont].
		colorToUse := self userInterfaceTheme textColor ifNil: [Color black].
	
		messageMorph contents
			addAttribute: (TextFontReference toFont: fontToUse);
			addAttribute: (TextColor color: colorToUse).
		messageMorph releaseParagraph; changed].! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/25/2016 14:40'!
setTitleParameters

	(self submorphNamed: #title) ifNotNil: [:title |
		title
			fillStyle: (self class gradientDialog
				ifFalse: [SolidFillStyle color: (self userInterfaceTheme titleColor ifNil: [Color r: 0.658 g: 0.678 b: 0.78])]
				ifTrue: [self titleGradientFor: title from: (self userInterfaceTheme titleColor ifNil: [Color r: 0.658 g: 0.678 b: 0.78])]);
			borderStyle: (self userInterfaceTheme titleBorderStyle ifNil: [BorderStyle default]);
			borderColor: (self userInterfaceTheme titleBorderColor ifNil: [Color r: 0.6 g: 0.7 b: 1]);
			borderWidth: (self userInterfaceTheme titleBorderWidth ifNil: [0]);
			cornerStyle: (self wantsRoundedCorners ifTrue: [#rounded] ifFalse: [#square]);
			vResizing: #shrinkWrap;
			hResizing: #spaceFill;
			wrapCentering: #center;
			cellPositioning: #center;
			cellInset: 0;
			layoutInset: (5@3 corner: 5@ (2+(self wantsRoundedCorners ifFalse: [0] ifTrue: [self cornerRadius])))].
	
	titleMorph ifNotNil: [
		| fontToUse colorToUse |
		fontToUse := self userInterfaceTheme titleFont ifNil: [TextStyle defaultFont].
		colorToUse := self userInterfaceTheme titleTextColor ifNil: [Color black].
	
		titleMorph contents
			addAttribute: (TextFontReference toFont: fontToUse);
			addAttribute: (TextColor color: colorToUse).
		titleMorph releaseParagraph; changed].! !

!DialogWindow methodsFor: 'initialization' stamp: 'mt 7/25/2016 14:39'!
titleGradientFor: morph from: aColor

	| cc gradient |
	cc := aColor.
	gradient := GradientFillStyle ramp: {
		0.0 -> Color white. 
		0.15 ->(cc mixed: 0.5 with: Color white). 
		0.7 -> cc.
	}.
	gradient origin: morph topLeft.
	gradient direction: 0 @ (TextStyle defaultFont height + 10).
	^ gradient! !

!DialogWindow methodsFor: 'accessing - ui' stamp: 'mt 7/14/2016 09:44'!
buttonRowMorph
	^ buttonRow! !

!DialogWindow methodsFor: 'accessing - ui' stamp: 'mt 7/13/2016 12:21'!
buttons

	^buttonRow submorphs! !

!DialogWindow methodsFor: 'accessing - ui' stamp: 'mt 7/13/2016 17:40'!
cancelButton
	^ cancelButton! !

!DialogWindow methodsFor: 'accessing - ui' stamp: 'mt 7/13/2016 18:24'!
messageMorph
	^ messageMorph! !

!DialogWindow methodsFor: 'accessing - ui' stamp: 'mt 7/13/2016 18:24'!
paneMorph
	^ paneMorph! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 17:51'!
defaultButtonColor

	^  self userInterfaceTheme buttonColor ifNil: [(Color r: 0.658 g: 0.678 b: 0.78) twiceLighter]! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/19/2016 13:55'!
exclusive

	^ exclusive! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/25/2016 09:44'!
exclusive: aBoolean

	exclusive := aBoolean.
	
	exclusive
		ifTrue: [self activeHand newMouseFocus: self]
		ifFalse: [self activeHand releaseMouseFocus: self].! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 17:15'!
message
	^messageMorph contents! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/22/2016 10:53'!
message: aStringOrText

	messageMorph contents: aStringOrText.
	self setMessageParameters.! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 12:21'!
selectedButton
	^ selectedButton! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 17:24'!
selectedButton: aButton

	aButton
		ifNil: [self deselectButton: self selectedButton]
		ifNotNil: [self selectButton: aButton].! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 18:30'!
selectedButtonIndex
	
	^ self selectedButton
		ifNil: [0]
		ifNotNil: [:btn | self buttons indexOf: btn]! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 18:33'!
selectedButtonIndex: anInteger

	anInteger = 0 ifTrue: [^ self selectedButton: nil].
	self selectedButton: (self buttons at: anInteger).! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/13/2016 12:21'!
title
	^titleMorph contents! !

!DialogWindow methodsFor: 'accessing' stamp: 'mt 7/22/2016 10:45'!
title: aString

	titleMorph contents: aString asText.
	self setTitleParameters.! !

!DialogWindow methodsFor: 'dropping/grabbing' stamp: 'mt 7/25/2016 14:14'!
justDroppedInto: aMorph event: event

	"Restore drop shadow if necessary."
	self hasDropShadow: Preferences menuAppearance3d.

	self exclusive ifTrue: [
		"aggressively preserve focus"
		event hand newMouseFocus: self].! !

!DialogWindow methodsFor: 'dropping/grabbing' stamp: 'mt 7/13/2016 17:32'!
startDrag: event

	self hasDropShadow: false.
	event hand grabMorph: self.! !

!DialogWindow methodsFor: 'dropping/grabbing' stamp: 'mt 7/13/2016 12:21'!
wantsToBeDroppedInto: aMorph
	"Return true if it's okay to drop the receiver into aMorph"
	^aMorph isWorldMorph "only into worlds"! !

!DialogWindow methodsFor: 'updating' stamp: 'mt 7/26/2016 16:56'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self
		setDefaultParameters;
		setTitleParameters;
		setMessageParameters.
		
	"Update all buttons."
	selectedButton in: [:sb |
		self buttons do: [:ea |
			ea setProperty: #normalColor toValue: self defaultButtonColor.
			self deselectButton: ea].
		sb ifNotNil: [self selectButton: sb]].! !

!DialogWindow methodsFor: 'updating' stamp: 'mt 7/21/2016 09:18'!
update: aspect

	aspect == #buttons
		ifTrue: [self updateButtonExtent].
		
	^ super update: aspect! !

!DialogWindow methodsFor: 'updating' stamp: 'mt 7/21/2016 09:16'!
updateButtonExtent
	
	self updateButtonExtent: 20@10.! !

!DialogWindow methodsFor: 'updating' stamp: 'mt 7/22/2016 11:07'!
updateButtonExtent: margin

	"Update all button extents."
	(buttonRow submorphs collect: [:ea | ea minimumExtent]) max + margin in: [:preferredExtent |
		buttonRow submorphsDo: [:ea | ea extent: preferredExtent]].
	
	"See if horizontal button layout would be more appropriate."
	self flag: #magicNumber. "mt: Remove number with computation, maybe choose button font and 20 characters"
	(buttonRow submorphs collect: [:ea | ea fullBounds width]) sum > 400
		ifTrue: [buttonRow
					hResizing: #shrinkWrap;
					listDirection: #topToBottom;
					layoutInset: (buttonRow owner fullBounds width - (buttonRow owner layoutInset left*2) - buttonRow submorphs first fullBounds width // 2@0)]
		ifFalse: [buttonRow
					hResizing: #spaceFill;
					listDirection: #leftToRight;
					layoutInset: 0].! !

!DialogWindow methodsFor: 'stepping and presenter' stamp: 'mt 7/13/2016 19:02'!
step
	timeout ifNil: [^self].
	timeout = 0
		ifTrue: [
			self stopStepping.
			selectedButton performAction]
		ifFalse: [
			selectedButton label: ('{1} ({2})' format: {
				selectedButton valueOfProperty: #normalLabel.
				timeout}).
			timeout := timeout - 1]! !

!DialogWindow methodsFor: 'stepping and presenter' stamp: 'mt 7/13/2016 12:21'!
stepTime
	^1000! !

!DialogWindow methodsFor: 'stepping and presenter' stamp: 'mt 7/13/2016 18:47'!
stopAutoTrigger
	timeout ifNil: [^self].
	timeout := nil.
	self stopStepping.
	selectedButton label: (selectedButton valueOfProperty: #normalLabel). ! !

!DialogWindow methodsFor: 'drawing' stamp: 'mt 7/25/2016 14:36'!
drawOverlayOn: aCanvas

	| title inset |
	super drawOverlayOn: aCanvas.

	title := self submorphs first.

	self wantsRoundedCorners ifTrue: [
		inset := (self class roundedDialogCorners and: [self class gradientDialog])
			"This check compensates a bug in balloon."
			ifTrue: [0@0 corner: 0@ -1] ifFalse: [self borderWidth @ 0].

		"Overdraw lower part of title bar to hide bottom corners."		
		aCanvas
			fillRectangle:( (title bottomLeft - (0 @ self submorphs first cornerRadius) corner: title bottomRight) insetBy: inset)
			color: self color].
		
	"Draw a line between the title and the contents."
	self borderWidth > 0 ifTrue: [			
		"Redraw the border all around. Needed because rounded borders do not align very well."
		self wantsRoundedCorners
			ifTrue: [	aCanvas frameRoundRect: self bounds radius: self cornerRadius width: self borderStyle width color: self borderStyle color]
			ifFalse: [aCanvas frameRectangle: self bounds width: self borderStyle width color: self borderStyle color]].! !

!DialogWindow methodsFor: 'rounding' stamp: 'mt 7/25/2016 14:28'!
wantsRoundedCorners

	^ self class roundedDialogCorners or: [super wantsRoundedCorners]! !


!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/25/2016 14:35'!
gradientDialog

	<preference: 'gradientDialog'
		category: 'dialogs'
		description: 'If true, dialogs will have a gradient look.'
		type: #Boolean>
	^ GradientDialog ifNil: [true]
! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/25/2016 14:35'!
gradientDialog: aBoolean

	aBoolean = GradientDialog ifTrue: [^ self].
	GradientDialog := aBoolean.
	self refreshAllDialogs.! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/25/2016 14:34'!
refreshAllDialogs
	
	self allSubInstances do: [:instance | instance setDefaultParameters; setTitleParameters].! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/25/2016 14:27'!
roundedDialogCorners
	<preference: 'Rounded Dialog Corners'
		categoryList: #(windows dialogs)
		description: 'Governs whether dialog windows should have rounded corners'
		type: #Boolean>
	^ RoundedDialogCorners ifNil: [ true ]! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/25/2016 14:34'!
roundedDialogCorners: aBoolean
	
	RoundedDialogCorners = aBoolean ifTrue: [^ self].
	RoundedDialogCorners := aBoolean.
	self refreshAllDialogs.! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/13/2016 19:24'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the dialogs''s border.' }.
		{ #borderWidth. 'Borders'. 'Width of the dialogs''s border.' }.
		{ #borderStyle. 'Borders'. 'Whether to use a plain border, inset, or outset.' }.
		{ #color. 'Colors'. 'Background color of the dialog.' }.
		{ #font. 'Fonts'. 'Font for dialog messages.' }.
		{ #textColor. 'Colors'. 'Color for dialog messages.' }.
		
		{ #titleBorderColor. 'Colors'. 'Color of the dialogs title border.' }.
		{ #titleBorderWidth. 'Geometry'. 'Width of the dialog title border.' }.
		{ #titleBorderStyle. 'Borders'. 'Whether to use a plain border, inset, or outset for the title.' }.
		{ #titleColor. 'Colors'. 'Background color of the dialogs'' title.' }.
		{ #titleFont. 'Fonts'. 'Font for dialog title.' }.
		{ #titleTextColor. 'Colors'. 'Color for the dialog title label.' }.
		
		{ #okColor. 'Colors'. 'Color for the OK button.' }.
		{ #cancelColor. 'Colors'. 'Color for the Cancel button.' }.
		{ #buttonColor. 'Colors'. 'Color for a normal button.' }.
		{ #selectionModifier. 'Colors'. 'How to convert the color of a selected button?' }.
	}! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/19/2016 13:49'!
useWiggleAnimation
	
	<preference: 'Use Wiggle Animation in Modal Dialogs'
		categoryList: #(Morphic windows dialogs)
		description: 'In order to indicate that a modal dialog is waiting for a user''s input, wiggle instead of flash.'
		type: #Boolean>
	^ UseWiggleAnimation ifNil: [true]! !

!DialogWindow class methodsFor: 'preferences' stamp: 'mt 7/19/2016 13:49'!
useWiggleAnimation: aBoolean
	
	UseWiggleAnimation := aBoolean.! !


!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'mt 7/13/2016 20:26'!
response

	^ result
! !

!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'mt 7/13/2016 20:41'!
response: aText
	"Sent when text pane accepts."

	result := aText asString.
	self delete.
! !

!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'mt 7/13/2016 20:38'!
selectionInterval
	^ 1 to: result size
! !

!FillInTheBlankMorph methodsFor: 'accessing' stamp: 'mt 7/13/2016 20:47'!
textPane
	^ textPane! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 11:15'!
createTextPaneAcceptOnCR: acceptBoolean 

	textPane := PluggableTextMorph
				on: self
				text: #response
				accept: #response:
				readSelection: #selectionInterval
				menu: #codePaneMenu:shifted:.
	textPane 
		showScrollBarsOnlyWhenNeeded;
		wantsFrameAdornments: false;
		hasUnacceptedEdits: true;
		acceptOnCR: acceptBoolean;
		setNameTo: 'textPane';
		layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@1));
		hResizing: #spaceFill;
		vResizing: #spaceFill.

	^ textPane! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'mt 7/19/2016 13:08'!
initialize

	super initialize.
	self addKeyboardCaptureFilter: self.! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'mt 7/14/2016 08:01'!
setDefaultParameters

	super setDefaultParameters.
	textPane ifNotNil: [:tp | tp borderColor: self borderColor].! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'mt 7/10/2016 15:22'!
setPasswordQuery: queryString initialAnswer: initialAnswer answerHeight: answerHeight acceptOnCR: acceptBoolean

	self setQuery: queryString 
		initialAnswer: initialAnswer 
		answerHeight: answerHeight 
		acceptOnCR: acceptBoolean.
	textPane font: (StrikeFont passwordFontSize: 12).! !

!FillInTheBlankMorph methodsFor: 'initialization' stamp: 'mt 7/14/2016 08:00'!
setQuery: queryString initialAnswer: initialAnswer answerExtent: answerExtent acceptOnCR: acceptBoolean 
	
	| text |
	
	result := initialAnswer.
	done := false.

	self paneMorph removeAllMorphs.

	self title: 'Input Requested'.
	self message: queryString.
	
	text := self createTextPaneAcceptOnCR: acceptBoolean.
	self paneMorph addMorphBack: text.

	self paneMorph extent: ((initialAnswer asText asMorph extent + (20@10) max: answerExtent) min: 500@500).	
	self setDefaultParameters.! !

!FillInTheBlankMorph methodsFor: 'events' stamp: 'mt 7/19/2016 13:09'!
filterEvent: event for: morph

	(event isKeystroke and: [event keyCharacter = Character escape])
		ifTrue: [event ignore. self cancelDialog].
		
	^ event! !


!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'mt 7/13/2016 20:48'!
request: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean answerExtent: answerExtent
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setQuery: queryString
		initialAnswer: defaultAnswer
		answerExtent: answerExtent
		acceptOnCR: acceptBoolean.

	aFillInTheBlankMorph createAcceptButton
		action: [aFillInTheBlankMorph textPane accept].
	aFillInTheBlankMorph createCancelButton
		action: [aFillInTheBlankMorph closeDialog: returnOnCancel].
		
	aFillInTheBlankMorph moveTo: aPoint.
	^ aFillInTheBlankMorph getUserResponse
! !

!FillInTheBlankMorph class methodsFor: 'instance creation' stamp: 'mt 7/13/2016 20:49'!
requestPassword: queryString initialAnswer: defaultAnswer centerAt: aPoint inWorld: aWorld onCancelReturn: returnOnCancel acceptOnCR: acceptBoolean
	"Create an instance of me whose question is queryString with the given initial answer. Invoke it centered at the given point, and answer the string the user accepts.   If the user cancels, answer returnOnCancel."
	"FillInTheBlankMorph
		request: 'Type something, then type CR.'
		initialAnswer: 'yo ho ho!!'
		centerAt: Display center"

	| aFillInTheBlankMorph |
	aFillInTheBlankMorph := self new
		setPasswordQuery: queryString
		initialAnswer: defaultAnswer
		answerHeight: 50
		acceptOnCR: acceptBoolean.

	aFillInTheBlankMorph createAcceptButton
		action: [aFillInTheBlankMorph textPane accept].
	aFillInTheBlankMorph createCancelButton
		action: [aFillInTheBlankMorph closeDialog: returnOnCancel].
		
	aFillInTheBlankMorph moveTo: aPoint.
	^ aFillInTheBlankMorph getUserResponse! !


!ListChooser methodsFor: 'event handling' stamp: 'mt 7/19/2016 14:45'!
filterEvent: aKeyboardEvent for: aMorph

	| char |
	aKeyboardEvent isKeystroke ifFalse: [^ aKeyboardEvent].
	aKeyboardEvent anyModifierKeyPressed ifTrue: [^ aKeyboardEvent].
	
	char := aKeyboardEvent keyCharacter.
	
	char = Character backspace
		ifTrue: [self searchText: (self searchText asString ifNotEmpty: [:s | s allButLast]). ^ aKeyboardEvent ignore].
	char = Character delete
		ifTrue: [self searchText: (self searchText asString ifNotEmpty: [:s | s allButFirst]). ^ aKeyboardEvent ignore].
	(char = Character cr or: [char = Character enter])
		ifTrue: [self accept. aKeyboardEvent ignore].
	char = Character escape 
		ifTrue: [self cancel. aKeyboardEvent ignore].
	(char asInteger between: 32 and: 126)
		ifTrue: [self searchText: self searchText asString, char asString. aKeyboardEvent ignore].
	
	^ aKeyboardEvent! !

!ListChooser methodsFor: 'building' stamp: 'mt 7/22/2016 15:47'!
buildWith: builder

	| dialogSpec searchBarHeight listSpec fieldSpec |
	
	searchBarHeight := Preferences standardDefaultTextFont height * 2.
	
	dialogSpec := builder pluggableDialogSpec new
		model: self;
		title: #title;
		closeAction: #closed;
		extent: self initialExtent;
		children: OrderedCollection new;
		buttons: OrderedCollection new;
		yourself.
	
	listSpec := builder pluggableListSpec new.
	listSpec 
		model: self;
		list: #items; 
		getIndex: #selectedIndex; 
		setIndex: #selectedIndex:; 
		doubleClick: #accept;
		"keystrokePreview: #keyStrokeFromList:;"
		autoDeselect: false;
		name: #list;
		frame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@searchBarHeight corner: 0@0)).
	dialogSpec children add: listSpec.
	
	fieldSpec := builder pluggableInputFieldSpec new.
	fieldSpec 
		model: self;
		getText: #searchText;
		editText: #searchText:;
		setText: #acceptText:;
		selection: #textSelection;
		menu: nil;
		indicateUnacceptedChanges: false;
		askBeforeDiscardingEdits: false;
		help: 'Type a string to filter down the listed items';
		frame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@searchBarHeight)).
	dialogSpec children add: fieldSpec.
	
	"Buttons"
	dialogSpec buttons add: (
		builder pluggableButtonSpec new
			model: self; 
			label: #acceptLabel;
			action: #accept;
			enabled: #canAcceptOrAdd;
			color: #acceptColor).

	dialogSpec buttons add: (
		builder pluggableButtonSpec new
			model: self; 
			label: 'Cancel';
			action: #cancel;
			color: #cancelColor).
		
	dialogMorph := builder build: dialogSpec.
	dialogMorph addKeyboardCaptureFilter: self.
	listMorph := builder widgetAt: #list.
	listMorph allowEmptyFilterResult: true.
	
	^ dialogMorph! !

!ListChooser methodsFor: 'building' stamp: 'mt 7/14/2016 17:04'!
initialExtent

	| listFont |
	listFont := Preferences standardListFont.
	^ (20 * (listFont widthOf: $m))@(15 * listFont height)! !

!ListChooser methodsFor: 'testing' stamp: 'mt 7/19/2016 12:12'!
canAcceptOrAdd
	^ self canAccept or: [self canAdd]! !

!ListChooser methodsFor: 'testing' stamp: 'mt 7/22/2016 10:41'!
canAdd
	^ self addAllowed
		and: [self searchText asString withBlanksTrimmed notEmpty]
		and: [self selectedItem asString ~= self searchText asString]! !

!ListChooser methodsFor: 'initialize-release' stamp: 'mt 7/22/2016 15:46'!
chooseIndexFrom: labelList title: aString
	| choice |
	choice := self chooseItemFrom: labelList title: aString addAllowed: false.
	^ self items indexOf: choice ifAbsent: 0! !

!ListChooser methodsFor: 'initialize-release' stamp: 'mt 7/14/2016 17:22'!
chooseIndexFrom: labelList title: aString addAllowed: aBoolean
	| choice |
	choice := self chooseItemFrom: labelList title: aString addAllowed: false.
	self addAllowed: aBoolean.
	^ self items indexOf: choice ifAbsent: 0! !

!ListChooser methodsFor: 'initialize-release' stamp: 'mt 7/14/2016 17:21'!
chooseItemFrom: labelList title: aString addAllowed: aBoolean

	self items: labelList asOrderedCollection.
	self title: aString.
	self addAllowed: aBoolean.

	ToolBuilder open: self.
	^ self result! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/14/2016 17:19'!
addAllowed

	^ addAllowed! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/14/2016 17:19'!
addAllowed: anObject

	addAllowed := anObject! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/14/2016 17:19'!
items

	^ items! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/14/2016 17:19'!
items: anObject

	items := anObject! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/14/2016 17:19'!
result

	^ result! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/14/2016 17:19'!
result: anObject

	result := anObject! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/21/2016 09:18'!
searchText: aString
	searchText := aString.
	listMorph filterList: aString asString.
	
	self changed: #searchText.
	self changed: #canAcceptOrAdd.
	self changed: #acceptLabel.
	self changed: #buttons.! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/19/2016 11:25'!
selectedIndex
	^ selectedIndex ifNil: [ 1 ]! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/21/2016 09:18'!
selectedIndex: anInt
	selectedIndex := anInt.
	self changed: #selectedIndex.! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/22/2016 10:40'!
selectedItem

	^  self items at: self selectedIndex ifAbsent: []! !

!ListChooser methodsFor: 'accessing' stamp: 'mt 7/19/2016 12:00'!
textSelection
	^ self searchText size +1 to: self searchText size ! !

!ListChooser methodsFor: 'actions' stamp: 'mt 7/22/2016 10:40'!
accept
	"if the user submits with no valid entry, make them start over"
	
	| choice |
	self canAccept ifFalse: [
		self canAdd ifTrue: [^ self add].
		^ self changed: #textSelection].
	
	choice := self selectedItem.
	
	self canAdd ifTrue: [
		"Ask the user whether to add the new item or choose the list selection."
		(UserDialogBoxMorph confirm: 'You can either choose an existing item or add a new one.\What do you want?' translated withCRs title: 'Choose or Add' translated trueChoice: choice asString falseChoice: self searchText asString at: ActiveHand position)
			ifTrue: [self result: choice] ifFalse: [self result: self searchText asString]
		] ifFalse: [self result: choice].
		
	
	self changed: #close.! !

!ListChooser methodsFor: 'actions' stamp: 'mt 7/19/2016 11:33'!
add
	"if the user submits with no valid entry, make them start over"
	self canAdd ifFalse: [^ self changed: #textSelection].
	self result: self searchText asString.
	self changed: #close.! !

!ListChooser methodsFor: 'actions' stamp: 'mt 7/19/2016 11:33'!
cancel

	self result: nil.
	self changed: #close.! !

!ListChooser methodsFor: 'actions' stamp: 'mt 7/14/2016 17:23'!
closed
	
	self selectedIndex: 0.! !

!ListChooser methodsFor: 'colors' stamp: 'mt 7/22/2016 15:50'!
acceptColor
	
	self canAdd ifTrue: [^ self addColor].
	
	^ self canAccept 
		ifTrue: [ self userInterfaceTheme okColor ifNil: [(Color r: 0.49 g: 0.749 b: 0.49)] ]
		ifFalse: [ self userInterfaceTheme disabledColor ifNil: [Color lightGray] ]! !

!ListChooser methodsFor: 'colors' stamp: 'mt 7/20/2016 13:59'!
acceptLabel

	^ self canAdd
		ifFalse: ['Choose' translated]
		ifTrue: [self canAccept
			ifTrue: ['Choose or Add' translated]
			ifFalse: ['Add' translated]]! !

!ListChooser methodsFor: 'colors' stamp: 'mt 7/10/2016 20:01'!
addColor
	
	^ self canAdd 
		ifTrue: [ self userInterfaceTheme addColor ifNil: [Color blue muchLighter] ]
		ifFalse: [ self userInterfaceTheme disabledColor ifNil: [Color lightGray] ]! !

!ListChooser methodsFor: 'colors' stamp: 'mt 7/22/2016 15:51'!
cancelColor
	
	^ self userInterfaceTheme cancelColor ifNil: [Color r: 1 g: 0.6 b: 0.588]! !

!ListChooser methodsFor: 'updating' stamp: 'mt 7/21/2016 09:23'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self
		changed: #okColor;
		changed: #cancelColor;
		changed: #addColor.! !


!ListChooser class methodsFor: 'preferences' stamp: 'mt 7/10/2016 20:02'!
themeProperties

	^ super themeProperties,  {
		{ #okColor. 'Colors'. 'Color for the OK button.' }.
		{ #cancelColor. 'Colors'. 'Color for the Cancel button.' }.
		{ #addColor. 'Colors'. 'Color for a normal button.' }.
		{ #disabledColor. 'Colors'. 'Color for a disabled button.' }.
	}! !


!ListMultipleChooser methodsFor: 'actions' stamp: 'mt 7/21/2016 10:31'!
choose

	
"	self changed: #inputRequested with: #selectedIndex.
"	
	ToolBuilder open: self.
	^ self selectedValues! !

!ListMultipleChooser methodsFor: 'toolbuilder' stamp: 'mt 7/22/2016 15:52'!
buildWith: builder

	| dialogSpec choicesSpec |
	dialogSpec := builder pluggableDialogSpec new
		model: self;
		extent: self initialExtent;
		title: #title;
		children: OrderedCollection new;
		buttons: OrderedCollection new.
		
	choicesSpec := builder pluggableMultiSelectionListSpec new
		model: self;
		list: #labels;
		setIndex: #selectedIndex:;
		getIndex: #selectedIndex;
		setSelectionList: #selectionAt:put:;
		getSelectionList: #selectionAt:;
		frame: (0@0 corner: 1@1).
	dialogSpec children add: choicesSpec.
	
	"Buttons"
	dialogSpec buttons add: (
		builder pluggableButtonSpec new
			model: self;
			label: 'accept';
			color: (self userInterfaceTheme okColor ifNil: [Color r: 0.49 g: 0.749 b: 0.49]);
			action: #accept).
			
	dialogSpec buttons add: (
		builder pluggableButtonSpec new
			model: self;
			label: 'cancel';
			color: (self userInterfaceTheme cancelColor ifNil: [Color r: 1 g: 0.6 b: 0.588]);
			action: #cancel).
				
	^ builder build: dialogSpec! !

!ListMultipleChooser methodsFor: 'toolbuilder' stamp: 'mt 7/21/2016 10:33'!
initialExtent

	| listFont |
	listFont := Preferences standardListFont.
	^ (20 * (listFont widthOf: $m))@(15 * listFont height)! !

!ListMultipleChooser methodsFor: 'updating' stamp: 'mt 7/10/2016 20:15'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self
		changed: #okColor;
		changed: #cancelColor.! !


!ListMultipleChooser class methodsFor: 'preferences' stamp: 'mt 7/10/2016 20:16'!
themeProperties

	^ super themeProperties,  {
		{ #okColor. 'Colors'. 'Color for the OK button.' }.
		{ #cancelColor. 'Colors'. 'Color for the Cancel button.' }.
	}! !


!MorphicUIManager methodsFor: 'ui requests' stamp: 'mt 7/21/2016 09:30'!
chooseFrom: aList lines: linesArray title: aString 
	"Choose an item from the given list. Answer the index of the selected item."
	
	aList size <= 7 ifTrue: [
		| dialog |
		dialog := DialogWindow new
			title: 'Please Choose';
			message: aString;
			yourself.
		aList doWithIndex: [:ea :index |
			dialog createButton: ea value: index].
		dialog selectedButtonIndex: 1.
		^ dialog getUserResponseAtHand ifNil: [0]].
	
	^ ListChooser chooseFrom: aList title: aString! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'mt 7/21/2016 09:46'!
chooseFrom: labelList values: valueList lines: linesArray title: aString 
	"Choose an item from the given list. Answer the selected item."
	
	| index |
	index := self chooseFrom: labelList lines: linesArray title: aString.
	^ index = 0
		ifTrue: [ nil ]
		ifFalse: [ valueList at: index ]! !

!MorphicUIManager methodsFor: 'ui requests' stamp: 'mt 7/19/2016 14:29'!
chooseFromOrAddTo: aList lines: linesArray title: aString

	^ ListChooser
		chooseItemFrom: aList
		title: aString
		addAllowed: true! !


!NewBalloonMorph methodsFor: 'initialization' stamp: 'mt 7/25/2016 10:13'!
initialize

	super initialize.
	
	self setDefaultParameters.
	
	textMorph := TextMorph new
		wrapFlag: false;
		lock;
		yourself.
	
	self addMorph: textMorph.! !

!NewBalloonMorph methodsFor: 'initialization' stamp: 'mt 7/25/2016 11:03'!
setDefaultParameters

	self
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color r: 0.46 g: 0.46 b: 0.353]);
		color: (self userInterfaceTheme color ifNil: [Color r: 0.92 g: 0.92 b: 0.706]);
		hasDropShadow: (Preferences menuAppearance3d and: [self color isTranslucent not]);
		shadowOffset: 1@1;
		shadowColor: (self color muchDarker muchDarker alpha: 0.333);
		orientation: #bottomLeft.
		
	MenuMorph roundedMenuCorners
		ifTrue: [self cornerStyle: #rounded].
		
	"Gradients?"
	MenuMorph gradientMenu ifTrue: [
		| cc fill |
		cc := self color.
		fill := GradientFillStyle ramp: {
			0.0 -> Color white.
			0.15 -> (cc mixed: 0.5 with: Color white).
			0.5 -> cc.
			0.8 -> cc twiceDarker}.
		fill
			origin: self topLeft;
			direction: 0@self height.
		self fillStyle: fill].! !

!NewBalloonMorph methodsFor: 'initialization' stamp: 'mt 7/25/2016 10:15'!
setText: stringOrText

	| text |
	text := stringOrText asText.

	text unembellished ifTrue: [
		text addAttribute: (TextColor color: (self userInterfaceTheme textColor ifNil: [Color black]))].

	text addAttribute: (TextFontReference toFont: (self userInterfaceTheme font ifNil: [TextStyle defaultFont])).
	
	self textMorph wrapFlag: false.
	self textMorph newContents: text.
	self textMorph fullBounds.
	
	(self maximumWidth > 0 and: [self textMorph width > self maximumWidth])
		ifTrue: [
			self textMorph
				wrapFlag: true;
				width: self maximumWidth].
		
	self updateLayout.! !

!NewBalloonMorph methodsFor: 'drawing' stamp: 'mt 7/25/2016 10:58'!
drawOn: aCanvas

	self fillStyle isColor
		ifFalse: [self fillStyle isGradientFill
				ifTrue: [self fillStyle direction: 0 @ self height]].
	"Bubble."
	self wantsRoundedCorners
		ifTrue: [aCanvas
			frameAndFillRoundRect: self bubbleBounds
			radius: self cornerRadius fillStyle: self fillStyle borderWidth: self borderStyle width borderColor: self borderStyle color]
		ifFalse: [aCanvas
			fillRectangle: self bubbleBounds
			fillStyle: self fillStyle borderStyle: self borderStyle].

	"Tail."
	self hasTail ifTrue: [
		self verticesForTail in: [:points |
			| pixelOffset |
			pixelOffset := points first y < points second y
				ifFalse: [points first x < points second x
					ifTrue: [self borderStyle width negated @ self borderStyle width] "bottomLeft"
					ifFalse: [self borderStyle width @ self borderStyle width]] "bottomRight"
				ifTrue: [points first x < points second x
					ifTrue: [self borderStyle width negated @ self borderStyle width negated] "topLeft"
					ifFalse: [self borderStyle width @ self borderStyle width negated]]. "topRight"

			aCanvas
				drawPolygon: points
				fillStyle: self fillStyle.
			aCanvas
				line: points first
				to: points second + pixelOffset
				width: self borderStyle width
				color: self borderStyle color.
			aCanvas
				line: points first
				to: points third + pixelOffset
				width: self borderStyle width
				color: self borderStyle color]]! !

!NewBalloonMorph methodsFor: 'updating' stamp: 'mt 7/25/2016 10:12'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	self setDefaultParameters.! !


!NewBalloonMorph class methodsFor: 'instance creation' stamp: 'mt 7/25/2016 10:18'!
string: message for: morph corner: symbol

	^ self new
		balloonOwner: morph;
		setText: message;
		orientation: symbol;
		yourself! !

!NewBalloonMorph class methodsFor: 'preferences' stamp: 'mt 7/25/2016 10:09'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the balloon''s border.' }.
		{ #borderWidth. 'Borders'. 'Width of the balloon''s border.' }.
		{ #color. 'Colors', 'Color for the balloon background.' }.
		{ #font. 'Fonts'. 'Font for balloon text if not overridden by text attributes.' }.
		{ #textColor. 'Colors'. 'Color for the balloon text if not overridden by text attributes.' }.
	}! !


!PluggableDialogSpec methodsFor: 'window compatibility' stamp: 'mt 7/14/2016 08:42'!
label
	^ self title! !

!PluggableDialogSpec methodsFor: 'window compatibility' stamp: 'mt 7/14/2016 08:43'!
label: stringOrSymbol
	self title: stringOrSymbol.! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
buttons

	^ buttons! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
buttons: anObject

	buttons := anObject! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:24'!
closeAction

	^ closeAction! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:24'!
closeAction: anObject

	closeAction := anObject! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
extent

	^ extent! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
extent: anObject

	extent := anObject! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
message

	^ message! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
message: anObject

	message := anObject! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
title

	^ title! !

!PluggableDialogSpec methodsFor: 'accessing' stamp: 'mt 7/13/2016 16:31'!
title: anObject

	title := anObject! !

!PluggableDialogSpec methodsFor: 'building' stamp: 'mt 7/14/2016 09:42'!
buildWith: builder
	^builder buildPluggableDialog: self.! !

!PluggableDialogSpec methodsFor: 'as yet unclassified' stamp: 'mt 7/14/2016 16:24'!
horizontalResizing
	^ #rigid! !

!PluggableDialogSpec methodsFor: 'as yet unclassified' stamp: 'mt 7/14/2016 16:24'!
verticalResizing
	^ #rigid! !


!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:36'!
closeDialogSelector

	^ closeDialogSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:36'!
closeDialogSelector: anObject

	closeDialogSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getButtonsSelector

	^ getButtonsSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getButtonsSelector: anObject

	getButtonsSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getChildrenSelector

	^ getChildrenSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getChildrenSelector: anObject

	getChildrenSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getMessageSelector

	^ getMessageSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getMessageSelector: anObject

	getMessageSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getTitleSelector

	^ getTitleSelector! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:31'!
getTitleSelector: anObject

	getTitleSelector := anObject! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:17'!
model
	^ model! !

!PluggableDialogWindow methodsFor: 'accessing' stamp: 'mt 7/14/2016 08:18'!
model: anObject

	model ifNotNil: [model removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	model := anObject.! !

!PluggableDialogWindow methodsFor: 'updating' stamp: 'mt 7/14/2016 17:01'!
update: what

	what ifNil:[^self].

	what == self getTitleSelector ifTrue:[self title: (model perform: self getTitleSelector)].
	what == self getMessageSelector ifTrue:[self message: (model perform: self getMessageSelector)].
	
	what == self getChildrenSelector ifTrue:[
		self paneMorph removeAllMorphs.
		(self model perform: self getChildrenSelector)
			do: [:m| m hResizing: #spaceFill; vResizing: #spaceFill];
			in: [:children | self paneMorph addAllMorphs: children]].

	what == self getButtonsSelector ifTrue:[
		self buttonRow
			removeAllMorphs;
			addAllMorphs: (self model perform: self getButtonsSelector).
		self updateButtonProperties].
	
	what == #close ifTrue: [^ self delete].

	super update: what.! !

!PluggableDialogWindow methodsFor: 'updating' stamp: 'mt 7/21/2016 09:16'!
updateButtonProperties

	self buttons do: [:ea |
		ea setProperty: #normalColor toValue: ea offColor.
		ea setProperty: #normalLabel toValue: ea label.
		ea hResizing: #rigid; vResizing: #rigid].
	
	self updateButtonExtent.! !

!PluggableDialogWindow methodsFor: 'submorphs-add/remove' stamp: 'mt 7/14/2016 08:36'!
delete

	self model okToClose ifFalse: [^ self].
	
	self closeDialogSelector ifNotNil: [:sel | self model perform: sel].
	
	self model
		windowIsClosing;
		release.
	self model: nil.
	
	super delete.! !


!SystemProgressBarMorph methodsFor: 'drawing' stamp: 'mt 7/22/2016 11:33'!
drawOn: aCanvas
	| area |
	super drawOn: aCanvas.
	
	barSize > 0 ifTrue: [
		area := self innerBounds.
		area := area origin extent: (barSize min: area extent x)@area extent y.
		aCanvas fillRectangle: area color: barColor
	].
! !

!SystemProgressBarMorph methodsFor: 'initialization' stamp: 'mt 7/22/2016 11:36'!
initialize
	super initialize.

	self setDefaultParameters.
	barSize := 0.
! !

!SystemProgressBarMorph methodsFor: 'initialization' stamp: 'mt 7/22/2016 11:29'!
setDefaultParameters
	"change the receiver's appareance parameters"

	self
		color: (self userInterfaceTheme color ifNil: [Color r: 0.977 g: 0.977 b: 0.977]);
		borderStyle: (self userInterfaceTheme borderStyle ifNil: [BorderStyle default]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color transparent]);
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [0]).

	barColor := self userInterfaceTheme barColor ifNil: [Color r: 0.72 g: 0.72 b: 0.9].! !

!SystemProgressBarMorph methodsFor: 'updating' stamp: 'mt 7/22/2016 11:29'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self setDefaultParameters.! !


!SystemProgressBarMorph class methodsFor: 'preferences' stamp: 'mt 7/22/2016 11:27'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the progress bar''s border.' }.
		{ #borderWidth. 'Borders'. 'Width of the progress bar''s border.' }.
		{ #borderStyle. 'Borders'. 'Whether to use a plain border, inset, or outset.' }.
		{ #color. 'Colors'. 'Background color of the progress bar.' }.
		{ #barColor. 'Colors'. 'Color of the progress bar''s bar.' }.
	}! !


!SystemProgressMorph methodsFor: 'initialization' stamp: 'mt 7/22/2016 11:20'!
initialize
	super initialize.
	activeSlots := 0.
	bars := Array new: 10.
	labels := Array new: 10.
	lock := Semaphore forMutualExclusion.
	self setDefaultParameters;
		setProperty: #morphicLayerNumber toValue: self morphicLayerNumber;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		cellPositioning: #leftCenter;
		cellInset: 5;
		listCentering: #center;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: Inset;
		minWidth: 150! !

!SystemProgressMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 15:39'!
setDefaultParameters
	"change the receiver's appareance parameters"

	self
		color: (self userInterfaceTheme color ifNil: [Color r: 0.9 g: 0.9 b: 0.9]);
		borderStyle: (self userInterfaceTheme borderStyle ifNil: [BorderStyle default]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color gray]);
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]).

	Preferences menuAppearance3d ifTrue: [self addDropShadow].

	self
		font: (self userInterfaceTheme font ifNil: [TextStyle defaultFont]);
		textColor: (self userInterfaceTheme textColor ifNil: [Color black]).

	self
		updateColor: self
		color: self color
		intensity: 1.! !

!SystemProgressMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 15:36'!
updateColor: aMorph color: aColor intensity: anInteger 
	"update the apareance of aMorph"
	| fill cc |
	MenuMorph gradientMenu
		ifFalse: [^ self].

	
	cc := aColor adjustSaturation: -0.08 brightness: 0.4.
	fill := GradientFillStyle ramp: {
		0.0 -> cc. 
		0.25 -> (aColor mixed: 0.5 with: cc). 
		1.0 -> aColor}.
	
	fill radial: false;
		origin: aMorph topLeft;
		direction: 0 @ aMorph height.
	aMorph fillStyle: fill! !

!SystemProgressMorph methodsFor: 'updating' stamp: 'mt 7/26/2016 15:39'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self setDefaultParameters.! !

!SystemProgressMorph methodsFor: 'private' stamp: 'mt 7/26/2016 15:39'!
nextSlotFor: shortDescription
	
	lock critical: [ | label bar slots |
		slots := self labels size.
		self activeSlots = slots ifTrue: [^0].
		self activeSlots: self activeSlots + 1.
		1 to: slots do: [:index |
			label := (self labels at: index).
			label ifNil: [
				bar := self bars at: index put: (SystemProgressBarMorph new extent: BarWidth@BarHeight).
				label := self labels at: index put: ((StringMorph contents: shortDescription font: self font) color: self textColor).
				self
					addMorphBack: label;
					addMorphBack: bar.
				^index].
			label owner ifNil: [
				bar := self bars at: index.
				label := self labels at: index.
				self
					addMorphBack: (label contents: shortDescription);
					addMorphBack: (bar barSize: 0).
				^index]]]
		! !

!SystemProgressMorph methodsFor: 'rounding' stamp: 'mt 7/22/2016 11:11'!
wantsRoundedCorners

	^ MenuMorph roundedMenuCorners or: [super wantsRoundedCorners]! !

!SystemProgressMorph methodsFor: 'accessing' stamp: 'mt 7/26/2016 15:40'!
font: anObject

	font := anObject.
	self labels select: [:ea | ea notNil] thenDo: [:ea | ea font: font].! !

!SystemProgressMorph methodsFor: 'accessing' stamp: 'mt 7/26/2016 15:38'!
textColor

	^ textColor ifNil: [Color black]! !

!SystemProgressMorph methodsFor: 'accessing' stamp: 'mt 7/26/2016 15:41'!
textColor: aColor

	textColor := aColor.
	self labels select: [:ea | ea notNil] thenDo: [:ea | ea color: textColor].! !


!SystemProgressMorph class methodsFor: 'preferences' stamp: 'mt 7/26/2016 15:40'!
applyUserInterfaceTheme

	self reset.! !

!SystemProgressMorph class methodsFor: 'preferences' stamp: 'mt 7/22/2016 11:13'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the progress'' border.' }.
		{ #borderWidth. 'Borders'. 'Width of the progress'' border.' }.
		{ #borderStyle. 'Borders'. 'Whether to use a plain border, inset, or outset.' }.
		{ #color. 'Colors'. 'Background color of the progress.' }.

		{ #font. 'Fonts'. 'Font for bar labels.' }.
		{ #textColor. 'Colors'. 'Color for bar labels.' }.
	}! !


!ToolBuilder methodsFor: 'defaults' stamp: 'mt 7/14/2016 08:47'!
pluggableDialogSpec
	^PluggableDialogSpec! !

!ToolBuilder methodsFor: 'widgets optional' stamp: 'mt 7/13/2016 16:37'!
buildPluggableDialog: spec

	| windowSpec |
	windowSpec := self pluggableWindowSpec new.
	windowSpec children: (spec children ifNil: [OrderedCollection new]).
	
	"TODO: Convert the dialog's message into some element in the children."
		
	spec buttons ifNotNil: [:buttons | windowSpec children addAll: buttons].
	windowSpec
		model: spec model;
		extent: spec extent;
		label: spec title.
	^ self buildPluggableWindow: windowSpec! !


!MorphicToolBuilder methodsFor: 'opening' stamp: 'mt 7/14/2016 17:00'!
open: anObject
	"Build and open the object. Answer the widget opened."
	| morph |
	anObject isMorph 
		ifTrue:[morph := anObject]
		ifFalse:[morph := self build: anObject].
	(morph isKindOf: MenuMorph)
		ifTrue:[morph popUpInWorld: World].
	(morph isKindOf: DialogWindow)
		ifTrue: [^ morph moveToHand; getUserResponse].
	(morph isKindOf: SystemWindow)
		ifFalse:[morph openInWorld]
		ifTrue:[
			morph := morph openInWorldExtent: morph extent.
			(self class openToolsAttachedToMouseCursor
				and: [self currentEvent isMouse  and: [self currentEvent isMouseUp]])
					ifTrue: [
						morph setProperty: #initialDrop toValue: true.
						morph hasDropShadow: false.
						self currentHand attachMorph: morph]].
	^morph! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'mt 7/13/2016 16:40'!
dialogClass
	^ PluggableDialogWindow! !

!MorphicToolBuilder methodsFor: 'widget classes' stamp: 'mt 7/14/2016 07:56'!
windowClassFor: aSpec
	^aSpec multiWindowStyle
		caseOf:
		{	[nil]				->	[PluggableSystemWindow].
			[#labelButton]	->	[PluggableSystemWindowWithLabelButton] }
		otherwise:				[PluggableSystemWindowWithLabelButton]! !

!MorphicToolBuilder methodsFor: 'widgets optional' stamp: 'mt 7/14/2016 16:53'!
buildPluggableDialog: aSpec

	| widget |

	widget := self dialogClass new.
	self register: widget id: aSpec name.
	
	widget model: aSpec model.

	"Set child dependent layout properties. The pane morph holds the special contents."
	widget paneMorph wantsPaneSplitters: (aSpec wantsResizeHandles ifNil: [true]).
	self setLayoutHintsFor: widget paneMorph spec: aSpec.
	widget paneMorph layoutInset: (aSpec padding ifNil: [ProportionalSplitterMorph gripThickness]).
	widget paneMorph cellInset: (aSpec spacing ifNil: [ProportionalSplitterMorph gripThickness]).
	widget paneMorph wantsPaneSplitters ifTrue: [widget paneMorph addCornerGrips"addEdgeGrips"].

	"Now create the children."
	panes := OrderedCollection new.
	aSpec children isSymbol
		ifTrue: [
			widget getChildrenSelector: aSpec children.
			widget update: aSpec children]
		ifFalse: [
			self buildAll: aSpec children in: widget paneMorph].

	"Now create the buttons."
	aSpec buttons isSymbol
		ifTrue: [
			widget getButtonsSelector: aSpec buttons.
			widget update: aSpec buttons]
		ifFalse: [
			self buildAll: aSpec buttons in: widget buttonRowMorph.
			widget updateButtonProperties].

	aSpec title ifNotNil: [:label |
		label isSymbol 
			ifTrue:[widget getTitleSelector: label; update: label]
			ifFalse:[widget title: label]].
	aSpec message ifNotNil: [:label |
		label isSymbol 
			ifTrue:[widget getMessageSelector: label; update: label]
			ifFalse:[widget message: label]].
		
	widget closeDialogSelector: aSpec closeAction.
	self buildHelpFor: widget spec: aSpec. 

	"Everything is shrink-wrapped around the pane morph."
	widget paneMorph extent: (aSpec extent ifNil:[widget initialExtent]).

	^ widget! !


!UndefinedVariable methodsFor: 'as yet unclassified' stamp: 'mt 7/19/2016 15:01'!
openMenuIn: aBlock

	^ self resume: (UIManager default
		confirm: name asText allBold, ' appears to be undefined at this point.\Proceed anyway?' withCRs
		title: 'Undefined Variable').! !


!UnknownSelector methodsFor: 'as yet unclassified' stamp: 'mt 7/19/2016 15:08'!
openMenuIn: aBlock
	| alternatives labels lines caption choice |
	alternatives := Symbol possibleSelectorsFor: name.
	labels := Array streamContents:
				[:s | s nextPut: name; nextPutAll: alternatives].
	lines := {1. alternatives size + 1}.
	caption := 'Unknown selector, please\confirm, correct, or cancel' withCRs.
	
	choice := aBlock value: labels value: lines value: caption.
	
	choice = 0 ifTrue: [^ self resume: nil].
	choice = 1 ifTrue: [^ self resume: name asSymbol].
	self resume: (alternatives at: choice - 1)! !


!UnusedVariable methodsFor: 'as yet unclassified' stamp: 'mt 7/19/2016 14:54'!
openMenuIn: aBlock
	
	self resume: (UIManager default
		confirm: name asText allBold, ' appears to be unused in this method.\Remove it from the code?' withCRs
		title: 'Unused Variable').! !


!UserDialogBoxMorph methodsFor: 'accessing' stamp: 'mt 7/13/2016 20:12'!
label
	^ self message! !

!UserDialogBoxMorph methodsFor: 'accessing' stamp: 'mt 7/13/2016 20:12'!
label: aString
	self message: aString.! !


!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/20/2016 13:52'!
confirm: aString
	"UserDialogBoxMorph confirm: 'Do you like chocolate?'"
	^self confirm: aString title: 'Please Confirm'! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/20/2016 13:53'!
confirm: aString orCancel: cancelBlock at: aPointOrNil
	^self
		confirm: aString
		orCancel: cancelBlock
		title: 'Please Confirm'
		at: aPointOrNil! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/13/2016 20:59'!
confirm: aString orCancel: cancelBlock title: titleString at: aPointOrNil
	
	(self new
		title: titleString;
		message: aString;
		createButton: 'Yes' translated value: true;
		createButton: 'No' translated  value: false;
		createButton: 'Cancel' translated value: nil;
		selectedButtonIndex: 1; "YES"
		yourself) in: [:dialog |
			^ (aPointOrNil
				ifNil: [dialog getUserResponseAtHand]
				ifNotNil: [
					dialog moveTo: aPointOrNil.
					dialog getUserResponse])
						ifNil: [ cancelBlock value ]]! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/13/2016 20:11'!
confirm: aString title: titleString at: aPointOrNil
	"UserDialogBoxMorph confirm: 'Make your choice carefully' withCRs title: 'Do you like chocolate?'"
	^self new
		title: titleString;
		message: aString;
		createButton: 'Yes' translated value: true;
		createCancelButton: 'No' translated  value: false;
		selectedButtonIndex: 1; "YES"
		getUserResponseAtHand! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/13/2016 20:17'!
confirm: aString title: titleString trueChoice: trueChoice falseChoice: falseChoice at: aPointOrNil
	"UserDialogBoxMorph confirm: 'Make your choice carefully' withCRs title: 'Do you like chocolate?' trueChoice: 'Oh yessir!!' falseChoice: 'Not so much...'"
	^self new
		title: titleString;
		message: aString;
		createButton: trueChoice translated value: true;
		createCancelButton: falseChoice translated value: false;
		selectedButtonIndex: 1;
		moveTo: (aPointOrNil ifNil: [ActiveWorld center]);
		getUserResponse! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/13/2016 20:19'!
confirm: aString title: titleString trueChoice: trueChoice falseChoice: falseChoice default: default triggerAfter: seconds at: aPointOrNil
	"UserDialogBoxMorph confirm: 'I like hot java' title: 'What do you say?' trueChoice: 'You bet!!' falseChoice: 'Nope' default: false triggerAfter: 12 at: 121@212"
	^self new
		title: titleString;
		message: aString;
		createButton: trueChoice translated value: true;
		createCancelButton: falseChoice translated value: false;
		selectedButtonIndex: (default ifTrue: [1] ifFalse: [2]);
		moveTo: (aPointOrNil ifNil: [ActiveWorld center]);
		getUserResponseAfter: seconds! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/20/2016 13:53'!
inform: aString
	"UserDialogBoxMorph inform: 'Squeak is great!!'"
	^self inform: aString title: 'Note' translated! !

!UserDialogBoxMorph class methodsFor: 'utilities' stamp: 'mt 7/13/2016 21:02'!
inform: aString title: titleString at: aPointOrNil
	"UserDialogBoxMorph inform: 'Squeak is great!!' title: 'Will you look at this:'"
	
	^self new
		title: titleString;
		message: aString;
		createButton: 'OK' translated value: nil;
		getUserResponseAtHand! !

UserDialogBoxMorph removeSelector: #addButton:value:!
UserDialogBoxMorph removeSelector: #addButton:value:selected:performActionOnEscape:!
UserDialogBoxMorph removeSelector: #addCancelButton:value:!
UserDialogBoxMorph removeSelector: #addSelectedButton:value:!
UserDialogBoxMorph removeSelector: #addSelectedCancelButton:value:!
UserDialogBoxMorph removeSelector: #buttonColor!
UserDialogBoxMorph removeSelector: #buttons!
UserDialogBoxMorph removeSelector: #checkAgainstKeymap:!
UserDialogBoxMorph removeSelector: #closeDialog:!
UserDialogBoxMorph removeSelector: #deselectSelectedButton!
UserDialogBoxMorph removeSelector: #drawSubmorphsOn:!
UserDialogBoxMorph removeSelector: #flash!
UserDialogBoxMorph removeSelector: #handlesKeyboard:!
UserDialogBoxMorph removeSelector: #initialize!
UserDialogBoxMorph removeSelector: #justDroppedInto:event:!
UserDialogBoxMorph removeSelector: #keyStroke:!
UserDialogBoxMorph removeSelector: #mouseDown:!
UserDialogBoxMorph removeSelector: #mouseUp:!
UserDialogBoxMorph removeSelector: #performActionOnEscapeOf:!
UserDialogBoxMorph removeSelector: #processFocusEvent:using:!
UserDialogBoxMorph removeSelector: #registerKeyFor:!
UserDialogBoxMorph removeSelector: #runModalIn:forHand:at:!
UserDialogBoxMorph removeSelector: #selectButton:!
UserDialogBoxMorph removeSelector: #selectNextButton!
UserDialogBoxMorph removeSelector: #selectPreviousButton!
UserDialogBoxMorph removeSelector: #step!
UserDialogBoxMorph removeSelector: #stepTime!
UserDialogBoxMorph removeSelector: #stopAutoTrigger!
UserDialogBoxMorph removeSelector: #title!
UserDialogBoxMorph removeSelector: #title:!
UserDialogBoxMorph removeSelector: #titleGradient!
UserDialogBoxMorph removeSelector: #triggerAfter:!
UserDialogBoxMorph removeSelector: #wantsToBeDroppedInto:!
DialogWindow subclass: #UserDialogBoxMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!UserDialogBoxMorph reorganize!
('accessing' label label:)
!

Morph subclass: #SystemProgressMorph
	instanceVariableNames: 'activeSlots bars labels font lock requestedPosition textColor'
	classVariableNames: 'BarHeight BarWidth Inset UniqueInstance'
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!SystemProgressMorph reorganize!
('dropping/grabbing' slideToTrash:)
('initialization' initialize morphicLayerNumber setDefaultParameters updateColor:color:intensity:)
('updating' applyUserInterfaceTheme)
('submorphs-add/remove' dismissViaHalo)
('private' freeSlot: nextSlotFor: position:label:min:max: recenter reposition)
('labelling' labelAt:put: setLabel:at:)
('rounding' wantsRoundedCorners)
('accessing' activeSlots activeSlots: bars bars: font font: labels labels: requestedPosition requestedPosition: textColor textColor:)
!

Morph subclass: #SystemProgressBarMorph
	instanceVariableNames: 'barSize barColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!
PluggableWindowSpec removeSelector: #isDialog!
PluggableWindowSpec removeSelector: #isDialog:!
PluggableCompositeSpec subclass: #PluggableWindowSpec
	instanceVariableNames: 'label extent closeAction multiWindowStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Kernel'!
PluggableDialogWindow removeSelector: #statusValue!
PluggableDialogWindow removeSelector: #statusValue:!
DialogWindow subclass: #PluggableDialogWindow
	instanceVariableNames: 'model getTitleSelector getMessageSelector getChildrenSelector getButtonsSelector closeDialogSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableDialogWindow reorganize!
('accessing' closeDialogSelector closeDialogSelector: getButtonsSelector getButtonsSelector: getChildrenSelector getChildrenSelector: getMessageSelector getMessageSelector: getTitleSelector getTitleSelector: model model:)
('updating' update: updateButtonProperties)
('submorphs-add/remove' delete)
!

NewBalloonMorph class removeSelector: #defaultBalloonTextColor!
NewBalloonMorph class removeSelector: #defaultBalloonTextColor:!
NewBalloonMorph removeSelector: #defaultBorderColor!
NewBalloonMorph removeSelector: #defaultBorderWidth!
NewBalloonMorph removeSelector: #defaultColor!
Morph subclass: #NewBalloonMorph
	instanceVariableNames: 'balloonOwner textMorph maximumWidth orientation hasTail'
	classVariableNames: 'UseNewBalloonMorph'
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!MorphicUIManager reorganize!
('ui requests' chooseClassOrTrait:from: chooseDirectory:from: chooseFileMatching:label: chooseFont:for:setSelector:getSelector: chooseFrom:lines:title: chooseFrom:values:lines:title: chooseFromOrAddTo:lines:title: chooseMultipleFrom:lines:title: chooseMultipleFrom:values:lines:title: confirm: confirm:orCancel: confirm:orCancel:title: confirm:title: confirm:title:trueChoice:falseChoice: confirm:trueChoice:falseChoice: displayProgress:at:from:to:during: edit:label:accept: inform: informUserDuring: multiLineRequest:centerAt:initialAnswer:answerHeight: request:initialAnswer: request:initialAnswer:centerAt: requestPassword:)
!

ListChooser removeSelector: #buildButtonBarWith:!
ListChooser removeSelector: #buildListMorphWith:!
ListChooser removeSelector: #buildSearchMorphWith:!
ListChooser removeSelector: #buildWindowWith:!
ListChooser removeSelector: #buildWindowWith:specs:!
ListChooser removeSelector: #handlesKeyboard:!
ListChooser removeSelector: #keyStroke:!
ListChooser removeSelector: #keyStrokeFromList:!
ListChooser removeSelector: #list!
ListChooser removeSelector: #list:!
ListChooser removeSelector: #list:title:!
ListChooser removeSelector: #move:!
ListChooser removeSelector: #moveWindowNear:!
ListChooser removeSelector: #realIndex!
ListChooser removeSelector: #updateFilter!

!ListChooser reorganize!
('event handling' filterEvent:for:)
('building' buildWith: initialExtent)
('testing' canAccept canAcceptOrAdd canAdd)
('initialize-release' chooseIndexFrom:title: chooseIndexFrom:title:addAllowed: chooseItemFrom:title:addAllowed:)
('accessing' addAllowed addAllowed: items items: result result: searchText searchText: selectedIndex selectedIndex: selectedItem textSelection title title:)
('actions' accept acceptText: add cancel closed)
('colors' acceptColor acceptLabel addColor cancelColor)
('updating' applyUserInterfaceTheme)
!

FillInTheBlankMorph class removeSelector: #roundedDialogCorners!
FillInTheBlankMorph class removeSelector: #roundedDialogCorners:!

!FillInTheBlankMorph class reorganize!
('default constants' defaultAnswerExtent)
('instance creation' request: request:initialAnswer: request:initialAnswer:centerAt: request:initialAnswer:centerAt:inWorld: request:initialAnswer:centerAt:inWorld:onCancelReturn: request:initialAnswer:centerAt:inWorld:onCancelReturn:acceptOnCR: request:initialAnswer:centerAt:inWorld:onCancelReturn:acceptOnCR:answerExtent: request:initialAnswer:centerAt:inWorld:onCancelReturn:acceptOnCR:answerHeight: requestPassword: requestPassword:initialAnswer:centerAt:inWorld:onCancelReturn:acceptOnCR:)
!

FillInTheBlankMorph removeSelector: #accept!
FillInTheBlankMorph removeSelector: #cancel!
FillInTheBlankMorph removeSelector: #convertToCurrentVersion:refStream:!
FillInTheBlankMorph removeSelector: #createAcceptButton!
FillInTheBlankMorph removeSelector: #createCancelButton!
FillInTheBlankMorph removeSelector: #createQueryTextMorph:!
FillInTheBlankMorph removeSelector: #createTextPaneExtent:acceptBoolean:topOffset:buttonAreaHeight:!
FillInTheBlankMorph removeSelector: #defaultColor!
FillInTheBlankMorph removeSelector: #delete!
FillInTheBlankMorph removeSelector: #extent:!
FillInTheBlankMorph removeSelector: #getUserResponse!
FillInTheBlankMorph removeSelector: #handlesMouseDown:!
FillInTheBlankMorph removeSelector: #morphicLayerNumber!
FillInTheBlankMorph removeSelector: #mouseDown:!
FillInTheBlankMorph removeSelector: #responseUponCancel:!
FillInTheBlankMorph removeSelector: #undoGrabCommand!
FillInTheBlankMorph removeSelector: #updateColor!
FillInTheBlankMorph removeSelector: #updateColor:color:intensity:!
DialogWindow subclass: #FillInTheBlankMorph
	instanceVariableNames: 'response done textPane responseUponCancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!FillInTheBlankMorph reorganize!
('accessing' response response: selectionInterval textPane)
('initialization' createTextPaneAcceptOnCR: initialize setDefaultParameters setPasswordQuery:initialAnswer:answerHeight:acceptOnCR: setQuery:initialAnswer:answerExtent:acceptOnCR: setQuery:initialAnswer:answerHeight:acceptOnCR:)
('menu' codePaneMenu:shifted:)
('*services-base' selection)
('events' filterEvent:for:)
!

DialogWindow class removeSelector: #gradientWindow:!
DialogWindow removeSelector: #titleGradientFrom:!
"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

SystemProgressMorph reset.
!

