'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:23 pm'!
Morph subclass: #PluggableButtonMorph
	instanceVariableNames: 'model label font getStateSelector actionSelector getLabelSelector getMenuSelector shortcutCharacter askBeforeChanging triggerOnMouseDown offColor onColor feedbackColor showSelectionFeedback allButtons arguments argumentsProvider argumentsSelector style labelOffset hoverColor textColor borderColor '
	classVariableNames: 'GradientButton RoundedButtonCorners '
	poolDictionaries: ''
	category: 'Morphic-Pluggable Widgets'!
PluggableButtonMorph subclass: #PluggableButtonMorphPlus
	instanceVariableNames: 'enabled action getColorSelector getEnabledSelector updateMap disabledColor disabledTextColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/22/2016 15:32'!
feedbackColor
	^ feedbackColor! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 12:34'!
label: aStringOrTextOrMorph

	label = aStringOrTextOrMorph ifTrue: [^ self].
	label := aStringOrTextOrMorph isString
		ifFalse: [aStringOrTextOrMorph asMorph]
		ifTrue: [aStringOrTextOrMorph].
	
	self updateMinimumExtent.
	self changed.! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/27/2016 10:01'!
labelOffset
	^ labelOffset ifNil: [0@0]! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/27/2016 10:01'!
labelOffset: aPoint
	labelOffset := aPoint.! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/22/2016 15:14'!
offColor: colorWhenOff
	"Set the fill colors to be used when this button is off."

	| cc |
	cc := colorWhenOff isTransparent ifTrue: [(Color gray: 0.9) alpha: 0.5] ifFalse: [colorWhenOff].
	self
		onColor: ((self userInterfaceTheme selectionModifier ifNil: [ [:c | c adjustBrightness: -0.2] ]) value: cc)
		offColor: cc
! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/22/2016 15:07'!
onColor: colorWhenOn offColor: colorWhenOff
	"Set the fill colors to be used when this button is on/off."

	onColor := colorWhenOn.
	offColor := colorWhenOff.
	
	hoverColor := (self userInterfaceTheme hoverModifier ifNil: [ [:c | c adjustBrightness: -0.1] ]) value: offColor.
	feedbackColor := (self userInterfaceTheme feedbackModifier ifNil: [ [:c | c adjustBrightness: -0.3] ]) value: offColor.
	
	self updateFillStyle.! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/22/2016 15:34'!
textColor
	^ textColor ifNil: [Color black "old instances"]! !

!PluggableButtonMorph methodsFor: 'accessing' stamp: 'mt 7/22/2016 15:32'!
textColor: aColor
	textColor := aColor.
	self changed.! !

!PluggableButtonMorph methodsFor: 'copying' stamp: 'mt 7/28/2016 12:05'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  	Warning!!!!  Every instance variable defined in this class must be handled.  We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

super veryDeepInner: deepCopier.
"model := model.		Weakly copied"
label := label veryDeepCopyWith: deepCopier.
"getStateSelector := getStateSelector.		a Symbol"
"actionSelector := actionSelector.		a Symbol"
"getLabelSelector := getLabelSelector.		a Symbol"
"getMenuSelector := getMenuSelector.		a Symbol"
shortcutCharacter := shortcutCharacter veryDeepCopyWith: deepCopier.
askBeforeChanging := askBeforeChanging veryDeepCopyWith: deepCopier.
triggerOnMouseDown := triggerOnMouseDown veryDeepCopyWith: deepCopier.
offColor := offColor veryDeepCopyWith: deepCopier.
onColor := onColor veryDeepCopyWith: deepCopier.
feedbackColor := feedbackColor veryDeepCopyWith: deepCopier.
hoverColor := hoverColor veryDeepCopyWith: deepCopier.
borderColor := borderColor veryDeepCopyWith: deepCopier.
textColor := textColor veryDeepCopyWith: deepCopier.
labelOffset := labelOffset veryDeepCopyWith: deepCopier.
allButtons := nil.		"a cache"
arguments := arguments veryDeepCopyWith: deepCopier.
argumentsProvider := argumentsProvider veryDeepCopyWith: deepCopier.
"argumentsSelector := argumentsSelector.   a Symbol" 
style := style.  "a Symbol"! !

!PluggableButtonMorph methodsFor: 'drawing' stamp: 'mt 7/26/2016 10:53'!
drawLabelOn: aCanvas

	| fontToUse labelToUse labelWidth layoutBounds drawBlock |
	self label ifNil: [^ self].

	layoutBounds := self layoutBounds.
	labelToUse := self label asString.
	fontToUse := self font.
	
	"Support very narrow buttons. Shrink text to monogram then."
	(layoutBounds width < self labelShrinkThreshold and: [labelToUse size > 3]) ifTrue: [
		labelToUse := labelToUse first asString. "Show first character only."
		fontToUse := fontToUse emphasized: (TextEmphasis bold) emphasisCode].
	
	labelWidth := fontToUse widthOfString: labelToUse.

	drawBlock := [:c | c
			drawString: labelToUse
			at: (layoutBounds center x - (labelWidth // 2) max: (layoutBounds left)) 
				@ (layoutBounds center y - (fontToUse height // 2))
			font: fontToUse
			color: self textColorToUse].
		
	self clipSubmorphs
		ifTrue: [aCanvas clipBy: layoutBounds during: drawBlock]
		ifFalse: [drawBlock value: aCanvas]! !

!PluggableButtonMorph methodsFor: 'drawing' stamp: 'mt 7/27/2016 10:02'!
drawOn: aCanvas 

	(self fillStyle isColor not and: [self fillStyle isGradientFill])
		ifTrue: [self fillStyle origin: self topLeft; direction: 0@ self height].

	super drawOn: aCanvas.
	
	aCanvas
		translateBy: self labelOffset
		during: [:c |
			self label isMorph
				ifTrue: [self drawMorphLabelOn: c]
				ifFalse: [self drawLabelOn: c]].! !

!PluggableButtonMorph methodsFor: 'drawing' stamp: 'mt 7/26/2016 10:53'!
textColorToUse

	^ self textColor! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'mt 7/22/2016 14:33'!
mouseDown: evt
	"Details: If this button is triggered on mouse down or the event is the menu gesture, handle it immediately. Otherwise, make a list of buttons (including the receiver) for mouseMove feedback. This allows a simple radio-button effect among the button submorphs of a given morph."

	allButtons := nil.
	evt yellowButtonPressed ifTrue: [^ self invokeMenu: evt].
	triggerOnMouseDown
		ifTrue: [self performAction]
		ifFalse: [
			allButtons := owner submorphs select: [:m | m class = self class].
			self updateFillStyle: evt].
! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'mt 7/22/2016 14:34'!
mouseEnter: evt

	self updateFillStyle: evt.! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'mt 7/22/2016 14:34'!
mouseLeave: evt

	self updateFillStyle: evt.! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'mt 7/22/2016 14:34'!
mouseMove: evt

	allButtons ifNil: [^ self].
	allButtons do: [:m | m updateFillStyle: evt].! !

!PluggableButtonMorph methodsFor: 'event handling' stamp: 'mt 7/22/2016 14:35'!
mouseUp: evt

	self updateFillStyle: evt.
	
	allButtons ifNil: [^ self].
	allButtons do: [:m |
		(m containsPoint: evt cursorPoint) ifTrue: [m performAction]].
	allButtons := nil.
	self changed.
! !

!PluggableButtonMorph methodsFor: 'initialization' stamp: 'mt 7/23/2016 10:31'!
initialize

	super initialize.

	"Layout properties."
	self
		extent: 20 @ 15;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: (4@0 corner: 4@0);
		clipSubmorphs: true;
		wrapCentering: #center;
		cellPositioning: #topCenter.
	
	"Initialize instance variables."
	model := nil.
	label := nil.
	getStateSelector := nil.
	actionSelector := nil.
	getLabelSelector := nil.
	getMenuSelector := nil.
	shortcutCharacter := nil.
	askBeforeChanging := false.
	triggerOnMouseDown := false.
	allButtons := nil.
	argumentsProvider := nil.
	argumentsSelector := nil.
	
	self setDefaultParameters.
! !

!PluggableButtonMorph methodsFor: 'initialization' stamp: 'mt 7/23/2016 10:41'!
on: anObject getState: getStateSel action: actionSel label: labelSel menu: menuSel

	self model: anObject.
	getStateSelector := getStateSel.
	actionSelector := actionSel.
	getLabelSelector := labelSel.
	getMenuSelector := menuSel.
	
	self update: labelSel.
	self update: getStateSel.
	self updateFillStyle.! !

!PluggableButtonMorph methodsFor: 'initialization' stamp: 'mt 7/22/2016 15:34'!
setDefaultParameters
	"change the receiver's appareance parameters"

	self
		color: (self userInterfaceTheme color ifNil: [Color gray: 0.91]);
		borderStyle: (self userInterfaceTheme borderStyle ifNil: [BorderStyle default]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color gray]);
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]);
		font: (self userInterfaceTheme font ifNil: [TextStyle defaultFont]);
		textColor: (self userInterfaceTheme textColor ifNil: [Color black]).

	borderColor := self borderColor.
	self	offColor: self color.! !

!PluggableButtonMorph methodsFor: 'updating' stamp: 'mt 7/22/2016 14:33'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	self setDefaultParameters.! !

!PluggableButtonMorph methodsFor: 'updating' stamp: 'mt 7/23/2016 10:34'!
update: aParameter 

	getLabelSelector ifNotNil: [:sel |
		aParameter == sel ifTrue: [self label: (model perform: sel)]].
	getStateSelector ifNotNil: [:sel |
		aParameter == sel ifTrue: [self updateFillStyle]].! !

!PluggableButtonMorph methodsFor: 'updating' stamp: 'mt 7/22/2016 14:32'!
updateFillStyle

	self
		updateFillStylePressing: false
		hovering: false.! !

!PluggableButtonMorph methodsFor: 'updating' stamp: 'mt 7/22/2016 15:08'!
updateFillStyle: evt

	self
		updateFillStylePressing: (evt redButtonPressed and: [self containsPoint: evt position])
		hovering: (evt redButtonPressed not and: [self containsPoint: evt position]).! !

!PluggableButtonMorph methodsFor: 'updating' stamp: 'mt 7/27/2016 10:01'!
updateFillStylePressing: isPressing hovering: isHovering

	| gradient cc |
	"Migrate old instances."
	hoverColor ifNil: [hoverColor := onColor darker].
	
	self labelOffset: (isPressing ifTrue: [1@1] ifFalse: [0@0]).
	
	self getModelState
		ifTrue: [self color: onColor]
		ifFalse: [self color: offColor].
	self borderColor: borderColor.
	
	self class gradientButton ifFalse: [
		isPressing ifTrue: [
			self color: feedbackColor.
			self borderColor: feedbackColor muchDarker].
		isHovering ifTrue: [
			self color: hoverColor.
			self borderColor: borderColor].
		^ self].
	
	isPressing ifTrue: [
		cc := feedbackColor.
		self borderColor: feedbackColor muchDarker.
		gradient := GradientFillStyle ramp: {
			0.0 -> cc muchDarker.
			0.1-> (cc adjustBrightness: -0.2).
			0.5 -> cc.
			0.9-> (cc adjustBrightness: -0.1).
			1 -> cc muchDarker}].
	isHovering ifTrue: [
		cc := hoverColor.
		gradient := GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (cc adjustBrightness: 0.05).
			0.6 -> (cc darker)}].
	gradient ifNil: [
		cc := self color.
		gradient := GradientFillStyle ramp: {
			0.0 -> Color white.
			0.1-> (cc adjustBrightness: 0.05).
			0.6 -> (cc darker)}].
		
	gradient origin: bounds topLeft.
	gradient direction: 0@self height.
	
	self fillStyle: gradient.! !


!PluggableButtonMorph class methodsFor: 'preferences' stamp: 'mt 7/25/2016 13:43'!
gradientButton: aBoolean

	GradientButton = aBoolean ifTrue: [^ self].
	GradientButton := aBoolean.
	
	PluggableButtonMorph allSubInstancesDo: [:ea | ea updateFillStyle].! !

!PluggableButtonMorph class methodsFor: 'preferences' stamp: 'mt 7/22/2016 15:24'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the button''s border.' }.
		{ #borderWidth. 'Borders'. 'Width of the button''s border.' }.
		{ #borderStyle. 'Borders'. 'Whether to use a plain border, inset, or outset.' }.
		{ #color. 'Colors'. 'Background color of the button.' }.

		{ #font. 'Fonts'. 'Font for button title.' }.
		{ #textColor. 'Colors'. 'Color for the button title label.' }.
	}! !


!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'mt 7/22/2016 14:59'!
enabled: aBool
	enabled := aBool.
	self updateFillStyle.! !

!PluggableButtonMorphPlus methodsFor: 'accessing' stamp: 'mt 7/23/2016 10:51'!
getEnabledSelector: aSymbol
	getEnabledSelector := aSymbol.
	self update: getEnabledSelector.! !

!PluggableButtonMorphPlus methodsFor: 'initialize-release' stamp: 'mt 7/23/2016 10:54'!
initialize

	enabled := true.
	super initialize.! !

!PluggableButtonMorphPlus methodsFor: 'initialize-release' stamp: 'mt 7/26/2016 10:55'!
setDefaultParameters

	super setDefaultParameters.
	
	disabledColor := (self userInterfaceTheme disabledColor ifNil: [Color transparent]).
	disabledTextColor := (self userInterfaceTheme disabledTextColor ifNil: [Color gray: 0.6]).
	
	! !

!PluggableButtonMorphPlus methodsFor: 'initialize-release' stamp: 'mt 7/26/2016 10:53'!
updateFillStylePressing: isPressing hovering: isHovering

	enabled ifFalse: [
		self color: (disabledColor ifNil: [Color transparent]).
		self borderColor: Color transparent.
		^ self].
	
	super updateFillStylePressing: isPressing hovering: isHovering.! !

!PluggableButtonMorphPlus methodsFor: 'event handling' stamp: 'mt 7/23/2016 10:27'!
handlesMouseDown: evt
	^ enabled! !

!PluggableButtonMorphPlus methodsFor: 'event handling' stamp: 'mt 7/23/2016 10:28'!
handlesMouseOver: evt
	^ enabled! !

!PluggableButtonMorphPlus methodsFor: 'event handling' stamp: 'mt 7/23/2016 10:28'!
handlesMouseOverDragging: evt
	^ enabled! !

!PluggableButtonMorphPlus methodsFor: 'updating' stamp: 'mt 7/22/2016 15:29'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.! !

!PluggableButtonMorphPlus methodsFor: 'updating' stamp: 'mt 7/23/2016 10:56'!
update: what

	super update: what.
		
	getColorSelector ifNotNil: [:sel |
		what == sel ifTrue: [self offColor: (model perform: sel)]].

	getEnabledSelector ifNotNil: [:sel |
		what == sel ifTrue: [self enabled: (model perform: sel)]].

	updateMap ifNotNil:
		[(updateMap at: what ifAbsent: [])
			ifNotNilDo: [ :newTarget | self update: newTarget]].
! !

!PluggableButtonMorphPlus methodsFor: 'drawing' stamp: 'mt 7/26/2016 10:55'!
textColorToUse

	^ self enabled
		ifTrue: [super textColorToUse]
		ifFalse: [disabledTextColor ifNil: [Color gray: 0.6]]! !


!PluggableButtonMorphPlus class methodsFor: 'preferences' stamp: 'mt 7/26/2016 10:49'!
themeProperties

	^ super themeProperties, {
		{ #disabledColor. 'Colors'. 'Color when button cannot be clicked.' }.
		{ #disabledTextColor. 'Colors'. 'Color for label when button cannot be clicked.' }.
	}! !

PluggableButtonMorphPlus removeSelector: #mouseDown:!
PluggableButtonMorphPlus removeSelector: #mouseMove:!
PluggableButtonMorphPlus removeSelector: #mouseUp:!
PluggableButtonMorphPlus removeSelector: #onColor:offColor:!
PluggableButtonMorph subclass: #PluggableButtonMorphPlus
	instanceVariableNames: 'enabled action getColorSelector getEnabledSelector updateMap disabledColor disabledTextColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ToolBuilder-Morphic'!

!PluggableButtonMorphPlus reorganize!
('accessing' action action: enabled enabled: getColorSelector getColorSelector: getEnabledSelector getEnabledSelector:)
('action' performAction)
('initialize-release' initialize setDefaultParameters updateFillStylePressing:hovering:)
('event handling' handlesMouseDown: handlesMouseOver: handlesMouseOverDragging:)
('updating' applyUserInterfaceTheme update: updateMap whenChanged:update:)
('drawing' textColorToUse)
!

PluggableButtonMorph removeSelector: #defaultBorderWidth!
PluggableButtonMorph removeSelector: #defaultColor!
PluggableButtonMorph removeSelector: #drawBackgroundOn:!
PluggableButtonMorph removeSelector: #updateFeedbackForEvt:!
Morph subclass: #PluggableButtonMorph
	instanceVariableNames: 'model label font getStateSelector actionSelector getLabelSelector getMenuSelector shortcutCharacter askBeforeChanging triggerOnMouseDown offColor onColor feedbackColor showSelectionFeedback allButtons arguments argumentsProvider argumentsSelector style hoverColor borderColor textColor labelOffset'
	classVariableNames: 'GradientButton RoundedButtonCorners'
	poolDictionaries: ''
	category: 'Morphic-Pluggable Widgets'!

!PluggableButtonMorph reorganize!
('accessing' action: actionSelector askBeforeChanging askBeforeChanging: enabled feedbackColor feedbackColor: font font: label label: label:font: labelOffset labelOffset: model: offColor offColor: onColor:offColor: performAction shortcutCharacter shortcutCharacter: style style: textColor textColor: triggerOnMouseDown triggerOnMouseDown:)
('arguments' arguments: argumentsProvider:argumentsSelector:)
('copying' veryDeepFixupWith: veryDeepInner:)
('drawing' drawLabelOn: drawMorphLabelOn: drawOn: labelShrinkThreshold textColorToUse)
('event handling' handlesMouseDown: handlesMouseOver: handlesMouseOverDragging: mouseDown: mouseEnter: mouseLeave: mouseLeaveDragging: mouseMove: mouseUp:)
('initialization' initialize on:getState:action:label:menu: setDefaultParameters)
('updating' applyUserInterfaceTheme update: updateFillStyle updateFillStyle: updateFillStylePressing:hovering:)
('private' getMenu: getModelState invokeMenu:)
('browse' browseAllImplementorsOfActionSelector buildDebugMenu:)
('rounding' wantsRoundedCorners)
('layout' updateMinimumExtent)
('layout-properties' hResizing: vResizing:)
!

