'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:22 pm'!
Object subclass: #NewParagraph
	instanceVariableNames: 'text textStyle firstCharacterIndex container lines positionWhenComposed offsetToEnd maxRightX selectionStart selectionStop wantsColumnBreaks focused caretRect showCaret selectionColor caretColor unfocusedSelectionColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Text Support'!
ScrollPane subclass: #SimpleHierarchicalListMorph
	instanceVariableNames: 'selectedMorph hoveredMorph getListSelector keystrokeActionSelector autoDeselect columns columnsCache sortingSelector getSelectionSelector setSelectionSelector potentialDropMorph lineColor textColor font '
	classVariableNames: 'WrappedNavigation '
	poolDictionaries: ''
	category: 'Morphic-Explorer'!

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:24'!
filterColor

	^ self valueOfProperty: #filterColor ifAbsent: [Color yellow]! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 11:41'!
filterColor: aColor

	| cc fill |
	cc := aColor.

	MenuMorph gradientMenu
		ifFalse: [fill := SolidFillStyle color: cc]
		ifTrue: [
			fill := GradientFillStyle ramp: { 
				0.0 -> cc twiceLighter. 
				1 -> cc twiceDarker }].
			
	self setProperty: #filterColor toValue: fill.! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:25'!
filterTextColor

	^ self valueOfProperty: #filterTextColor ifAbsent: [Color black]! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:25'!
filterTextColor: aColor

	self setProperty: #filterTextColor toValue: aColor.! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/26/2016 12:58'!
fitContents

	super fitContents.
	self width: container preferredSubmorphWidth.! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:46'!
highlightTextColor

	^ self valueOfProperty: #highlightTextColor ifAbsent: [Color red]! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:46'!
highlightTextColor: aColor

	self setProperty: #highlightTextColor toValue: aColor.! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:38'!
hoverColor

	^ self valueOfProperty: #hoverColor ifAbsent: [Color veryLightGray]! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:33'!
hoverColor: aColor

	self setProperty: #hoverColor toValue: aColor.! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:26'!
selectionColor

	^ self valueOfProperty: #selectionColor ifAbsent: [Color blue]! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 11:42'!
selectionColor: aColor

	| cc fill |
	cc := aColor.

	MenuMorph gradientMenu
		ifFalse: [fill := SolidFillStyle color: cc]
		ifTrue: [
			fill := GradientFillStyle ramp: { 
				0.0 -> cc twiceLighter. 
				1 -> cc twiceDarker }].

	self setProperty: #selectionColor toValue: fill.! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:26'!
selectionTextColor

	^ self valueOfProperty: #selectionTextColor ifAbsent: [Color white]! !

!IndentingListItemMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:26'!
selectionTextColor: aColor

	self setProperty: #selectionTextColor toValue: aColor.! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'mt 7/26/2016 13:05'!
colorToUse

	^ (self valueOfProperty: #wasRefreshed ifAbsent: [false])
		ifTrue: [complexContents highlightColor ifNil: [self highlightTextColor]]
		ifFalse: [
			self isSelected ifTrue: [^ self selectionTextColor].			
			complexContents preferredColor ifNil: [self color]]! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 10:36'!
drawHoverOn: aCanvas 

	aCanvas
		fillRectangle: self bounds
		color: self hoverColor.! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 10:05'!
drawOn: aCanvas
	
	| tRect sRect columnScanner columnLeft |
	self backgroundColor ifNotNil: [:c |
		aCanvas fillRectangle: self innerBounds color: c].

	tRect := self toggleRectangle.	
	self drawToggleOn: aCanvas in: tRect.

	sRect := bounds withLeft: tRect right + self hMargin.
	sRect := sRect top: sRect top + sRect bottom - self fontToUse height // 2.	
	
	(container columns isNil or: [(contents asString indexOf: Character tab) = 0]) ifTrue: [
		icon ifNotNil: [
			aCanvas
				translucentImage: icon
				at: sRect left @ (self top + (self height - icon height // 2)).
			sRect := sRect left: sRect left + icon width + 2.
		].
		
		aCanvas drawString: contents asString in: sRect font: self fontToUse color: self colorToUse.
	
	] ifFalse: [
		columnLeft := sRect left.
		columnScanner := ReadStream on: contents asString.
		container columns withIndexDo: [ :widthSpec :column | | columnRect columnData columnWidth |
			"Draw icon."
			column = self class iconColumnIndex ifTrue: [
				icon ifNotNil: [
					aCanvas
						translucentImage: icon
						at: columnLeft @ (self top + (self height - icon height // 2)).
					columnLeft := columnLeft + icon width + 2]].

			columnWidth := self widthOfColumn: column.
			columnRect := columnLeft @ sRect top extent: columnWidth @ sRect height.
			columnData := columnScanner upTo: Character tab.
			
			"Draw string."
			columnData ifNotEmpty: [
				aCanvas drawString: columnData in: columnRect font: self fontToUse color: self colorToUse].

			"Compute next column offset."			
			columnLeft := columnRect right + 5.
			column = 1 ifTrue: [columnLeft := columnLeft - tRect right + self left].
			
		].
	]! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 11:43'!
drawSelectionOn: aCanvas 

	| fill |
	fill := self selectionColor isColor
		ifTrue: [SolidFillStyle color: self selectionColor]
		ifFalse: [self selectionColor].
	fill isGradientFill ifTrue: [
		fill origin: self topLeft.
		fill direction: 0@ self height].

	aCanvas
		fillRectangle: self bounds
		fillStyle: fill.! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 10:04'!
highlight

	self changed.
	
! !

!IndentingListItemMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 10:04'!
unhighlight

	self changed.
	
	
! !

!IndentingListItemMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 12:59'!
refresh

	self contents: self getLabel.
	icon := self getIcon.
	
	(self valueOfProperty: #wasRefreshed ifAbsent: [false]) ifFalse: [
		self setProperty: #wasRefreshed toValue: true].! !

!IndentingListItemMorph methodsFor: 'testing' stamp: 'mt 7/26/2016 10:35'!
isSelected

	^ container ifNil: [false] ifNotNil: [container selectedMorph == self]! !


!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 17:45'!
filterColor
	^ self valueOfProperty: #filterColor ifAbsent: [Color yellow]! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 11:29'!
filterColor: aColor

	| cc fill |
	cc := aColor.

	MenuMorph gradientMenu
		ifFalse: [fill := SolidFillStyle color: cc]
		ifTrue: [
			fill := GradientFillStyle ramp: { 
				0.0 -> cc twiceLighter. 
				1 -> cc twiceDarker }].

	self setProperty: #filterColor toValue: fill! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 17:45'!
filterTextColor
	^ self valueOfProperty: #filterTextColor ifAbsent: [Color black]! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 17:38'!
hoverColor
	^ self valueOfProperty: #hoverColor ifAbsent: [Color veryVeryLightGray]! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 17:34'!
preSelectionColor
	^ self valueOfProperty: #preSelectionColor ifAbsent: [Color gray]! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 17:34'!
selectionColor
	^ self valueOfProperty: #selectionColor ifAbsent: [Color blue]! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 11:31'!
selectionColor: aColor

	| cc fill |
	cc := aColor.

	MenuMorph gradientMenu
		ifFalse: [fill := SolidFillStyle color: cc]
		ifTrue: [
			fill := GradientFillStyle ramp: { 
				0.0 -> cc twiceLighter. 
				1 -> cc twiceDarker }].

	self setProperty: #selectionColor toValue: fill! !

!LazyListMorph methodsFor: 'accessing' stamp: 'mt 7/23/2016 17:35'!
selectionTextColor
	^ self valueOfProperty: #selectionTextColor ifAbsent: [Color white]! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/23/2016 17:35'!
colorForRow: row
	
	^(selectedRow notNil and: [ row = selectedRow])
		ifTrue: [ self selectionTextColor ]
		ifFalse: [ self color ].! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 11:03'!
display: item atRow: row on: canvas
	"display the given item at row row"

	| drawBounds emphasized rowColor itemAsText |
	itemAsText := item asStringOrText.
	
	"If it is a text, we will only use the first character's emphasis."
	emphasized := itemAsText isText 
		ifTrue: [font emphasized: (itemAsText emphasisAt: 1)] 
		ifFalse: [font].
	
	rowColor := itemAsText isText
		ifTrue: [itemAsText colorAt: 1 ifNone: [self colorForRow: row]]
		ifFalse: [self colorForRow: row].
	
	drawBounds := (self drawBoundsForRow: row) translateBy: (self hMargin @ 0).
	drawBounds := drawBounds intersect: self bounds.

	"Draw icon if existing. Adjust draw bounds in that case."
	(self icon: row) ifNotNil: [ :icon || top |
		top := drawBounds top + ((drawBounds height - icon height) // 2).
		canvas translucentImage: icon at: drawBounds left @ top.
		drawBounds := drawBounds left: drawBounds left + icon width + 2 ].
		
	"We will only draw strings here."
	canvas
		drawString: itemAsText asString
		in: drawBounds
		font: emphasized
		color: rowColor.

	"Draw filter matches if any."
	self
		displayFilterOn: canvas
		for: row
		in: drawBounds
		font: emphasized.! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 11:28'!
displayFilterOn: canvas for: row in: drawBounds font: font
	"Draw filter matches if any."
	
	| fill |
	fill := self filterColor isColor
		ifTrue: [SolidFillStyle color: self filterColor]
		ifFalse: [self filterColor].
	fill isGradientFill ifTrue: [
		fill origin: drawBounds topLeft.
		fill direction: 0@ drawBounds height].
	
	(self filterOffsets: row) do: [:offset | | r |
		r := ((drawBounds left + offset first first) @ drawBounds top corner: (drawBounds left + offset first last) @ drawBounds bottom).
		canvas
			frameAndFillRoundRect: (r outsetBy: 1@0)
			radius: 3
			fillStyle: fill
			borderWidth: 1
			borderColor: fill asColor twiceDarker.
		canvas
			drawString: offset second
			in: r
			font: font
			color: self filterTextColor].! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/26/2016 11:30'!
drawBackgroundForMulti: row on: aCanvas 
	"shade the background paler, if this row is selected, but not the current selected row"
	| selectionDrawBounds thisColor |
	thisColor := selectedRow = row
		ifTrue: [ self selectionColor asColor darker ]
		ifFalse: [ self selectionColor asColor ].
	selectionDrawBounds := self drawBoundsForRow: row.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	aCanvas
		fillRectangle: selectionDrawBounds
		color: thisColor! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 11:07'!
drawOn: aCanvas

	| topRow bottomRow hasMultiSelection |
	listItems ifEmpty: [ ^self ].
	
	self drawPreSelectionOn: aCanvas.
	
	topRow := self topVisibleRowForCanvas: aCanvas.
	bottomRow := self bottomVisibleRowForCanvas: aCanvas.

	"Draw multi-selection."
	hasMultiSelection := false.
	topRow to: bottomRow do: [ :row |
		(listSource itemSelectedAmongMultiple: row) ifTrue: [
			hasMultiSelection := true.
			self drawBackgroundForMulti: row on: aCanvas ] ].
	hasMultiSelection ifFalse: [self drawSelectionOn: aCanvas].

	"Draw hovered row if preference enabled."
	PluggableListMorph highlightHoveredRow ifTrue: [
		listSource hoverRow > 0 ifTrue: [
			self highlightHoverRow: listSource hoverRow on: aCanvas ] ].

	"Draw all visible rows."
	topRow to: bottomRow do: [ :row |
		self display: (self item: row) atRow: row on: aCanvas ].

	"Finally, highlight drop row for drag/drop operations.."
	listSource potentialDropRow > 0 ifTrue: [
		self highlightPotentialDropRow: listSource potentialDropRow on: aCanvas ].! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/23/2016 17:35'!
drawPreSelectionOn: aCanvas
	
	self 
		drawSelectionFor: preSelectedRow
		withColor: self preSelectionColor 
		on: aCanvas! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 11:32'!
drawSelectionFor: index withColor: color on: aCanvas
	
	| selectionDrawBounds fill |
	index ifNil: [ ^self ].
	index = 0 ifTrue: [ ^self ].
	selectionDrawBounds := self drawBoundsForRow: index.
	selectionDrawBounds := selectionDrawBounds intersect: self bounds.
	
	fill := color isColor
		ifTrue: [SolidFillStyle color: color]
		ifFalse: [color].
	fill isGradientFill ifTrue: [
		fill origin: selectionDrawBounds topLeft.
		fill direction: 0@ selectionDrawBounds height].
	
	aCanvas fillRectangle: selectionDrawBounds fillStyle: fill.! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/23/2016 17:35'!
drawSelectionOn: aCanvas
	
	self 
		drawSelectionFor: selectedRow 
		withColor: self selectionColor 
		on: aCanvas! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/23/2016 17:38'!
highlightHoverRow: row on: aCanvas
	| drawBounds  |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	aCanvas fillRectangle: drawBounds color: self hoverColor.! !

!LazyListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 11:34'!
highlightPotentialDropRow: row  on: aCanvas
	| drawBounds  |
	drawBounds := self drawBoundsForRow: row.
	drawBounds := drawBounds intersect: self bounds.
	aCanvas frameRectangle: drawBounds color: self selectionColor asColor! !

!LazyListMorph methodsFor: 'list access' stamp: 'mt 7/23/2016 17:54'!
getFilterOffsets: row
	"Calculate matching character indexes for the current filter term."
	
	| item filter offsets currentIndex sub |
	filter := listSource filterTerm.
	filter ifEmpty: [^ Array empty].

	item := (self item: row) asStringOrText asString. "See row drawing. Strings only."
	offsets := OrderedCollection new.
	
	currentIndex := 1.
	[currentIndex > 0] whileTrue: [
		currentIndex := item findString: filter startingAt: currentIndex caseSensitive: false.
		currentIndex > 0 ifTrue: [ | left width |
			left := font widthOfString: item from: 1 to: currentIndex-1.
			sub := item copyFrom: currentIndex to: currentIndex + filter size - 1.
			width := font widthOfString: sub.
			offsets addLast: {(left to: left + width). sub}.
			currentIndex := currentIndex + 1] ].
	^ offsets! !

!LazyListMorph methodsFor: 'list access' stamp: 'mt 7/23/2016 17:52'!
resetFilterOffsets
	
	listFilterOffsets := nil.! !


!ListItemWrapper methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:47'!
highlightColor
	"You can override the current theme's default with a custom value."

	^ nil! !

!ListItemWrapper methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:06'!
preferredColor
	"You can override the current theme's default with a custom value."
	
	^ nil! !


!MorphicToolBuilder methodsFor: 'widgets optional' stamp: 'mt 7/26/2016 11:24'!
buildPluggableScrollPane: spec

	| widget panel |
	widget := self scrollPaneClass new.
	widget model: spec model.
	self register: widget id: spec name.
	
	spec children
		ifNotNil: [:obj |
			"Create panel morph to scroll it."
			panel := self pluggablePanelSpec new
				model: spec model;
				children: obj;
				layout: spec layout;
				horizontalResizing: (spec layout == #proportional ifTrue: [#rigid] ifFalse: [#shrinkWrap]);
				verticalResizing: (spec layout == #proportional ifTrue: [#rigid] ifFalse: [#shrinkWrap]);
				buildWith: self.
			widget morph: panel.
			]
		ifNil: [spec morph
			ifNotNil: [:m | widget morph: m]
			ifNil: [widget morphClass: spec morphClass]].
	
	self setFrame: spec frame in: widget.
	self setLayoutHintsFor: widget spec: spec.
	
	parent ifNotNil: [self add: widget to: parent].
	
	spec borderWidth ifNotNil: [:w | widget borderWidth: w].
	
	"Override default scroll bar policies if needed. Widget will use preference values otherwise."
	spec hScrollBarPolicy ifNotNil: [:policy |
		policy caseOf: {
			[#always] -> [widget alwaysShowHScrollBar].
			[#never] -> [widget hideHScrollBarIndefinitely].
			[#whenNeeded] -> [widget showHScrollBarOnlyWhenNeeded]}].
	spec vScrollBarPolicy ifNotNil: [:policy | 
		policy caseOf: {
			[#always] -> [widget alwaysShowVScrollBar].
			[#never] -> [widget hideVScrollBarIndefinitely].
			[#whenNeeded] -> [widget showVScrollBarOnlyWhenNeeded]}].
	
	^ widget! !

!MorphicToolBuilder methodsFor: 'widgets required' stamp: 'mt 7/23/2016 17:17'!
buildPluggableList: aSpec
	| widget listClass getIndex setIndex |
	aSpec getSelected ifNil:[
		listClass := self listClass.
		getIndex := aSpec getIndex.
		setIndex := aSpec setIndex.
	] ifNotNil:[
		listClass := self listByItemClass.
		getIndex := aSpec getSelected.
		setIndex := aSpec setSelected.
	].
	widget := listClass on: aSpec model
				list: aSpec list
				selected: getIndex
				changeSelected: setIndex
				menu: aSpec menu
				keystroke: aSpec keyPress.
	self register: widget id: aSpec name.
	
	"Override default scroll bar policies if needed. Widget will use preference values otherwise."
	aSpec hScrollBarPolicy ifNotNil: [:policy |
		policy caseOf: {
			[#always] -> [widget alwaysShowHScrollBar].
			[#never] -> [widget hideHScrollBarIndefinitely].
			[#whenNeeded] -> [widget showHScrollBarOnlyWhenNeeded]. } ].
	aSpec vScrollBarPolicy ifNotNil: [:policy |
		policy caseOf: {
			[#always] -> [widget alwaysShowVScrollBar].
			[#never] -> [widget hideVScrollBarIndefinitely].
			[#whenNeeded] -> [widget showVScrollBarOnlyWhenNeeded]. } ].	
	
	widget getListElementSelector: aSpec listItem.
	widget getListSizeSelector: aSpec listSize.
	widget getIconSelector: aSpec icon.
	widget getHelpSelector: aSpec helpItem.
	widget doubleClickSelector: aSpec doubleClick.
	
	widget dragItemSelector: aSpec dragItem.
	widget dropItemSelector: aSpec dropItem.
	widget wantsDropSelector: aSpec dropAccept.
	widget dragStartedSelector: aSpec dragStarted.
	
	widget autoDeselect: aSpec autoDeselect.
	widget keystrokePreviewSelector: aSpec keystrokePreview.
	
	aSpec color ifNotNil: [:c | widget color: c].
	self buildHelpFor: widget spec: aSpec. 
			
	self setFrame: aSpec frame in: widget.
	self setLayoutHintsFor: widget spec: aSpec.
	
	parent ifNotNil:[self add: widget to: parent].
	panes ifNotNil:[
		aSpec list ifNotNil:[panes add: aSpec list].
	].
	^widget! !

!MorphicToolBuilder methodsFor: 'widgets required' stamp: 'mt 7/23/2016 17:17'!
buildPluggableText: aSpec
	| widget |
	widget := self textPaneClass new.
	aSpec stylerClass ifNotNil: [:c | widget styler: (c new view: widget)].	
	widget
		on: aSpec model
		text: aSpec getText 
		accept: aSpec setText
		readSelection: aSpec selection 
		menu: aSpec menu.
	aSpec font ifNotNil: [:f | widget font: f].
	
	widget readOnly: aSpec readOnly.
	widget editTextSelector: aSpec editText.
	widget wantsFrameAdornments: aSpec indicateUnacceptedChanges.

	widget askBeforeDiscardingEdits: aSpec askBeforeDiscardingEdits.
	widget setProperty: #alwaysAccept toValue: aSpec askBeforeDiscardingEdits not.

	aSpec softLineWrap ifNotNil: [:b | widget wrapFlag: b].

	widget isAutoFit
		ifTrue: [widget hideHScrollBarIndefinitely]
		ifFalse: [widget showHScrollBarOnlyWhenNeeded].
	
	self register: widget id: aSpec name.
	widget getColorSelector: aSpec color.
	self buildHelpFor: widget spec: aSpec.
	 
	self setFrame: aSpec frame in: widget.
	self setLayoutHintsFor: widget spec: aSpec.
	
	parent ifNotNil:[self add: widget to: parent].
	^widget! !


!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 13:28'!
caretColor
	^ caretColor ifNil: [Color red]! !

!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 13:31'!
caretColor: aColor
	caretColor := aColor.! !

!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 13:53'!
caretWidth
	^ Editor dumbbellCursor
		ifTrue: [ 3 ]
		ifFalse: [ 2 ]! !

!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 14:19'!
selectionColor
	^ selectionColor ifNil: [Color blue muchLighter]! !

!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 13:31'!
selectionColor: aColor
	selectionColor := aColor.! !

!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 13:30'!
unfocusedSelectionColor
	^ unfocusedSelectionColor ifNil: [Color gray: 0.9]! !

!NewParagraph methodsFor: 'access' stamp: 'mt 7/24/2016 13:31'!
unfocusedSelectionColor: aColor
	unfocusedSelectionColor := aColor.! !

!NewParagraph methodsFor: 'display' stamp: 'mt 7/24/2016 15:19'!
displayDumbbellCursorOn: aCanvas at: leftX in: line

	| w |
	w := 2.
	self focused ifFalse: [^ w].
	
	1 to: w
		do: 
			[:i | 
			"Draw caret triangles at top and bottom"

			aCanvas fillRectangle: ((leftX - w + i - 1) @ (line top + i - 1) 
						extent: ((w - i) * 2 + 3) @ 1)
				color: self caretColor.
			aCanvas fillRectangle: ((leftX - w + i - 1) @ (line bottom - i) 
						extent: ((w - i) * 2 + 3) @ 1)
				color: self caretColor].
	
	aCanvas
		line: leftX @ line top
		to: leftX @ (line bottom-1)
		color: self caretColor.
	
	^ w! !

!NewParagraph methodsFor: 'display' stamp: 'mt 7/24/2016 15:15'!
displaySelectionInLine: line on: aCanvas 
	| leftX rightX w |
	selectionStart ifNil: [^self].	"No selection"
	aCanvas isShadowDrawing ifTrue: [ ^self ].	"don't draw selection with shadow"
	selectionStart = selectionStop 
		ifTrue: 
			["Only show caret on line where clicked"

			selectionStart textLine ~= line ifTrue: [^self]]
		ifFalse:
			["Test entire selection before or after here"

			(selectionStop stringIndex < line first 
				or: [selectionStart stringIndex > (line last + 1)]) ifTrue: [^self].	"No selection on this line"
			(selectionStop stringIndex = line first 
				and: [selectionStop textLine ~= line]) ifTrue: [^self].	"Selection ends on line above"
			(selectionStart stringIndex = (line last + 1) 
				and: [selectionStop textLine ~= line]) ifTrue: [^self]].	"Selection begins on line below"
	leftX := (selectionStart stringIndex < line first 
				ifTrue: [line ]
				ifFalse: [selectionStart ])left.
	rightX := (selectionStop stringIndex > (line last + 1) or: 
					[selectionStop stringIndex = (line last + 1) 
						and: [selectionStop textLine ~= line]]) 
				ifTrue: [line right]
				ifFalse: [selectionStop left].
	selectionStart = selectionStop 
		ifTrue: [
			rightX := rightX + 1.
			caretRect := (leftX-2) @ line top corner: (rightX+2)@ line bottom. "sigh..."
			self showCaret ifFalse: [^self].
			w := (Editor dumbbellCursor
				ifTrue: [self displayDumbbellCursorOn: aCanvas at: leftX in: line]
				ifFalse: [self displaySimpleCursorOn: aCanvas at: leftX in: line]).
			caretRect := (leftX-w) @ line top corner: (rightX+w)@ line bottom]
		ifFalse: [
			caretRect := nil.
			aCanvas fillRectangle: (leftX @ line top corner: rightX @ line bottom)
				color: (self focused ifTrue: [self selectionColor] ifFalse: [self unfocusedSelectionColor])]! !

!NewParagraph methodsFor: 'display' stamp: 'mt 7/24/2016 15:19'!
displaySimpleCursorOn: aCanvas at: leftX in: line

	self focused ifFalse: [^ 1].
	
	aCanvas
		line: leftX @ (line top+1)
		to: leftX @ (line bottom-1)
		color: self caretColor.

	aCanvas
		line: leftX+1 @ (line top+1)
		to: leftX+1 @ (line bottom-1)
		color: (self caretColor alpha: 0.3).
	
	^ 1! !


!PluggableScrollPaneSpec methodsFor: 'accessing' stamp: 'mt 7/26/2016 11:24'!
borderWidth

	^ borderWidth! !


!PointerExplorerWrapper methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:06'!
preferredColor

	^self isWeakOnly
		ifTrue: [ Color gray ]
		ifFalse: [ super preferredColor ]! !


!ScrollPane methodsFor: 'accessing' stamp: 'mt 7/26/2016 15:43'!
borderWidth: aNumber 
	super borderWidth: aNumber.
	self resizeScroller; setScrollDeltas! !

!ScrollPane methodsFor: 'initialization' stamp: 'mt 7/23/2016 11:35'!
initialize
	
	"initialize the state of the receiver"
	super initialize.
	""
	self initializePreferences.
	hasFocus := false.
	self initializeScrollBars.
	""
	
	self extent: self defaultExtent.
	self
		resizeScrollBars;
		resizeScroller;
		hideOrShowScrollBars;
		updateMinimumExtent.
	
	self setDefaultParameters.
	self addKeyboardCaptureFilter: self.! !

!ScrollPane methodsFor: 'initialization' stamp: 'mt 7/23/2016 13:41'!
initializeScrollBars
	"Initialize vertical and horizontal scroll bars."

	(scrollBar := ScrollBar on: self getValue: nil setValue: #vScrollBarValue:)
			menuSelector: #vScrollBarMenuButtonPressed:;
			orientation: #vertical;
			extent: 1@1.
	(hScrollBar := ScrollBar on: self getValue: nil setValue: #hScrollBarValue:)
			menuSelector: #hScrollBarMenuButtonPressed:;
			orientation: #horizontal;
			extent: 1@1.

	""
	scroller := TransformMorph new color: Color transparent.
	scroller offset: 0 @ 0.
	self addMorph: scroller.
	""
	retractableScrollBar ifFalse: 
			[self 
				addMorph: scrollBar;
				addMorph: hScrollBar].
	self updateMinimumExtent.! !

!ScrollPane methodsFor: 'initialization' stamp: 'mt 7/23/2016 17:20'!
setDefaultParameters
	"change the receiver's appareance parameters"

	self
		color: (self userInterfaceTheme color ifNil: [Color white]);
		borderStyle: (self userInterfaceTheme borderStyle ifNil: [BorderStyle default]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color gray: 0.6]);
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]).! !

!ScrollPane methodsFor: 'updating' stamp: 'mt 7/23/2016 17:15'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	self setDefaultParameters.! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 11:28'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel menu: getMenuSel keystroke: keyActionSel 
	self model: anObject.
	getListSelector := getListSel.
	getIndexSelector := getSelectionSel.
	setIndexSelector := setSelectionSel.
	getMenuSelector := getMenuSel.
	keystrokeActionSelector := keyActionSel.
	autoDeselect := true.
	self updateList.
	self selectionIndex: self getCurrentSelectionIndex.
	self initForKeystrokes! !

!PluggableListMorph methodsFor: 'initialization' stamp: 'mt 7/25/2016 14:12'!
setDefaultParameters

	super setDefaultParameters.
	
	self
		font: (self userInterfaceTheme font ifNil: [TextStyle defaultFont]);
		textColor: (self userInterfaceTheme textColor ifNil: [Color black]).
		
	self setListParameters.! !

!PluggableListMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 10:16'!
setListParameters

	self listMorph
		selectionColor: (self userInterfaceTheme selectionColor ifNil: [Color r: 0.72 g: 0.72 b: 0.9]);
		setProperty: #selectionTextColor
			toValue: (self userInterfaceTheme selectionTextColor ifNil: [Color black]);
		filterColor: (self userInterfaceTheme filterColor ifNil: [Color yellow paler]);
		setProperty: #filterTextColor
			toValue: (self userInterfaceTheme filterTextColor ifNil: [Color black]);
		
		setProperty: #preSelectionColor
			toValue: ((self userInterfaceTheme preSelectionModifier ifNil: [ [:c | Color gray: 0.9] ]) value: self listMorph selectionColor asColor);
		setProperty: #hoverColor
			toValue: ((self userInterfaceTheme hoverSelectionModifier ifNil: [ [:c | c darker alpha: 0.3] ]) value: self listMorph selectionColor asColor)! !

!PluggableListMorph methodsFor: 'updating' stamp: 'mt 7/24/2016 10:23'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.! !

!PluggableListMorph methodsFor: 'filtering' stamp: 'mt 7/23/2016 17:19'!
indicateUnfiltered
	! !


!PluggableTextMorph methodsFor: 'accessing' stamp: 'mt 7/25/2016 11:31'!
adoptPaneColor: aColor

	super adoptPaneColor: aColor.
	
	self wrapBorderColor: ((self userInterfaceTheme wrapBorderColorModifier ifNil: [ [:c | c muchLighter alpha: 0.3] ])
								value: self borderColor).! !

!PluggableTextMorph methodsFor: 'accessing' stamp: 'mt 7/25/2016 11:27'!
wrapBorderColor

	^ self valueOfProperty: #wrapBorderColor ifAbsent: [Color gray alpha: 0.3]! !

!PluggableTextMorph methodsFor: 'accessing' stamp: 'mt 7/25/2016 11:27'!
wrapBorderColor: aColor

	self setProperty: #wrapBorderColor toValue: aColor.
	self changed.! !

!PluggableTextMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 14:27'!
drawFrameAdornmentsOn: aCanvas 
	"Include a thin red inset border for unaccepted edits, or, if the unaccepted edits are known to conflict with a change made somewhere else to the same method (typically), put a thick red frame"

	self wantsFrameAdornments ifFalse: [^ self].
	
	self readOnly ifTrue: [^ self drawFrameAdornment: (self valueOfProperty: #adornmentReadOnly ifAbsent: [Color black]) on: aCanvas].
	
	(model notNil and: [model refusesToAcceptCode])
		ifTrue: [
			"Put up feedback showing that code cannot be submitted in this state"
			^ self drawFrameAdornment: (self valueOfProperty: #adornmentRefuse ifAbsent: [Color tan]) on: aCanvas].
	
	self hasEditingConflicts
		ifTrue: [^ self drawFrameAdornment: (self valueOfProperty: #adornmentConflict ifAbsent: [Color red]) on: aCanvas].
		 
	self hasUnacceptedEdits ifTrue: [
		model wantsDiffFeedback
			ifTrue: [self drawFrameAdornment: (self valueOfProperty: #adornmentDiffEdit ifAbsent: [Color yellow]) on: aCanvas]
			ifFalse: [self drawFrameAdornment: (self valueOfProperty: #adornmentNormalEdit ifAbsent: [Color orange]) on: aCanvas].
		^ self].

	model wantsDiffFeedback
		ifTrue: [self drawFrameAdornment: (self valueOfProperty: #adornmentDiff ifAbsent: [Color green]) on: aCanvas].! !

!PluggableTextMorph methodsFor: 'drawing' stamp: 'mt 7/25/2016 11:32'!
drawWrapBorderOn: aCanvas

	| offset rect |
	self wantsWrapBorder ifFalse: [^ self].
	textMorph ifNil: [^ self].
	
	offset := textMorph margins isRectangle
		ifTrue: [textMorph margins left]
		ifFalse: [textMorph margins isPoint
			ifTrue: [textMorph margins x]
			ifFalse: [textMorph margins]].
	offset := offset + ((textMorph textStyle defaultFont widthOf: $x) * self class visualWrapBorderLimit).
	offset > self width ifTrue: [^ self].
	
	rect := scroller topLeft + (offset @ 0) corner: scroller bottomRight.

	aCanvas
		fillRectangle: rect
		color: self wrapBorderColor.
	aCanvas
		line: rect topLeft
		to: rect bottomLeft
		width: self borderStyle width
		color: (self wrapBorderColor muchDarker alpha: 0.5).! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'mt 7/24/2016 14:00'!
initialize

	self initializeTextMorph.
	super initialize.

	hasUnacceptedEdits := false.
	hasEditingConflicts := false.
	askBeforeDiscardingEdits := true.

	self minimumWidth: (TextStyle defaultFont widthOf: $m) * 10.
		
	scroller addMorph: textMorph.
	
	"Reset minExtent because only now we can anser #isAutoFit correctly."
	self minimumExtent: 0@0; updateMinimumExtent.! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'mt 7/24/2016 14:01'!
initializeTextMorph

	textMorph := self textMorphClass new
		margins: (3@0 corner: 0@0);
		setEditView: self;
		autoFit: true;
		setProperty: #indicateKeyboardFocus toValue: #never;
		yourself.! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'mt 7/26/2016 11:15'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel

	self model: anObject.
	getTextSelector := getTextSel.
	setTextSelector := setTextSel.
	getSelectionSelector := getSelectionSel.
	getMenuSelector := getMenuSel.
	self setText: self getText.
	self setSelection: self getSelection.! !

!PluggableTextMorph methodsFor: 'initialization' stamp: 'mt 7/25/2016 11:31'!
setDefaultParameters

	super setDefaultParameters.
	
	self
		font: (self userInterfaceTheme font ifNil: [TextStyle defaultFont]);
		setTextColor: (self userInterfaceTheme textColor ifNil: [Color black]).
	
	self wrapBorderColor: ((self userInterfaceTheme wrapBorderColorModifier ifNil: [ [:c | c muchLighter alpha: 0.3] ])
								value: self borderColor).
	
	self
		setProperty: #adornmentReadOnly
		toValue: (self userInterfaceTheme adornmentReadOnly ifNil: [Color black]);
		setProperty: #adornmentRefuse
		toValue: (self userInterfaceTheme adornmentRefuse ifNil: [Color tan]);
		setProperty: #adornmentConflict
		toValue: (self userInterfaceTheme adornmentConflict ifNil: [Color red]);
		setProperty: #adornmentDiff
		toValue: (self userInterfaceTheme adornmentDiff ifNil: [Color green]);
		setProperty: #adornmentNormalEdit
		toValue: (self userInterfaceTheme adornmentNormalEdit ifNil: [Color orange]);
		setProperty: #adornmentDiffEdit
		toValue: (self userInterfaceTheme adornmentDiffEdit ifNil: [Color yellow]).
	
	textMorph
		setProperty: #caretColor
		toValue: (self userInterfaceTheme caretColor ifNil: [Color red]);
		setProperty: #selectionColor
		toValue: (self userInterfaceTheme selectionColor ifNil: [TranslucentColor r: 0.0 g: 0.0 b: 0.8 alpha: 0.2]);
		setProperty: #unfocusedSelectionColor
		toValue: ((self userInterfaceTheme unfocusedSelectionModifier ifNil: [ [:c | Color gray: 0.9] ])
			value: textMorph selectionColor).! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'mt 7/24/2016 13:57'!
setText: aText

	textMorph newContents: aText.
	self hasUnacceptedEdits: false.
	self setScrollDeltas.	
	self changed. "Redraw the whole area. For example, it might not be necssary to draw the help text anymore."! !

!PluggableTextMorph methodsFor: 'updating' stamp: 'mt 7/24/2016 14:17'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	self textMorph releaseParagraph; paragraph.! !


!PluggableTextMorphPlus methodsFor: 'updating' stamp: 'mt 7/24/2016 13:21'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.

	self styler ifNotNil: [:s | 
		s reset.
		self updateStyle].! !

!PluggableTextMorphPlus methodsFor: 'drawing' stamp: 'mt 7/25/2016 11:09'!
drawBalloonTextOn: aCanvas 
	"Show balloon text in the text morph if it has no contents."
	textMorph contents ifNotEmpty: [ ^ self ].
	([ self balloonText ]
		on: Error
		do: [ : err | 'error in balloonText' ]) ifNotNil:
		[ : text | aCanvas
			drawString: text
			in: (self innerBounds insetBy: (5 @ 2 corner: 0 @ 0))
			font: (self userInterfaceTheme balloonTextFont ifNil: [TextStyle defaultFont])
			color: (self userInterfaceTheme balloonTextColor ifNil: [Color gray: 0.7]) ]! !


!ScrollPane class methodsFor: 'preferences' stamp: 'mt 7/23/2016 11:33'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the pane''s border.' }.
		{ #borderWidth. 'Borders'. 'Width of the pane''s border.' }.
		{ #borderStyle. 'Borders'. 'Whether to use a plain border, inset, or outset.' }.
		{ #color. 'Colors'. 'Background color of the pane.' }.
	}! !


!PluggableListMorph class methodsFor: 'preferences' stamp: 'mt 7/26/2016 10:14'!
themeProperties

	^ super themeProperties, {
		{ #font. 'Fonts'. 'Font of the list items.' }.
		{ #textColor. 'Colors'. 'Color of the list items.' }.
		{ #selectionColor. 'Colors'. 'Color used for items when hovering or selecting them.' }.
		{ #selectionTextColor. 'Colors'. 'Color used for label when hovering or selecting them.' }.
		{ #filterColor. 'Colors'. 'Color used for items to indicate the matching filter.' }.
		{ #filterTextColor. 'Colors'. 'Color used for items to indicate the matching filter.' }.
		
		{ #preSelectionModifier. 'Colors'. 'How to derive the pre-selection color from the selection color.'}.
		{ #hoverSelectionModifier. 'Colors'. 'How to derive the hover color from the selection color.'}.
	}! !


!PluggableTextMorph class methodsFor: 'frame adornments' stamp: 'mt 7/24/2016 14:37'!
adornmentWithColor: aColor
	"Create and return a frame adornment with the given color"

	| size box form fillStyle |
	^self adornmentCache at: aColor ifAbsentPut:[
		size := 20. 
		box := 0@0 extent: size asPoint.
		form := Form extent: size@size depth: 32.
		fillStyle := MenuMorph gradientMenu ifFalse: [SolidFillStyle color: aColor] ifTrue: [
			(GradientFillStyle ramp: {
				0.0->(aColor alpha: 0.01).
				0.8->aColor.
				1.0->aColor})
				origin: box topRight - (size@0);
				direction: (size @ size negated) // 4;
				radial: false].
		form getCanvas drawPolygon:  {
			box topRight. 
			box topRight + (0@size). 
			box topRight - (size@0)
		} fillStyle: fillStyle.
		form].
! !

!PluggableTextMorph class methodsFor: 'preferences' stamp: 'mt 7/25/2016 11:25'!
themeProperties

	^ super themeProperties, {
		{ #font. 'Fonts'. 'Font for text if not styled.' }.
		{ #textColor. 'Colors'. 'Color for text if not styled.' }.		
		{ #caretColor. 'Colors'. 'The color of the text cursor.' }.
		{ #selectionColor. 'Colors'. 'The color of the text selection.' }.
		{ #unfocusedSelectionModifier. 'Colors'. 'How to derive the text selection color if not focused.' }.
		
		{ #adornmentReadOnly. 'Color'. 'How to indicate read-only contents.' }.
		{ #adornmentRefuse. 'Color'. 'How to indicate that the model refuses to accept.' }.
		{ #adornmentConflict. 'Color'. 'How to indicate that there are editing conflicts.' }.
		{ #adornmentDiff. 'Color'. 'How to indicate that the model wants diff feedback.' }.
		{ #adornmentNormalEdit. 'Color'. 'How to indicate that there are unaccepted edits.' }.
		{ #adornmentDiffEdit. 'Color'. 'How to indicate that there are unaccepted edits in a diff view.' }.
		
		{ #wrapBorderColorModifier. 'Color'. 'How to indicate a specific wrap border.' }.
	}! !


!PluggableTextMorphPlus class methodsFor: 'preferences' stamp: 'mt 7/25/2016 11:07'!
themeProperties

	^  super themeProperties, {
		{ #stylerClass. 'Editing'. 'The styler class you want to use for syntax highlighting' }.
		{ #balloonTextColor. 'Colors'. 'Color to use when drawing the balloon text on an empty text field.' }.
		{ #balloonTextFont. 'Fonts'. 'Font to use when drawing the balloon text on an empty text field.' }.
	}! !


!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:17'!
filterColor

	^ self valueOfProperty: #filterColor ifAbsent: [Color yellow]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:15'!
filterColor: aColor

	self setProperty: #filterColor toValue: aColor.
	scroller submorphsDo: [:ea | ea setProperty: #filterColor toValue: aColor].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:16'!
filterTextColor

	^ self valueOfProperty: #filterTextColor ifAbsent: [Color black]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:15'!
filterTextColor: aColor

	self setProperty: #filterTextColor toValue: aColor.
	scroller submorphsDo: [:ea | ea setProperty: #filterTextColor toValue: aColor].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 09:54'!
font
	^ font ifNil: [TextStyle defaultFont]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 09:52'!
font: aFont
	font := aFont.
	scroller submorphsDo: [:ea | ea font: font].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:46'!
highlightTextColor

	^ self valueOfProperty: #highlightTextColor ifAbsent: [Color red]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:46'!
highlightTextColor: aColor

	self setProperty: #highlightTextColor toValue: aColor.
	scroller submorphsDo: [:ea | ea setProperty: #highlightTextColor toValue: aColor].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:19'!
hoverColor

	^ self valueOfProperty: #hoverColor ifAbsent: [Color veryLightGray]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:33'!
hoverColor: aColor

	self setProperty: #hoverColor toValue: aColor.
	scroller submorphsDo: [:ea | ea setProperty: #hoverColor toValue: aColor].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:13'!
selectionColor

	^ self valueOfProperty: #selectionColor ifAbsent: [Color blue]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:14'!
selectionColor: aColor

	self setProperty: #selectionColor toValue: aColor.
	scroller submorphsDo: [:ea | ea setProperty: #selectionColor toValue: aColor].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:17'!
selectionTextColor

	^ self valueOfProperty: #selectionTextColor ifAbsent: [Color white]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 10:14'!
selectionTextColor: aColor

	self setProperty: #selectionTextColor toValue: aColor.
	scroller submorphsDo: [:ea | ea setProperty: #selectionTextColor toValue: aColor].! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 09:54'!
textColor
	^ textColor ifNil: [Color black]! !

!SimpleHierarchicalListMorph methodsFor: 'accessing' stamp: 'mt 7/24/2016 09:53'!
textColor: aColor
	textColor := aColor.
	scroller submorphsDo: [:ea | ea color: textColor].! !

!SimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 10:37'!
drawHoverOn: aCanvas 

	self hoveredMorph ifNil: [^ self].
	PluggableListMorph highlightHoveredRow ifFalse: [^ self].
	
	aCanvas
		transformBy: scroller transform
		clippingTo: scroller innerBounds
		during: [:c | self hoveredMorph drawHoverOn: c].! !

!SimpleHierarchicalListMorph methodsFor: 'drawing' stamp: 'mt 7/24/2016 10:32'!
drawSelectionOn: aCanvas 

	self selectedMorph ifNotNil: [:m |
		aCanvas
			transformBy: scroller transform
			clippingTo: scroller innerBounds
			during: [:c | m drawSelectionOn: c] ].! !

!SimpleHierarchicalListMorph methodsFor: 'initialization' stamp: 'mt 7/24/2016 15:05'!
setDefaultParameters

	super setDefaultParameters.
	
	self
		font: (self userInterfaceTheme font ifNil: [TextStyle defaultFont]);
		textColor: (self userInterfaceTheme textColor ifNil: [Color black]).
		
	self
		selectionColor: (self userInterfaceTheme selectionColor ifNil: [Color r: 0.72 g: 0.72 b: 0.9]);
		selectionTextColor: (self userInterfaceTheme selectionTextColor ifNil: [Color black]);
		filterColor: (self userInterfaceTheme filterColor ifNil: [Color yellow paler]);
		filterTextColor: (self userInterfaceTheme filterTextColor ifNil: [Color black]);
		lineColor: (self userInterfaceTheme lineColor ifNil: [Color veryLightGray]);
		hoverColor: ((self userInterfaceTheme hoverSelectionModifier ifNil: [ [:c | c darker alpha: 0.3] ]) value: self selectionColor);
		highlightTextColor: (self userInterfaceTheme highlightTextColor ifNil: [Color red]).! !

!SimpleHierarchicalListMorph methodsFor: 'updating' stamp: 'mt 7/24/2016 10:21'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.! !

!SimpleHierarchicalListMorph methodsFor: 'private' stamp: 'mt 7/24/2016 15:06'!
addMorphsTo: morphList from: aCollection allowSorting: sortBoolean withExpandedItems: expandedItems atLevel: newIndent

	| priorMorph newCollection firstAddition |
	priorMorph := nil.
	newCollection := (sortBoolean and: [sortingSelector notNil]) ifTrue: [
		(aCollection asSortedCollection: [ :a :b | 
			(a perform: sortingSelector) <= (b perform: sortingSelector)]) asOrderedCollection
	] ifFalse: [
		aCollection
	].
	firstAddition := nil.
	newCollection do: [:item | 
		priorMorph := self indentingItemClass basicNew 
			initWithContents: item 
			prior: priorMorph 
			forList: self
			indentLevel: newIndent.
		priorMorph
			color: self textColor;
			font: self font;
			selectionColor: self selectionColor;
			selectionTextColor: self selectionTextColor;
			hoverColor: self hoverColor;
			highlightTextColor: self highlightTextColor;
			filterColor: self filterColor;
			filterTextColor: self filterTextColor.
		firstAddition ifNil: [firstAddition := priorMorph].
		morphList add: priorMorph.
		((item hasEquivalentIn: expandedItems) or: [priorMorph isExpanded]) ifTrue: [
			priorMorph isExpanded: true.
			priorMorph 
				addChildrenForList: self 
				addingTo: morphList
				withExpandedItems: expandedItems.
		].
	].
	^firstAddition
	
! !

!SimpleHierarchicalListMorph methodsFor: 'private' stamp: 'mt 7/24/2016 15:06'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean

	| priorMorph morphList newCollection |
	priorMorph := nil.
	newCollection := (sortBoolean and: [sortingSelector notNil]) ifTrue: [
		(aCollection asSortedCollection: [ :a :b | 
			(a perform: sortingSelector) <= (b perform: sortingSelector)]) asOrderedCollection
	] ifFalse: [
		aCollection
	].
	morphList := OrderedCollection new.
	newCollection do: [:item | 
		priorMorph := self indentingItemClass basicNew 
			initWithContents: item 
			prior: priorMorph 
			forList: self
			indentLevel: parentMorph indentLevel + 1.
		priorMorph
			color: self textColor;
			font: self font;
			selectionColor: self selectionColor;
			selectionTextColor: self selectionTextColor;
			hoverColor: self hoverColor;
			highlightTextColor: self highlightTextColor;
			filterColor: self filterColor;
			filterTextColor: self filterTextColor.
		morphList add: priorMorph.
	].
	scroller addAllMorphs: morphList after: parentMorph.
	^morphList
	
! !


!SimpleHierarchicalListMorph class methodsFor: 'preferences' stamp: 'mt 7/24/2016 10:49'!
themeProperties

	^ super themeProperties, {
		{ #font. 'Fonts'. 'Font of the list items.' }.
		{ #textColor. 'Colors'. 'Color of the list items.' }.
		{ #selectionColor. 'Colors'. 'Color used for items when hovering or selecting them.' }.
		{ #selectionTextColor. 'Colors'. 'Color used for label when hovering or selecting them.' }.
		
		{ #filterColor. 'Colors'. 'Color used for items to indicate the matching filter.' }.
		{ #filterTextColor. 'Colors'. 'Color used for items to indicate the matching filter.' }.
		{ #highlightTextColor. 'Colors'. 'Color used for highlighted items.' }.
		
		{ #hoverSelectionModifier. 'Colors'. 'How to derive the hover color from the selection color.'}.

		{ #lineColor. 'Colors'. 'How the lines are drawn.' }.
	}! !


!Slider methodsFor: 'initialization' stamp: 'mt 7/23/2016 12:19'!
initialize

	super initialize.

	value := 0.0.
	descending := false.
	
	self initializeSlider.
	self setDefaultParameters.! !

!Slider methodsFor: 'initialization' stamp: 'mt 7/23/2016 12:24'!
initializeSlider

	slider := RectangleMorph
		newBounds: self totalSliderArea
		color: self thumbColor.
	
	sliderShadow := RectangleMorph
		newBounds: self totalSliderArea
		color: self pagingArea color.
	
	slider on: #mouseMove send: #scrollAbsolute: to: self.
	slider on: #mouseDown send: #mouseDownInSlider: to: self.
	slider on: #mouseUp send: #mouseUpInSlider: to: self.

	self addMorphFront: sliderShadow.
	self addMorphFront: slider.

	self computeSlider.
	self hideSliderShadow.! !

!Slider methodsFor: 'initialization' stamp: 'mt 7/23/2016 16:48'!
setDefaultParameters
	"change the receiver's appareance parameters"

	self
		color: (self userInterfaceTheme color ifNil: [Color lightGray]);
		borderColor: (self userInterfaceTheme borderColor ifNil: [Color gray]);
		borderWidth: (self userInterfaceTheme borderWidth ifNil: [1]).
	
	slider
		color: (self userInterfaceTheme thumbColor ifNil: [Color veryVeryLightGray]);
		borderColor: (self userInterfaceTheme thumbBorderColor ifNil: [Color gray: 0.6]);
		borderWidth: (self userInterfaceTheme thumbBorderWidth ifNil: [0]).

	sliderShadow
		borderWidth: slider borderWidth;
		borderColor: Color transparent.

	sliderColor := slider color.
	self updateSliderColor: slider color.! !

!Slider methodsFor: 'other events' stamp: 'mt 7/23/2016 12:10'!
hideSliderShadow

	sliderShadow hide.! !

!Slider methodsFor: 'other events' stamp: 'mt 7/23/2016 12:10'!
mouseDownInSlider: event 

	slider borderStyle style == #raised
		ifTrue: [slider borderColor: #inset].
	
	self showSliderShadow.! !

!Slider methodsFor: 'other events' stamp: 'mt 7/23/2016 12:10'!
mouseUpInSlider: event 

	slider borderStyle style == #inset
		ifTrue: [slider borderColor: #raised].
	
	self hideSliderShadow.! !

!Slider methodsFor: 'other events' stamp: 'mt 7/23/2016 12:10'!
showSliderShadow

	sliderShadow color: self sliderShadowColor.
	sliderShadow cornerStyle: slider cornerStyle.
	sliderShadow bounds: slider bounds.
	sliderShadow show.! !

!Slider methodsFor: 'accessing - ui' stamp: 'mt 7/23/2016 16:28'!
adoptPaneColor: paneColor

	super adoptPaneColor: paneColor.
	paneColor ifNotNil: [:c | self sliderColor: c].! !

!Slider methodsFor: 'accessing - ui' stamp: 'mt 7/23/2016 16:24'!
sliderColor
	"color scheme for the whole slider widget"
	
	^ sliderColor ifNil: [self userInterfaceTheme thumbColor ifNil: [Color veryVeryLightGray]]! !

!Slider methodsFor: 'accessing - ui' stamp: 'mt 7/23/2016 16:14'!
sliderColor: newColor

	sliderColor := newColor.
	self updateSliderColor: sliderColor.! !

!Slider methodsFor: 'accessing - ui' stamp: 'mt 7/23/2016 16:23'!
sliderShadowColor

	^ ((self userInterfaceTheme thumbShadowModifier
			ifNil: [ [:c | c alpha: 0.7 ] ]) value: self sliderColor)! !

!Slider methodsFor: 'updating' stamp: 'mt 7/23/2016 16:21'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.
	
	self setDefaultParameters.! !

!Slider methodsFor: 'updating' stamp: 'mt 7/23/2016 16:27'!
updateSliderColor: aColor

	slider color: aColor.
	sliderShadow color: self sliderShadowColor.! !


!ScrollBar methodsFor: 'accessing' stamp: 'mt 7/23/2016 13:04'!
downButton
	^ downButton! !

!ScrollBar methodsFor: 'accessing' stamp: 'mt 7/23/2016 16:40'!
imageColor

	^ slider ifNil: [Color black] ifNotNil: [:s | s borderColor]! !

!ScrollBar methodsFor: 'accessing' stamp: 'mt 7/23/2016 13:44'!
sliderColor: aColor 
	"Change the color of the scrollbar to go with aColor."

	super sliderColor: aColor.
	self updateSliderColor: aColor.! !

!ScrollBar methodsFor: 'accessing' stamp: 'mt 7/23/2016 13:04'!
upButton
	^ upButton! !

!ScrollBar methodsFor: 'geometry' stamp: 'mt 7/27/2016 10:05'!
extent: p 

	(bounds extent closeTo: p) ifTrue: [^ self].
	
	p x > p y
		ifTrue: [super
				extent: (p max: 8 @ 4)]
		ifFalse: [super
				extent: (p max: 4 @ 8)].
			
	self updateSliderColor.
	! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/23/2016 12:21'!
initialize

	interval := 0.2.
	scrollDelta := 0.02.
	pageDelta := 0.2.
	
	super initialize.! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/23/2016 16:46'!
initializeDownButton
	"initialize the receiver's downButton"

	downButton := RectangleMorph newBounds: self boundsForDownButton.
	downButton 
		on: #mouseDown
		send: #scrollDownInit
		to: self.
	downButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateDownButtonImage.	
	self addMorphFront: downButton.
	downButton visible: self class scrollBarsWithoutArrowButtons not.! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/23/2016 16:46'!
initializeMenuButton
"initialize the receiver's menuButton"
	"Preferences disable: #scrollBarsWithoutMenuButton"
	"Preferences enable: #scrollBarsWithoutMenuButton"
	menuButton := RectangleMorph newBounds: self boundsForMenuButton.
	menuButton
		on: #mouseEnter
		send: #menuButtonMouseEnter:
		to: self.
	menuButton
		on: #mouseDown
		send: #menuButtonMouseDown:
		to: self.
	menuButton
		on: #mouseLeave
		send: #menuButtonMouseLeave:
		to: self.
	"menuButton 
	addMorphCentered: (RectangleMorph 
	newBounds: (0 @ 0 extent: 4 @ 2) 
	color: Color black)."
	self updateMenuButtonImage.
	self addMorphFront: menuButton.
	menuButton visible: (self class scrollBarsWithoutMenuButton or: [self orientation == #horizontal]) not.! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/23/2016 12:48'!
initializePagingArea
	
	"Appearance"
	pagingArea := RectangleMorph newBounds: self totalSliderArea.
	self addMorphBack: pagingArea.
			
	"Interactions"
	pagingArea
		on: #mouseDown
		send: #scrollPageInit:
		to: self.
	pagingArea
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	
! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/23/2016 12:22'!
initializeSlider

	self
		initializeMenuButton;
		initializeUpButton;
		initializeDownButton;
		initializePagingArea.
		
	super initializeSlider.
	
	self expandSlider.! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/23/2016 13:07'!
initializeUpButton
"initialize the receiver's upButton"
	upButton := RectangleMorph newBounds: self boundsForUpButton.
	upButton
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateUpButtonImage.
	self addMorph: upButton.	
	upButton visible: self class scrollBarsWithoutArrowButtons not.! !

!ScrollBar methodsFor: 'initialize' stamp: 'mt 7/25/2016 13:51'!
setDefaultParameters

	"Compared to generic sliders, I am not my own paging area. Thus, make me transparent."
	self
		color: Color transparent;
		borderWidth: 0.

	pagingArea
		color: (self userInterfaceTheme color ifNil: [Color veryVeryLightGray darker alpha: 0.35]);
		borderWidth: 0. "no border for the paging area"

	slider
		color: (self userInterfaceTheme thumbColor ifNil: [Color veryVeryLightGray]);
		borderColor: (self userInterfaceTheme thumbBorderColor ifNil: [Color gray: 0.6]);
		borderWidth: (self userInterfaceTheme thumbBorderWidth ifNil: [1]).
	
	self updateSliderCornerStyle.
	
	sliderShadow
		cornerStyle: slider cornerStyle;
		borderWidth: slider borderWidth;
		borderColor: Color transparent.
	
	sliderColor := slider color.
	self updateSliderColor: slider color.! !

!ScrollBar methodsFor: 'event handling' stamp: 'mt 7/23/2016 12:11'!
mouseDownInSlider: event

	"make the entire scrollable area visible if a full scrollbar is clicked on"
	self interval = self maximumValue ifTrue: [
		self setValue: 0.
		self model hideOrShowScrollBars].
	
	self showSliderShadow.! !

!ScrollBar methodsFor: 'scrolling' stamp: 'mt 7/23/2016 13:10'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
! !

!ScrollBar methodsFor: 'scrolling' stamp: 'mt 7/23/2016 13:13'!
scrollDownInit
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!ScrollBar methodsFor: 'scrolling' stamp: 'mt 7/23/2016 13:13'!
scrollUpInit
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!ScrollBar methodsFor: 'images' stamp: 'mt 7/23/2016 16:40'!
downImage
	"answer a form to be used in the down button"
	^ self class
		arrowOfDirection: (self orientation == #horizontal
				ifTrue: [#right]
				ifFalse: [#bottom])
		size: (self buttonExtent x min: self buttonExtent y)
		color: self imageColor! !

!ScrollBar methodsFor: 'images' stamp: 'mt 7/23/2016 16:40'!
menuImage
	"answer a form to be used in the menu button"
	^ self class
		boxOfSize: (self buttonExtent x min: self buttonExtent y)
		color: self imageColor! !

!ScrollBar methodsFor: 'images' stamp: 'mt 7/23/2016 16:40'!
upImage
	"answer a form to be used in the up button"
	^ self class
		arrowOfDirection: (self orientation == #horizontal
				ifTrue: [#left]
				ifFalse: [#top])
		size: (self buttonExtent x min: self buttonExtent y)
		color: self imageColor! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/25/2016 15:00'!
applyUserInterfaceTheme

	super applyUserInterfaceTheme.! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/23/2016 16:54'!
updateDownButtonImage
	"update the receiver's downButton.  put a new image inside"
	downButton removeAllMorphs.
	downButton addMorphCentered: (ImageMorph new image: self downImage).! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/23/2016 16:54'!
updateMenuButtonImage
	"update the receiver's menuButton. put a new image inside"

	self menuButton removeAllMorphs.
	self menuButton addMorphCentered: (ImageMorph new image: self menuImage).! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/23/2016 12:07'!
updateSlider

	| imagesNeedUpdate |
	imagesNeedUpdate := upButton width ~= (self orientation == #horizontal ifTrue: [self height] ifFalse: [self width]).
	
	self menuButton
		visible: (self orientation == #horizontal or: [self class scrollBarsWithoutMenuButton]) not;
		bounds: self boundsForMenuButton.
	upButton
		visible: self class scrollBarsWithoutArrowButtons not;
		bounds: self boundsForUpButton.
	downButton
		visible: self class scrollBarsWithoutArrowButtons not;
		bounds: self boundsForDownButton.

	super updateSlider.

	pagingArea bounds: self totalSliderArea.
	self expandSlider.

	imagesNeedUpdate ifTrue: [
		self menuButton visible ifTrue: [self updateMenuButtonImage].
		upButton visible ifTrue: [self updateUpButtonImage].
		downButton visible ifTrue: [self updateDownButtonImage]].! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/25/2016 13:41'!
updateSliderColor: aColor

	self class gradientScrollBar
		ifFalse: [self updateSliderColorSolid: aColor]
		ifTrue: [self updateSliderColorGradient: aColor].
		
	self flag: #performance. "mt: This is slow..."
	self updateMenuButtonImage.
	self updateUpButtonImage.
	self updateDownButtonImage.! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/24/2016 14:48'!
updateSliderColorGradient: aColor

	| gradient cc |
	pagingArea color: ((self userInterfaceTheme pagingAreaColorModifier
		ifNil: [ [:c | c darker alpha: 0.35] ]) value: aColor).
	slider borderColor: ((self userInterfaceTheme borderColorModifier
		ifNil: [ [:c | c adjustBrightness: -0.3] ]) value: aColor).
	
	cc := ((self userInterfaceTheme thumbColorModifier
		ifNil: [ [:c | c] ]) value: aColor).
	
	gradient := GradientFillStyle ramp: {
		0.0 -> Color white.
		0.1-> (cc adjustBrightness: 0.05).
		0.6 -> (cc darker)}.
	
	"Fill the thumb"
	gradient origin: slider topLeft.
	gradient direction: (self orientation == #horizontal
		ifTrue:[0@slider height]
		ifFalse:[slider width@0]).
	slider fillStyle: gradient.
	
	"Fill the buttons"
	{self menuButton. self upButton. self downButton} do: [:ea |
		gradient := gradient copy.
		gradient origin: ea topLeft.
		gradient direction: (self orientation == #horizontal
			ifTrue:[0@ea height]
			ifFalse:[ea width@0]).
		ea
			fillStyle: gradient;
			borderWidth: slider borderWidth;
			borderColor: slider borderColor].! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/23/2016 17:11'!
updateSliderColorSolid: aColor

	sliderShadow color: self sliderShadowColor.

	slider color: ((self userInterfaceTheme thumbColorModifier
		ifNil: [ [:c | c] ]) value: aColor).

	slider borderColor: ((self userInterfaceTheme borderColorModifier
		ifNil: [ [:c | c adjustBrightness: -0.3] ]) value: aColor).

	pagingArea color: ((self userInterfaceTheme pagingAreaColorModifier
		ifNil: [ [:c | c darker alpha: 0.35] ]) value: aColor).
		
	{self menuButton. self upButton. self downButton} do: [:ea |
		ea
			color: slider color;
			borderWidth: slider borderWidth;
			borderColor: slider borderColor].! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/25/2016 13:50'!
updateSliderCornerStyle
	"Right now, only the slider's corner style is affected. Buttons and paging area remain square. Looks better somehow... :-)"
	
	slider cornerStyle: (self class roundedScrollBarLook ifTrue: [#rounded] ifFalse: [#square]).! !

!ScrollBar methodsFor: 'updating' stamp: 'mt 7/23/2016 16:54'!
updateUpButtonImage
"update the receiver's upButton. put a new image inside"
	upButton removeAllMorphs.
	upButton addMorphCentered: (ImageMorph new image: self upImage).! !


!Slider class methodsFor: 'preferences' stamp: 'mt 7/23/2016 16:18'!
themeProperties

	^ super themeProperties, {
		{ #borderColor. 'Colors'. 'Color of the slider''s border.' }.
		{ #borderWidth. 'Borders'. 'Width of the slider''s border.' }.
		{ #color. 'Colors'. 'Background color of the slider.' }.

		{ #thumbBorderColor. 'Colors'. 'Color of the slider thumb''s border.' }.
		{ #thumbBorderWidth. 'Borders'. 'Width of the slider thumb''s border.' }.
		{ #thumbColor. 'Colors'. 'Background color of the slider thumb.' }.
		
		{ #thumbShadowModifier. 'Colors'. 'How to modify the thumb color to get the shadow color.' }.
	}! !


!ScrollBar class methodsFor: '*51Deprecated' stamp: 'mt 7/25/2016 13:41'!
updateScrollBarButtonAspect: aMorph color: aColor 
	"update aMorph with aColor"
	| fill direction |
	aMorph isNil
		ifTrue: [^ self].
	""
	aMorph color: aColor.
	self gradientScrollBar ifFalse: [^ self].
	""
	fill := GradientFillStyle ramp: {
		0.0 -> aColor twiceLighter twiceLighter.
		1.0 -> aColor twiceDarker}.
	""
	direction := ((aMorph width min: aMorph height)
				+ ((aMorph width - aMorph height) abs * 0.3)) rounded.
	""
	fill origin: aMorph topLeft + (direction // 8).
	fill direction: direction @ direction.
	fill radial: true.
	""
	aMorph fillStyle: fill! !

!ScrollBar class methodsFor: 'images' stamp: 'mt 7/23/2016 17:05'!
createArrowOfDirection: aSymbolDirection size: size color: aColor 
	"PRIVATE - create an arrow with aSymbolDirectionDirection, finalSizeInteger and aColor  
	aSymbolDirectionDirection = #top, #bottom. #left or #right  
	 ScrollBar initializeImagesCache.
	Try with: 
	(ScrollBar createArrowOfDirection: #right size: 14 color: Color lightGreen) asMorph openInHand."
	
	| form canvas vertices margin |
	form := Form extent: size asPoint depth: 32.
	canvas := form getCanvas.
	margin := size < 14 ifTrue: [2] ifFalse: [3].
	vertices := {
		size // 2 @ margin.
		size asPoint - margin asPoint.
		margin @ (size-margin).
		size // 2 @ margin}.
	
	"Preferences gradientScrollBars
		ifTrue: [
			fillStyle := GradientFillStyle ramp: {
					0.0 -> (aColor adjustBrightness: 0.5).
					0.1-> (aColor adjustBrightness: 0.05).
					0.6 -> (aColor darker)}.
			fillStyle origin: size // 2 @ margin.
			fillStyle direction: 0 @ size]
		ifFalse: [
			fillStyle := SolidFillStyle color: aColor]. "
	
	canvas
		drawPolygon: vertices
		fillStyle: (SolidFillStyle color: aColor).
	
	^ (form rotateBy: (aSymbolDirection caseOf: {
		[#top] -> [0].
		[#bottom] -> [180].
		[#left] -> [270].
		[#right] -> [90]})) clippedToSize: size asPoint! !

!ScrollBar class methodsFor: 'images' stamp: 'mt 7/23/2016 17:05'!
createBoxOfSize: anInteger color: aColor 
	"PRIVATE - create a box with anInteger and aColor  
	 
	Try with:  
	(ScrollBar createBoxOfSize: 32 color: Color gray) asMorph  
	openInHand.  
	"
	
	| form canvas margin |
	form := Form extent: anInteger asPoint depth: 32.
	canvas := form getCanvas.
	margin := anInteger < 14 ifTrue: [3] ifFalse: [4].

	"Preferences gradientScrollBars
		ifTrue: [
			fillStyle := GradientFillStyle ramp: {
					0.0 -> (aColor adjustBrightness: 0.5).
					0.1-> (aColor adjustBrightness: 0.05).
					0.6 -> (aColor darker)}.
			fillStyle origin: margin asPoint.
			fillStyle direction: anInteger @ 0]
		ifFalse: [
			fillStyle := SolidFillStyle color: aColor]. "
	
	canvas
		fillRectangle: ((0@0 extent: anInteger asPoint) insetBy: margin)
		fillStyle: (SolidFillStyle color: aColor).
		
	^ form! !

!ScrollBar class methodsFor: 'preferences' stamp: 'mt 7/25/2016 13:51'!
roundedScrollBarLook: aBoolean

	RoundedScrollBarLook = aBoolean ifTrue: [^ self].
	RoundedScrollBarLook := aBoolean.
	
	ScrollBar allSubInstancesDo: [:ea | ea updateSliderCornerStyle].! !

!ScrollBar class methodsFor: 'preferences' stamp: 'mt 7/23/2016 16:35'!
themeProperties

	^ super themeProperties, {		
		{ #pagingAreaColorModifier. 'Colors'. 'How to modify the paging area color when adopting a pane color.' }.
		{ #thumbColorModifier. 'Colors'. 'How to modify the thumb color when adopting a pane color.' }.
		{ #borderColorModifier. 'Colors'. 'How to modify the border color when adopting a pane color.' }.
	}! !


!TextMorph methodsFor: 'private' stamp: 'mt 7/24/2016 14:11'!
createParagraph

	self setProperty: #CreatingParagraph toValue: true.

	[
		self setDefaultContentsIfNil.

		"...Code here to recreate the paragraph..."
		paragraph := (self paragraphClass new textOwner: self owner).
		paragraph wantsColumnBreaks: successor notNil.
		paragraph
			compose: text
			style: textStyle copy
			from: self startingIndex
			in: self container.
		wrapFlag ifFalse:
			["Was given huge container at first... now adjust"
			paragraph adjustRightX].
		paragraph focused: (self currentHand keyboardFocus == self).
	
		self fit.
	] ensure: [self removeProperty: #CreatingParagraph].

	^ paragraph! !

!TextMorph methodsFor: 'private' stamp: 'mt 7/24/2016 14:12'!
paragraph
	"Paragraph instantiation is lazy -- create it only when needed"

	^ paragraph ifNil: [self createParagraph]! !


!TextMorphForEditView methodsFor: 'private' stamp: 'mt 7/24/2016 14:13'!
createParagraph

	super createParagraph.
	
	paragraph
		caretColor: self caretColor;
		selectionColor: self selectionColor;
		unfocusedSelectionColor: self unfocusedSelectionColor.
		
	^ paragraph! !

!TextMorphForEditView methodsFor: 'accessing' stamp: 'mt 7/24/2016 14:05'!
caretColor
	^ self valueOfProperty: #caretColor ifAbsent: [Color red]! !

!TextMorphForEditView methodsFor: 'accessing' stamp: 'mt 7/24/2016 14:06'!
selectionColor
	^ self valueOfProperty: #selectionColor ifAbsent: [Color blue muchLighter]! !

!TextMorphForEditView methodsFor: 'accessing' stamp: 'mt 7/24/2016 14:06'!
unfocusedSelectionColor
	^ self valueOfProperty: #unfocusedSelectionColor ifAbsent: [Color blue muchLighter]! !


!ScrollBar class reorganize!
('as yet unclassified' alwaysShowFlatScrollbarForAlternativeLook)
('class initialization' cleanUp createArrowImagesCache createBoxImagesCache initialize initializeImagesCache refreshAllScrollBars)
('*51Deprecated' createArrowOfDirection:in: createBoxIn: updateScrollBarButtonAspect:color: updateScrollBarButtonsAspect:color: verticesForComplexArrow: verticesForSimpleArrow:)
('images' arrowOfDirection:size:color: boxOfSize:color: changesInPreferences createArrowOfDirection:size:color: createBoxOfSize:color:)
('images - samples' arrowSamples boxSamples sampleColors sampleSizes)
('preferences' gradientScrollBar gradientScrollBar: roundedScrollBarLook roundedScrollBarLook: scrollBarsWithoutArrowButtons scrollBarsWithoutArrowButtons: scrollBarsWithoutMenuButton scrollBarsWithoutMenuButton: themeProperties)
!

ScrollBar removeSelector: #defaultBorderWidth!
ScrollBar removeSelector: #initializeEmbedded:!
ScrollBar removeSelector: #sliderShadowColor!
ScrollBar removeSelector: #thumbColor!

!ScrollBar reorganize!
('accessing' downButton imageColor interval interval: menuButton menuSelector menuSelector: pagingArea scrollDelta scrollDelta:pageDelta: sliderColor: upButton)
('geometry' boundsForDownButton boundsForMenuButton boundsForUpButton buttonExtent expandSlider extent: minHeight minThumbThickness minWidth sliderExtent sliderThickness totalSliderArea)
('initialize' initialize initializeDownButton initializeMenuButton initializePagingArea initializeSlider initializeUpButton setDefaultParameters)
('event handling' menuButtonMouseDown: mouseDownInSlider:)
('scroll timing' resetTimer waitForDelay1:delay2:)
('scrolling' doScrollByPage doScrollDown doScrollUp finishedScrolling scrollBarAction scrollBarAction: scrollDown: scrollDownInit scrollPageInit: scrollUp: scrollUpInit setNextDirectionFromEvent:)
('*51Deprecated' scrollDown scrollUp)
('stepping and presenter' step)
('images' downImage menuImage upArrow8Bit upImage)
('updating' adoptPaneColor: applyUserInterfaceTheme updateDownButtonImage updateMenuButtonImage updateSlider updateSliderColor updateSliderColor: updateSliderColorGradient: updateSliderColorSolid: updateSliderCornerStyle updateUpButtonImage)
('testing' hasButtons stepTime wantsSteps)
!

Slider removeSelector: #defaultBorderColor!
Slider removeSelector: #defaultBorderWidth!
Slider removeSelector: #defaultColor!

!Slider reorganize!
('geometry' computeSlider extent: minHeight minWidth roomToMove sliderExtent sliderThickness totalSliderArea)
('initialization' defaultBounds initialize initializeSlider on:getValue:setValue: setDefaultParameters)
('model access' getMaximumValue getMinimumValue getValue setValue:)
('other events' hideSliderShadow mouseDownInSlider: mouseUpInSlider: showSliderShadow)
('scrolling' scrollAbsolute: scrollBy: scrollToMaximum scrollToMinimum)
('accessing - ui' adoptPaneColor: pagingArea sliderColor sliderColor: sliderShadowColor thumb thumbColor)
('accessing' descending descending: maximumValue maximumValue: minimumValue minimumValue: orientation orientation: quantum quantum: truncate truncate: value value:)
('accessing - model' getMaximumValueSelector getMaximumValueSelector: getMinimumValueSelector getMinimumValueSelector: getValueSelector getValueSelector: setValueSelector setValueSelector:)
('support' setValueFraction: trimmedValue:)
('updating' applyUserInterfaceTheme update: updateSlider updateSliderColor:)
('testing' wantsSlot)
('as yet unclassified' hResizing vResizing)
!

ScrollPane subclass: #SimpleHierarchicalListMorph
	instanceVariableNames: 'selectedMorph hoveredMorph getListSelector keystrokeActionSelector autoDeselect columns columnsCache sortingSelector getSelectionSelector setSelectionSelector potentialDropMorph lineColor font textColor'
	classVariableNames: 'WrappedNavigation'
	poolDictionaries: ''
	category: 'Morphic-Explorer'!
PluggableTextMorphPlus removeSelector: #font:!
PluggableTextMorphPlus removeSelector: #setTextColor:!
PluggableListMorph removeSelector: #listItemHeight!
ScrollPane removeSelector: #defaultBorderColor!
ScrollPane removeSelector: #defaultBorderWidth!
ScrollPane removeSelector: #defaultColor!
Object subclass: #NewParagraph
	instanceVariableNames: 'text textStyle firstCharacterIndex container lines positionWhenComposed offsetToEnd maxRightX selectionStart selectionStop wantsColumnBreaks focused caretRect showCaret caretColor selectionColor unfocusedSelectionColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Text Support'!

!NewParagraph reorganize!
('access' adjustedFirstCharacterIndex caretColor caretColor: caretRect caretWidth extent firstCharacterIndex focused focused: lastCharacterIndex numberOfLines selectionColor selectionColor: showCaret showCaret: string text textOwner: textStyle textStyle: unfocusedSelectionColor unfocusedSelectionColor: wantsColumnBreaks wantsColumnBreaks:)
('alignment' centered justified leftFlush rightFlush)
('*51Deprecated' insertionPointColor)
('composition' compose:style:from:in: composeAll composeAllStartingAt: composeLinesFrom:to:delta:into:priorLines:atY: compositionRectangle fixLastWithHeight: recomposeFrom:to:delta:)
('copying' deepCopy)
('display' asParagraphForPostscript displayDumbbellCursorOn:at:in: displaySelectionInLine:on: displaySimpleCursorOn:at:in:)
('editing' attributesAt: clickAt:for:controller: replaceFrom:to:with: replaceFrom:to:with:displaying:)
('fonts-display' displayOn:using:at:)
('initialize-release' initialize)
('selection' characterBlockAtPoint: characterBlockForIndex: containsPoint: defaultCharacterBlock selectionRects selectionRectsFrom:to: selectionStart:selectionStop:)
('private' adjustLineIndicesBy: adjustRightX fastFindFirstLineSuchThat: indentationOfLineIndex:ifBlank: lastLine lineIndexForCharacter: lineIndexForPoint: lineIndexOfCharacterIndex: lines moveBy: positionWhenComposed: textStyle:lines:text:)
!

ListItemWrapper removeSelector: #highlightingColor!
LazyListMorph removeSelector: #drawBackgroundForPotentialDrop:on:!
"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

ScrollBar initializeImagesCache.
LazyListMorph allSubInstancesDo: [:ea | ea resetFilterOffsets].
PluggableTextMorph flushAdornmentCache.
!

