'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:22 pm'!

!MenuMorph class methodsFor: 'preferences' stamp: 'mt 7/25/2016 14:12'!
gradientMenu: aBoolean

	GradientMenu = aBoolean ifTrue: [^ self].
	GradientMenu := aBoolean.

	self flag: #refactor. "mt: Heavy use of the gradient-menu property..."
	
	SystemProgressMorph reset.
	PluggableTextMorph flushAdornmentCache.

	MenuMorph allSubInstancesDo: [:ea | ea setDefaultParameters; setTitleParameters; updateColor].
	DockingBarMorph allSubInstancesDo: [:ea | ea setDefaultParameters; updateColor].

	TheWorldMainDockingBar updateInstances.
	PluggableListMorph allSubInstancesDo: [:ea | ea setListParameters].
	! !


!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/2/2016 11:06'!
editCurrentTheme

	UserInterfaceTheme current explore.! !

!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/2/2016 10:38'!
extrasMenuOn: aDockingBar 

	aDockingBar addItem: [ :it|
		it 	contents: 'Extras' translated;
			addSubMenu: [:menu|
				menu addItem:[:item|
					item
						contents: 'Recover Changes' translated;
						help: 'Recover changes after a crash' translated;
						icon: MenuIcons smallDocumentClockIcon;
						target: ChangeList;
						selector: #browseRecentLog].
				menu addLine.
				menu addItem:[:item|
					item
						contents: 'Themes & Colors' translated;
						subMenuUpdater: self
						selector: #themesAndWindowColorsOn: ].
				menu addItem:[:item|
					item
						contents: 'Set Author Initials' translated;
						help: 'Sets the author initials' translated;
						icon: MenuIcons smallUserQuestionIcon;
						target: Utilities;
						selector: #setAuthorInitials].
				menu addItem:[:item|
					item
						contents: 'Restore Display (r)' translated;
						help: 'Redraws the entire display' translated;
						target: Project current;
						selector: #restoreDisplay].
				menu addItem:[:item|
					item
						contents: 'Rebuild Menus' translated;
						help: 'Rebuilds the menu bar' translated;
						target: TheWorldMainDockingBar;
						selector: #updateInstances].
				menu addLine.
				menu addItem:[:item|
					item
						contents: 'Start Profiler' translated;
						help: 'Starts the profiler' translated;
						icon: MenuIcons smallTimerIcon;
						target: self;
						selector: #startMessageTally].
				menu addItem:[:item|
					item
						contents: 'Collect Garbage' translated;
						help: 'Run the garbage collector and report space usage' translated;
						target: Utilities;
						selector: #garbageCollectAndReport].
				menu addItem:[:item|
					item
						contents: 'Purge Undo Records' translated;
						help: 'Save space by removing all the undo information remembered in all projects' translated;
						target: CommandHistory;
						selector: #resetAllHistory].
				menu addItem:[:item|
					item
						contents: 'VM statistics' translated;
						help: 'Virtual Machine information' translated;
						target: self;
						selector: #vmStatistics].
				menu addLine.
				menu addItem:[:item|
					item
						contents: 'Graphical Imports' translated;
						help: 'View the global repository called ImageImports; you can easily import external graphics into ImageImports via the FileList' translated;
						target: (Imports default);
						selector: #viewImages].
				menu addItem:[:item|
					item
						contents: 'Standard Graphics Library' translated;
						help: 'Lets you view and change the system''s standard library of graphics' translated;
						target: ScriptingSystem;
						selector: #inspectFormDictionary].
				menu addItem:[:item|
					item
						contents: 'Annotation Setup' translated;
						help: 'Click here to get a little window that will allow you to specify which types of annotations, in which order, you wish to see in the annotation panes of browsers and other tools' translated;
						target: Preferences;
						selector: #editAnnotations].
				menu addItem:[:item|
					item
						contents: 'Browse My Changes' translated;
						help: 'Browse all of my changes since the last time #condenseSources was run.' translated;
						target: SystemNavigation new;
						selector: #browseMyChanges].
			] ]! !

!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/25/2016 14:23'!
themesAndWindowColorsOn: menu

	| themes |
	themes := UserInterfaceTheme allThemes asArray sortBy: [:t1 :t2 |
		t1 name <= t2 name].
	
	menu addItem:[:item|
		item
			contents: (Model useColorfulWindows ifTrue: ['<yes>'] ifFalse: ['<no>']), 'Colorful Windows' translated;
			target: self;
			selector: #toggleColorfulWindows].
	menu addItem:[:item|
		item
			contents: (SystemWindow gradientWindow not ifTrue: ['<yes>'] ifFalse: ['<no>']), 'Flat Widget Look' translated;
			target: self;
			selector: #toggleGradients].
	menu addItem:[:item |
		item
			contents: ((Preferences valueOfFlag: #menuAppearance3d) ifTrue: ['<yes>'] ifFalse: ['<no>']), 'Shadows' translated;
			target: self;
			selector: #toggleShadows].
	menu addItem:[:item |
		item
			contents: (SystemWindow roundedWindowCorners ifTrue: ['<yes>'] ifFalse: ['<no>']), 'Rounded Widget Look' translated;
			target: self;
			selector: #toggleRoundedLook].

	
	menu addLine.
	
	themes ifEmpty: [ 
		menu addItem: [ :item | 
			item
				contents: '(No UI themes found.)' translated;
				isEnabled: false ] ].
	themes do: [ :each |
		menu addItem: [ :item |
			item 
				contents: (UserInterfaceTheme current == each ifTrue: ['<yes>'] ifFalse: ['<no>']), each name;
				target: each;
				selector: #apply ] ].
	menu
		addLine;
		add: 'Edit Current UI Theme...' target: self selector: #editCurrentTheme.! !

!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/24/2016 09:31'!
toggleColorfulWindows

	Model useColorfulWindows: Model useColorfulWindows not.! !

!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/25/2016 14:41'!
toggleGradients

	| switch |
	switch := SystemWindow gradientWindow not.
	
	SystemWindow gradientWindow: switch.
	DialogWindow gradientDialog: switch.
	MenuMorph gradientMenu: switch.
	ScrollBar gradientScrollBar: switch.
	PluggableButtonMorph gradientButton: switch.! !

!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/25/2016 14:28'!
toggleRoundedLook

	| switch |
	switch := SystemWindow roundedWindowCorners not.
	
	SystemWindow roundedWindowCorners: switch.
	DialogWindow roundedDialogCorners: switch.
	PluggableButtonMorph roundedButtonCorners: switch.
	MenuMorph roundedMenuCorners: switch.
	ScrollBar roundedScrollBarLook: switch.! !

!TheWorldMainDockingBar methodsFor: 'submenu - extras' stamp: 'mt 7/27/2016 09:53'!
toggleShadows

	Preferences toggle: #menuAppearance3d.! !

TheWorldMainDockingBar removeSelector: #windowColorsOn:!
Preferences class removeSelector: #gradientScrollBars!
"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

"The menu for window colors and themes changes."
TheWorldMainDockingBar updateInstances.!

