'From Squeak5.1 of 23 July 2016 [latest update: #16138] on 28 July 2016 at 2:37:21 pm'!

!Morph methodsFor: 'drawing' stamp: 'mt 7/25/2016 16:02'!
drawKeyboardFocusIndicationOn: aCanvas

	self wantsRoundedCorners
		ifTrue: [aCanvas frameRoundRect: self bounds radius: self cornerRadius width: self keyboardFocusWidth color: self keyboardFocusColor]
		ifFalse: [aCanvas frameRectangle: self bounds width: self keyboardFocusWidth color: self keyboardFocusColor].! !

!Morph methodsFor: 'drawing' stamp: 'mt 7/25/2016 16:01'!
keyboardFocusColor

	^ self userInterfaceTheme keyboardFocusColor ifNil: [TranslucentColor r: 0.3 g: 0.5 b: 0.5 alpha: 0.5]! !

!Morph methodsFor: 'drawing' stamp: 'mt 7/25/2016 16:01'!
keyboardFocusWidth

	^ self userInterfaceTheme keyboardFocusWidth ifNil: [3]! !

!Morph methodsFor: 'drop shadows' stamp: 'mt 7/1/2016 16:33'!
addDropShadow

	self
		hasDropShadow: true;
		shadowOffset: (self userInterfaceTheme shadowOffset ifNil: [3@3]);
		shadowColor: (self userInterfaceTheme shadowColor ifNil: [Color black alpha: 0.5]).! !

!Morph methodsFor: 'updating' stamp: 'mt 7/1/2016 17:39'!
applyUserInterfaceTheme

	"Re-initialize the shadow. Ensure shadow cache invalidation."
	self hasDropShadow ifTrue: [
		self addDropShadow.
		self removeProperty: #dropShadow.
		self changed].! !


!Morph class methodsFor: 'preferences' stamp: 'mt 7/25/2016 16:01'!
themeProperties
	
	| catName |
	catName := 'Other'.
	
	^{ 
		{ #shadowColor. catName.  'The color of shadows. An alpha less than 0.05 is recommended.' }.
		{ #shadowOffset. catName. 'The offset of the shadows behind the morph.' } .
		{ #keyboardFocusColor. catName. 'The color of the keyboard focus indication.' }.
		{ #keyboardFocusWidth. catName. 'The width of the keyboard focus indication.' }.
	}! !

!Morph class methodsFor: 'preferences' stamp: 'mt 7/25/2016 15:57'!
useSoftDropShadow: aBoolean

	UseSoftDropShadow = aBoolean ifTrue: [^ self].
	UseSoftDropShadow := aBoolean.
	
	aBoolean
		ifTrue: [
			UserInterfaceTheme current
				set: #shadowOffset for: Morph to: (10@8 corner: 10@12);
				set: #shadowColor for: Morph to: (Color black alpha: 0.01).
			UserInterfaceTheme current
				clear: #shadowOffset for: SystemWindow;
				clear: #shadowColor for: SystemWindow.
			UserInterfaceTheme current
				clear: #shadowOffset for: MenuMorph;
				clear: #shadowColor for: MenuMorph.
			UserInterfaceTheme current
				clear: #shadowOffset for: SystemProgressMorph;
				clear: #shadowColor for: SystemProgressMorph.
			UserInterfaceTheme current
				clear: #shadowOffset for: DialogWindow;
				clear: #shadowColor for: DialogWindow]
		ifFalse: [
			UserInterfaceTheme current
				set: #shadowOffset for: Morph to: 3@3;
				set: #shadowColor for: Morph to: (Color black alpha: 0.5).
			UserInterfaceTheme current
				set: #shadowOffset for: SystemWindow to: 1@1;
				set: #shadowColor for: SystemWindow to: (Color black alpha: 0.333).
			UserInterfaceTheme current
				set: #shadowOffset for: MenuMorph to: 1@1;
				set: #shadowColor for: MenuMorph to: (Color black alpha: 0.666).
			UserInterfaceTheme current
				set: #shadowOffset for: SystemProgressMorph to: 1@1;
				set: #shadowColor for: SystemProgressMorph to: (Color black alpha: 0.666).
			UserInterfaceTheme current
				set: #shadowOffset for: DialogWindow to: 1@1;
				set: #shadowColor for: DialogWindow to: (Color black alpha: 0.666)].
	
	SystemWindow refreshAllWindows.
	DialogWindow refreshAllDialogs.
	SystemProgressMorph reset.
	TheWorldMainDockingBar updateInstances.! !


!UserInterfaceTheme class methodsFor: 'tools' stamp: 'mt 7/26/2016 13:13'!
fixShadow

	self flag: #refactor.
	(Smalltalk classNamed: 'Morph') ifNotNil: [:cls |
		cls useSoftDropShadow: cls useSoftDropShadow not.
		cls useSoftDropShadow: cls useSoftDropShadow not].! !

"Postscript:
Leave the line above, and replace the rest of this comment by a useful one.
Executable statements should follow this comment, and should
be separated by periods, with no exclamation points (!!).
Be sure to put any further comments in double-quotes, like this one."

"Update shadow caches."
Morph useSoftDropShadow: Morph useSoftDropShadow not.
Morph useSoftDropShadow: Morph useSoftDropShadow not.!

